2007-02-13  Release Manager

	* GCC 4.1.2 released.

2007-02-10  Bernhard Fischer  <aldot@gcc.gnu.org>

	Backport from trunk
	PR fortran/24783
	* resolve.c (resolve_variable): Get the implicit type from the
	symbols namespace rather than the default namespace. Fix whitespace.
	(resolve_formal_arglist, resolve_equivalence): Fix typo.

2007-01-27  Steven Bosscher  <stevenb.gcc@gmail.com>
            Steven G. Kargl <kargl@gcc.gnu.org>

	PR fortran/30278
	* fortran/io.c (next_char): Deal with backslash escaped characters.
	Issue warnings in non -std=gnu cases.
	* fortran/primary.c (next_string_char): Issue warnings in non

2007-01-24  Roger Sayle  <roger@eyesopen.com>

	* trans-intrinsic.c (gfc_conv_intrinsic_sign): Call gfc_evaluate_now
	to prevent re-evaluation of first operand.

2006-12-25  Jerry DeLisle  <jvdelisle@gcc.gnu.org>

	PR fortran/30200
	* trans-io.c (build_dt): Move post block for format_expr to end.

2006-12-13  Steven G. Kargl  <kargl@gcc.gnu.org>

	Revert Paul Thomas' commit from 2006-12-09

2006-12-09  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/29821
	* resolve.c (resolve_operator): Only return result of
	gfc_simplify_expr if expression is constant.

	PR fortran/29912
	* trans-expr.c (gfc_trans_arrayfunc_assign): Return NULL if the
	lhs and rhs character lengths are not constant and equal for
	character array valued functions.

	PR fortran/29916
	* resolve.c (resolve_symbol): Allow host-associated variables
	in the specification expression of an array-valued function.
	* expr.c (check_restricted): Accept host-associated dummy
	array indices.

	PR fortran/30003
	* trans-array.c (gfc_trans_create_temp_array): Set the section
	ends to zero.
	(gfc_conv_section_startstride): Declare an expression for end,
	set it from a the array reference and evaluate it for the info
	structure. Zero the ends in the ss structure and set end, used
	in the bounds check, from the info structure.
	trans.h: Add and end array to the gfc_ss_info structure.

	PR fortran/29820
	* trans-array.c (gfc_get_derived_type): Once done, spread the
	backend_decl to all identical derived types in all sibling
	namespaces.

2006-11-26  Andrew Pinski  <pinskia@gmail.com>

	PR fortran/29982
	* trans-expr.c (gfc_conv_expr_reference): Strip off NOP_EXPRs.

2006-11-24  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/29391
	PR fortran/29489
	* simplify.c (simplify_bound): Fix the simplification of
	LBOUND/UBOUND intrinsics.
	* trans-intrinsic.c (simplify_bound): Fix the logic, and
	remove an erroneous assert.

2006-11-24  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/29391
	* trans-intrinsic.c (gfc_conv_intrinsic_bound): Generate correct
	code for LBOUND and UBOUND intrinsics.

2006-11-11  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/29713
	* expr.c (gfc_simplify_expr): Correct memory allocation.

2006-11-10 Paul Thomas <pault@gcc.gnu.org>

	Backport from mainline.

	PR fortran/29371
	* trans-expr.c (gfc_trans_pointer_assignment): Add the expression
	for the assignment of null to the data field to se->pre, rather
	than block.

	PR fortran/29392
	* data.c (create_character_intializer): Copy and simplify
	the expressions for the start and end of a sub-string
	reference.

	PR fortran/29216
	PR fortran/29314
	* gfortran.h : Add EXEC_INIT_ASSIGN.
	* dump-parse-tree.c (gfc_show_code_node): The same.
	* trans-expr.c (gfc_trans_init_assign): New function.
	* trans-stmt.h : Add prototype for gfc_trans_init_assign.
	* trans.c (gfc_trans_code): Implement EXEC_INIT_ASSIGN.
	* resolve.c (resolve_allocate_exp): Replace EXEC_ASSIGN by
	EXEC_INIT_ASSIGN.
	(resolve_code): EXEC_INIT_ASSIGN does not need resolution.
	(apply_default_init): New function.
	(resolve_symbol): Call it for derived types that become
	defined but which do not already have an initialization
	expression..
	* st.c (gfc_free_statement): Include EXEC_INIT_ASSIGN.
	
	PR fortran/29387
	* trans-intrinsic.c (gfc_conv_intrinsic_len): Rearrange to have
	a specific case for EXPR_VARIABLE and, in default, build an ss
	to call gfc_conv_expr_descriptor for array expressions..

	PR fortran/29490
	* trans-expr.c (gfc_set_interface_mapping_bounds): In the case
	that GFC_TYPE_ARRAY_LBOUND is not available, use descriptor
	values for it and GFC_TYPE_ARRAY_UBOUND.

	PR fortran/29641
	* trans-types.c (gfc_get_derived_type): If the derived type
	namespace has neither a parent nor a proc_name, set NULL for
	the search namespace.

	PR fortran/24518
	* trans-intrinsic.c (gfc_conv_intrinsic_mod): Use built_in fmod
	for both MOD and MODULO, if it is available.

	PR fortran/29565
	* trans-expr.c (gfc_conv_aliased_arg): For an INTENT(OUT), save
	the declarations from the unused loops by merging the block
	scope for each; this ensures that the temporary is declared.

2006-11-08  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/29630
	PR fortran/29679
	* expr.c (find_array_section): Support vector subscripts.  Don't
	add sizes for dimen_type == DIMEN_ELEMENT to the shape array.

2006-11-06  Paul Thomas  <pault@gcc.gnu.org>

	Backport from mainline.

	PR fortran/29373
	* decl.c (get_proc_name, gfc_match_function_decl): Add
	attr.implicit_type to conditions that throw error for
	existing explicit interface and that allow new type-
	spec to be applied.

	PR fortran/29407
	* resolve.c (resolve_fl_namelist): Do not check for
	namelist/procedure conflict, if the symbol corresponds
	to a good local variable declaration.

	PR fortran/27701
	* decl.c (get_proc_name): Replace the detection of a declared
	procedure by the presence of a formal argument list by the
	attributes of the symbol and the presence of an explicit
	interface.

	PR fortran/29232
	* resolve.c (resolve_fl_variable): See if the host association
	of a derived type is blocked by the presence of another type I
	object in the current namespace.

	PR fortran/29364
	* resolve.c (resolve_fl_derived): Check for the presence of
	the derived type for a derived type component.

	PR fortran/24398
	* module.c (gfc_use_module): Check that the first words in a
	module file are 'GFORTRAN module'.

	PR fortran/29115
	* resolve.c (resolve_structure_cons): It is an error if the
	pointer component elements of a derived type constructor are
	not pointer or target.

	PR fortran/29211
	* trans-stmt.c (generate_loop_for_temp_to_lhs,
	generate_loop_for_rhs_to_temp): Provide a string length for
	the temporary by copying that of the other side of the scalar
	assignment.

	PR fortran/29098
	* resolve.c (resolve_structure_cons): Do not return FAILURE if
	component expression is NULL.

2006-11-03  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/29067
	* decl.c (gfc_set_constant_character_len): NULL-terminate the
	character constant string.
	* data.c (create_character_intializer): Likewise.
	* expr.c (gfc_simplify_expr): NULL-terminate the substring
	character constant.
	* primary.c (match_hollerith_constant): NULL-terminate the
	character constant string.

2006-10-24  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/29393
	* expr.c (simplify_parameter_variable): Keep rank of original
	expression.

2006-10-24  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/29284
	PR fortran/29321
	PR fortran/29322
	* trans-expr.c (gfc_conv_function_call): Check the expression
	and the formal symbol are present when testing the actual
	argument.

	PR fortran/25091
	PR fortran/25092
	* resolve.c (resolve_entries): It is an error if the entries
	of an array-valued function do not have the same shape.

2006-10-16  Steven G. Kargl  <kargl@gcc.gnu.org>

	PR fortran/29403
	* io.c (match_io):  Check for a default-char-expr for PRINT format.

2006-10-06  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/28415
	* trans-decl.c (gfc_finish_var_decl): With -fno-automatic, don't
	make artificial variables or pointer to variable automatic array
	TREE_STATIC.

2006-09-19 Paul Thomas <pault@gcc.gnu.org>
	   Steven Bosscher  <steven@gcc.gnu.org>

	PR fortran/29101
	* trans-stmt.c (gfc_trans_character_select): Store the label
	from select_string and then clean up any temporaries from the
	conversion of the select expression, before branching to the
	selected case.

2006-09-18 Paul Thomas <pault@gcc.gnu.org>

	PR fortran/28526
	* primary.c (match_variable): If the compiler is in a module
	specification block, an interface block or a contains section,
	reset host_flag to force the changed symbols mechanism.

	PR fortran/29101
	* trans-stmt.c (gfc_trans_character_select): Add the post block
	for the expression to the main block, after the call to
	select_string and the last label.

2006-09-18  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/29060
	* iresolve.c (resolve_spread): Build shape for result if the
	source shape is available and dim and ncopies are constants.

2006-09-18  Tobias Schlüter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/28817
	PR fortran/21918
	* trans-decl.c (generate_local_decl): Change from 'warning' to
	'gfc_warning' to have line numbers correctly reported.

2006-09-15  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/29051
	* decl.c (match_old_style_init): Set the 'where' field of the
	gfc_data structure 'newdata'.

	* match.c (match_case_eos): Add a comprehensible error message.

2006-09-12  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28890
	trans-expr.c (gfc_conv_function_call): Obtain the string length
	of a dummy character(*) function from the symbol if it is not
	already translated.  For a call to a character(*) function, use
	the passed, hidden string length argument, which is available
	from the backend_decl of the formal argument.
	resolve.c (resolve_function): It is an error if a function call
	to a character(*) function is other than a dummy procedure or
	an intrinsic.

2006-09-10  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28923
	expr.c (find_array_section): Only use the array lower and upper
	bounds for the start and end of the sections, where the expr is
	NULL.

	PR fortran/28959
	trans-types.c (gfc_get_derived_type): Use the parent namespace of
	the procedure if the type's own namespace does not have a parent.

2006-09-05 Paul Thomas <pault@gcc.gnu.org>

	PR fortran/28908
	* gfortran.h : Restore the gfc_dt_list structure and reference
	to it in gfc_namespace.
	* resolve.c (resolve_fl_derived): Restore the building of the
	list of derived types for the current namespace. Modify the
	restored code so that a check is made to see if the symbol is
	already in the list.
	(resolve_fntype): Make sure that the specification block
	version of the derived type is used for a module function that
	returns that type. 
	* symbol.c (gfc_free_dt_list): Restore.
	(gfc_free_namespace): Restore call to previous.
	* trans-types.c (copy_dt_decls_ifequal): Restore.
	(gfc_get_derived_type): Restore all the paraphenalia for
	association of derived types, including calls to previous.
	Modify the restored code such that all derived types are built
	if their symbols are found in the parent namespace; not just
	non-module types.  Add backend_decls to like derived types in
	sibling namespaces, as well as that of the derived type.

2006-08-30  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28885
	* trans-expr.c (gfc_conv_aliased_arg): Ensure that the temp
	declaration is retained for INTENT(OUT) arguments.

	PR fortran/28873
	PR fortran/20067
	* resolve.c (resolve_generic_f): Make error message more
	comprehensible.
	(resolve_generic_s): Restructure search for specific procedures
	to be similar to resolve_generic_f and change to similar error
	message.  Ensure that symbol reference is refreshed, in case
	the search produces a NULL.
	(resolve_specific_s): Restructure search, as above and as
	resolve_specific_f. Ensure that symbol reference is refreshed,
	in case the search produces a NULL.

	PR fortran/25077
	PR fortran/25102
	* interface.c (check_operator_interface): Throw error if the
	interface assignment tries to change intrinsic type assigments
	or has less than two arguments.  Also, it is an error if an
	interface operator contains an alternate return.

	PR fortran/24866
	* parse.c (gfc_fixup_sibling_symbols): Do not modify the symbol
	if it is a dummy in the contained namespace.

2006-08-29  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28788
	* symbol.c (gfc_use_derived): Never eliminate the symbol,
	following reassociation of use associated derived types.

2006-08-24  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28788
	* symbol.c (shift_types): Shift the derived type references in
	formal namespaces.
	(gfc_use_derived): Return if the derived type symbol is already
	in another namspace.  Add searches for the derived type in
	sibling namespaces.

	PR fortran/28771
	* decl.c (add_init_expr_to_sym): Restore the original but
	restricted to parameter arrays to fix a regression.

2006-08-23  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28788
	* gfortran.dg/used_types_4.f90: New test.
	* gfortran.dg/derived_init_2.f90: Modify to check sibling
	association of derived types.
	* gfortran.dg/used_types_2.f90: Add module cleanup.
	* gfortran.dg/used_types_3.f90: The same.

	PR fortran/28771
	* gfortran.dg/assumed_charlen_in_main.f90: Modify to check
	fix of regression.

2006-08-20  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28601
	PR fortran/28630
	* gfortran.h : Eliminate gfc_dt_list structure and reference
	to it in gfc_namespace.
	* resolve.c (resolve_fl_derived): Remove the building of the
	list of derived types for the current namespace.
	* symbol.c (find_renamed_type): New function to find renamed
	derived types by symbol name rather than symtree name.
	(gfc_use_derived): Search parent namespace for identical
	derived type and use it, even if local version is complete,
	except in interface bodies. Ensure that renamed derived types
	are found by call to find_renamed_type. Recurse for derived
	type components.
	(gfc_free_dt_list): Remove.
	(gfc_free_namespace): Remove call to previous.
	* trans-types.c (copy_dt_decls_ifequal): Remove.
	(gfc_get_derived_type): Remove all the paraphenalia for
	association of derived types, including calls to previous.
	* match.c (gfc_match_allocate): Call gfc_use_derived to
	associate any derived types that are being allocated.

	PR fortran/20886
	* resolve.c (resolve_actual_arglist): The passing of
	a generic procedure name as an actual argument is an
	error.

	PR fortran/28735
	* resolve.c (resolve_variable): Check for a symtree before
	resolving references.

	PR fortran/28762
	* primary.c (match_variable): Return MATCH_NO if the symbol
	is that of the program.

	PR fortran/28425
	* trans-expr.c (gfc_trans_subcomponent_assign): Translate
	derived type component expressions other than another derived
	type constructor.

	PR fortran/28496
	* expr.c (find_array_section): Correct errors in
	the handling of a missing start value for the
	index triplet in an array reference.

	PR fortran/18111
	* trans-decl.c (gfc_build_dummy_array_decl): Before resetting
	reference to backend_decl, set it DECL_ARTIFICIAL.
	(gfc_get_symbol_decl): Likewise for original dummy decl, when
	a copy is made of an array.
	(create_function_arglist): Likewise for the _entry paramter
	in entry_masters.
	(build_entry_thunks): Likewise for dummies in entry thunks.

	PR fortran/28771
	* decl.c (add_init_expr_to_sym): Remove setting of charlen for
	an initializer of an assumed charlen variable.

	PR fortran/28660
	* trans-decl.c (generate_expr_decls): New function.
	(generate_dependency_declarations): New function.
	(generate_local_decl): Call previous if not either a dummy or
	a declaration in an entry master.

2006-08-19  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/25217
	* resolve.c (resolve_fl_variable): Set a default initializer for
	derived types with INTENT(OUT) even if 'flag' is true.
	* trans-expr.c (gfc_conv_function_call): Insert code to
	reinitialize INTENT(OUT) arguments of derived type with default
	initializers.

2006-08-15  Jerry DeLisle  <jvdelisle@gcc.gnu.org>

	PR fortran/25828
	* gfortran.h: Add new pointer for stream position to st_inquire.
	Rename gfc_large_io_int_kind to gfc_intio_kind.
	* trans-types.c (gfc_init_kinds): use gfc_intio_kind.
	* io.c: Add new IO tag for file position going in and another for out.
	(match_dt_element): Match new tag_spos.
	(gfc_resolve_dt): Resolve new tag_spos.
	(gfc_free_inquire): Free inquire->strm_pos.
	(match_inquire_element): Match new tag_strm_out.
	(gfc_resolve_inquire): Resolve new tag_strm_out.
	* trans-io.c: Rename IOPARM_type_large_io_int to IOPARM_type_intio.
	(gfc_build_st_parameter): Same.
	(gfc_build_io_library_fndecls) Same. and add build pointer type pintio.
	(gfc_trans_inquire): Translate strm_pos for inquire.
	* ioparm.def: Reorder flags to accomodate addition of new inquire
	flag for strm_pos_out and add it in.2006-08-20  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/25217
	* resolve.c (resolve_fl_variable): Set a default initializer for
	derived types with INTENT(OUT) even if 'flag' is true.
	* trans-expr.c (gfc_conv_function_call): Insert code to
	reinitialize INTENT(OUT) arguments of derived type with default
	initializers.

2006-08-14  Asher Langton  <langton2@llnl.gov>

        * decl.c (match_old_style_init): Add data attribute to symbol.

2006-08-06  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28590
	* parse.c (parse_derived): Remove the test for sequence type
	components of a sequence type.
	* resolve.c (resolve_fl_derived): Put the test here so that
	pointer components are tested.

2006-08-05  Steven G. Kargl <kargls@comcast.nt>

	PR fortran/28548
	* resolve.c(resolve_elemental_actual): Add flags.h to use -pedantic
	and exclude conversion functions in conditional.  Change gfc_error
	to gfc_warning.
	(warn_unused_label) Rename to ...
	(warn_unused_fortran_label) avoid warn_unused_label in flags.h.

	PR fortran/27981
	* match.c (gfc_match_if):  Handle errors in assignment in simple if.

2006-07-26  Francois-Xavier Coudert  <coudert@clipper.ens.fr>
	    Daniel Franke  <franke.daniel@gmail.com>

	* intrinsic.c (add_subroutines): Add ITIME and IDATE.
	* intrinsic.h (gfc_check_itime_idate,gfc_resolve_idate,
	fc_resolve_itime): New protos.
	* iresolve.c (gfc_resolve_itime, gfc_resolve_idate): New functions.
	* check.c (gfc_check_itime_idate): New function.
	* intrinsic.texi: Document the new intrinsics.

2006-07-25  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/28439
	*trans-stmt.c (gfc_trans_arithmetic_if):  Evaluate the condition once.

2006-07-24  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/28129
	* trans-array.c (gfc_trans_array_bound_check): Add a locus
	argument, and use it in the error messages.
	(gfc_conv_array_index_offset): Donc perform bounds checking on
	the last dimension of assumed-size arrays.

2006-07-24  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/27874
	* trans-stmt.c (compute_inner_temp_size): Don't perform bounds
	checking when calculating the bounds of scalarization.

2006-07-24  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/20892
	* interface.c (gfc_match_interface): Don't allow dummy procedures
	to have a generic interface.

2006-07-16  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28384
	* trans-common.c (translate_common): If common_segment is NULL
	emit error that common block does not exist.

	PR fortran/20844
	* io.c (check_io_constraints): It is an error if an ADVANCE
	specifier appears without an explicit format.

	PR fortran/28201
	* resolve.c (resolve_generic_s): For a use_associated function,
	do not search for an alternative symbol in the parent name
	space.

	PR fortran/20893
	* resolve.c (resolve_elemental_actual): New function t combine
	all the checks of elemental procedure actual arguments. In
	addition, check of array valued optional args(this PR) has
	been added.
	(resolve_function, resolve_call): Remove parts that treated
	elemental procedure actual arguments and call the above.

	PR fortran/28353
	* trans-expr.c (gfc_conv_aliased_arg): Missing formal arg means
	that intent is INOUT (fixes regression).

	PR fortran/25097
	* check.c (check_present): The only permitted reference is a
	full array reference.

	PR fortran/20903
	* decl.c (variable_decl): Add error if a derived type is not
	from the current namespace if the namespace is an interface
	body.

2006-07-16  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/27980
	Backport from mainline
	* trans-array.h (gfc_trans_allocate_temp_array):  Add bool
	argument.
	* trans-array.c (gfc_trans_allocate_temp_array): Add extra
	argument "function" to show if we are translating a function.
	If we are translating a function, perform checks whether
	the size along any argument is negative.  In that case,
	allocate size 0.
	(gfc_trans_array_constructor):  Add funciton argument (as
	false) to gfc_trans_allocate_temp_array.
	(gfc_conv_loop_setup):  Likewise.
	* trans-expr.c (gfc_trans_function_call): Add funciton
	argument (as true) to gfc_trans_allocate_temp_array.
	* trans-stmt.c (gfc_conv_elemental_dependencies): Add funciton
	argument (as false) to gfc_trans_allocate_temp_array.
	* trans-intrinsic.c (gfc_conv_intrinsic_array_transfer):
	Likewise.

2006-07-11  Feng Wang  <fengwang@nudt.edu.cn>

	PR fortran/28213
	* trans-io.c (transfer_expr): Deal with Hollerith constants used in
	I/O list.

2006-07-07  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28237
	PR fortran/23420
	* io.c (resolve_tag): Any integer that is not an assigned
	variable is an error.

2006-07-06  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28174
	* trans-array.c (gfc_conv_expr_descriptor): When building temp,
	ensure that the substring reference uses a new charlen.
	* trans-expr.c (gfc_conv_aliased_arg): Add the formal intent to
	the argument list, lift the treatment of missing string lengths
	from the above and implement the use of the intent.
	(gfc_conv_function_call): Add the extra argument to the call to
	the above.

	PR fortran/28167
	* trans-array.c (get_array_ctor_var_strlen): Treat a constant
	substring reference.
	* array.c (gfc_resolve_character_array_constructor): Remove 
	static attribute and add the gfc_ prefix, make use of element
	charlens for the expression and pick up constant string lengths
	for expressions that are not themselves constant.
	* gfortran.h : resolve_character_array_constructor prototype
	added.
	* resolve.c (gfc_resolve_expr): Call resolve_character_array_
	constructor again after expanding the constructor, to ensure
	that the character length is passed to the expression.

2006-07-03  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* iresolve.c (gfc_resolve_cpu_time, gfc_resolve_random_number):
	Remove ATTRIBUTE_UNUSED for used argument.

2006-07-03  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* intrinsic.texi: Document new intrinsics.

2006-07-02  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/28094
	* trans-intrinsic.c (gfc_conv_intrinsic_mod): Support cases where
	there is no integer kind equal to the resulting real kind.
	* intrinsic.c (add_functions): MODULO is not allowed as an actual
	argument.

2006-07-02  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/27965
	* trans-array.c (gfc_conv_ss_startstride): Correct the runtime
	conditions for bounds-checking. Check for nonzero stride.
	Don't check the last dimension of assumed-size arrays. Fix the
	dimension displayed in the error message.

2006-07-02  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/26801
	* trans-intrinsic.c (gfc_conv_associated): Use pre and post blocks
	of the scalarization expression.

2006-07-02  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/28081
	* resolve.c (resolve_substring): Don't issue out-of-bounds
	error messages when the range has zero size.

2006-07-02  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/23862
	* lang-specs.h (f95-cpp-input): Pass -ffree-form to f951 unless
	-ffixed-form is explicitly specified.

2006-06-30  Asher Langton  <langton2@llnl.gov>

	PR fortran/24748
	* primary.c (gfc_match_rvalue): Don't call
	match_substring for implicit non-character types.

2006-06-27  Jerry DeLisle  <jvdelisle@gcc.gnu.org>

	PR fortran/19310
	PR fortran/19904
	* arith.c (gfc_range_check): Return ARITH_OK if -fno-range-check. Add
	return of ARITH_NAN, ARITH_UNDERFLOW, and ARITH_OVERFLOW.
	(gfc_arith_divide): If -fno-range-check allow mpfr to divide by zero.
	* gfortran.h (gfc_option_t): Add new flag.
	* invoke.texi: Document new flag.
	* lang.opt: Add option -frange-check.
	* options.c (gfc_init_options): Initialize new flag.
	(gfc_handle_options): Set flag if invoked.
	* simplify.c (range_check): Add error messages for
	overflow, underflow, and other errors.
	* trans-const.c (gfc_conv_mpfr_to_tree): Build NaN and Inf from mpfr
	result.

2006-06-25  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/25056
	* interface.c (compare_actual_formal): Signal an error if the formal
	argument is a pure procedure and the actual is not pure.

	PR fortran/27554
	* resolve.c (resolve_actual_arglist): If the type of procedure
	passed as an actual argument is not already declared, see if it is
	an intrinsic.

	PR fortran/25073
	* resolve.c (resolve_select): Use bits 1 and 2 of a new int to
	keep track of  the appearance of constant logical case expressions.
	Signal an error is either value appears more than once.

	PR fortran/20874
	* resolve.c (resolve_fl_procedure): Signal an error if an elemental
	function is not scalar valued.

	PR fortran/20867
	* match.c (recursive_stmt_fcn): Perform implicit typing of variables.

	PR fortran/22038
	* match.c (match_forall_iterator): Mark new variables as
	FL_UNKNOWN if the match fails.

	PR fortran/28119
	* match.c (gfc_match_forall): Remove extraneous call to
	gfc_match_eos.

	PR fortran/25072
	* resolve.c (resolve_code, resolve_function): Rework
	forall_flag scheme so that it is set and has a value of
	2, when the code->expr (ie. the forall mask) is resolved.
	This is used to change "block" to "mask" in the non-PURE
	error message.

2006-06-24  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/28118
	* trans-array.c (gfc_conv_expr_descriptor): When building temp,
	use the substring reference to calculate the length if the
	expression does not have a charlen.

2006-06-23  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/25049
	PR fortran/25050
	* check.c (non_init_transformational): New function.
	(find_substring_ref): New function to signal use of disallowed
	transformational intrinsic in an initialization expression.
	(gfc_check_all_any): Call previous if initialization expr.
	(gfc_check_count): The same.
	(gfc_check_cshift): The same.
	(gfc_check_dot_product): The same.
	(gfc_check_eoshift): The same.
	(gfc_check_minloc_maxloc): The same.
	(gfc_check_minval_maxval): The same.
	(gfc_check_gfc_check_product_sum): The same.
	(gfc_check_pack): The same.
	(gfc_check_spread): The same.
	(gfc_check_transpose): The same.
	(gfc_check_unpack): The same.

	PR fortran/18769
	*intrinsic.c (add_functions): Add gfc_simplify_transfer.
	*intrinsic.h : Add prototype for gfc_simplify_transfer.
	*simplify.c (gfc_simplify_transfer) : New function to act as
	placeholder for eventual implementation.  Emit error for now.

	PR fortran/16206
	* expr.c (find_array_element): Eliminate condition on length of
	offset. Add bounds checking. Rearrange exit. Return try and
	put gfc_constructor result as an argument.
	(find_array_section): New function.
	(find_substring_ref): New function.
	(simplify_const_ref): Add calls to previous.
	(simplify_parameter_variable): Return on NULL expr.
	(gfc_simplify_expr): Only call gfc_expand_constructor for full
	arrays.

	PR fortran/20876
	* match.c (gfc_match_forall): Add missing locus to gfc_code.

2006-06-21  Steven G. Kargl  <kargls@comcast.net>

	* simplify.c (gfc_simplify_rrspacing): Initialize and clear mpfr_t
	variable.

2006-06-20  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/27958
	* trans-expr.c (gfc_conv_substring): If the substring start is
	greater than its end, the length of the substring is zero, and
	not negative.
	(gfc_trans_string_copy): Don't generate a call to
	_gfortran_copy_string when destination length is zero.

2006-06-20  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR libfortran/27895
	* resolve.c (compute_last_value_for_triplet): New function.
	(check_dimension): Correctly handle zero-sized array sections.
	Add checking on last element of array sections.

2006-06-20  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* trans.c (gfc_msg_bounds, gfc_msg_fault, gfc_msg_wrong_return):
	Add strings for common runtime error messages.
	(gfc_trans_runtime_check): Add a locus argument, use a string
	and not a string tree for the message.
	* trans.h (gfc_trans_runtime_check): Change prototype accordingly.
	(gfc_msg_bounds, gfc_msg_fault, gfc_msg_wrong_return): Add proto.
	* trans-const.c (gfc_strconst_bounds, gfc_strconst_fault,
	gfc_strconst_wrong_return, gfc_strconst_current_filename): Remove.
	(gfc_init_constants): Likewise.
	* trans-const.h: Likewise.
	* trans-decl.c (gfc_build_builtin_function_decls): Call to
	_gfortran_runtime_error has only one argument, the message string.
	* trans-array.h (gfc_conv_array_ref): Add a symbol argument and a
	locus.
	* trans-array.c (gfc_trans_array_bound_check): Build precise
	error messages.
	(gfc_conv_array_ref): Use the new symbol argument and the locus
	to build more precise error messages.
	(gfc_conv_ss_startstride): More precise error messages.
	* trans-expr.c (gfc_conv_variable): Give symbol reference and
	locus to gfc_conv_array_ref.
	(gfc_conv_function_call): Use the new prototype for
	gfc_trans_runtime_check.
	* trans-stmt.c (gfc_trans_goto): Build more precise error message.
	* trans-io.c (set_string): Likewise.
	* trans-intrinsic.c (gfc_conv_intrinsic_bound): Use new prototype
	for gfc_trans_runtime_check.

2006-06-20  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/27715
	* arith.c:  Cast the characters from the strings to unsigned
	char to avoid values less than 0 for extended ASCII.

2006-06-15  Asher Langton  <langton2@llnl.gov>
	
	PR fortran/27786
	* trans-array.c (gfc_conv_array_ref): Eliminate bounds checking
	for assumed-size Cray pointees.

2006-06-12  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/24558
	PR fortran/20877
	PR fortran/25047
	* decl.c (get_proc_name): Add new argument to flag that a
	module function entry is being treated. If true, correct
	error condition, add symtree to module namespace and add
	a module procedure.
	(gfc_match_function_decl, gfc_match_entry,
	gfc_match_subroutine): Use the new argument in calls to
	get_proc_name.
	* resolve.c (resolve_entries): ENTRY symbol reference to
	to master entry namespace if a module function.
	* trans-decl.c (gfc_create_module_variable): Return if
	the symbol is an entry.

	PR fortran/23091
	* resolve.c (resolve_fl_variable): Error if an automatic
	object has the SAVE attribute.

	PR fortran/24168
	* expr.c (simplify_intrinsic_op): Transfer the rank and
	the locus to the simplified expression.

	PR fortran/25090
	PR fortran/25058
	* gfortran.h : Add int entry_id to gfc_symbol.
	* resolve.c : Add static variables current_entry_id and
	specification_expr.
	(resolve_variable): During code resolution, check if a
	reference to a dummy variable in an executable expression
	is preceded by its appearance as a parameter in an entry.
	Likewise check its specification expressions.
	(resolve_code): Update current_entry_id on EXEC_ENTRY.
	(resolve_charlen, resolve_fl_variable): Set and reset
	specifiaction_expr.
	(is_non_constant_shape_array): Do not return on detection
	of a variable but continue to resolve all the expressions.
	(resolve_codes): set current_entry_id to an out of range
	value.

2006-06-06  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/27897
	* match.c (gfc_match_common):  Fix code typo.  Remove
	sym->name, since sym is NULL, and replace with name.

2006-06-05  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/14067
	* data.c (create_character_intializer): Add warning message
	for truncated string.

	PR fortran/16943
	* symbol.c : Include flags.h.
	(gfc_add_type): If a procedure and types are the same do not
	throw an error unless standard is less than gnu or pedantic.

	PR fortran/20839
	* parse.c (parse_do_block): Error if named block do construct
	does not have a named enddo.

	PR fortran/27655
	* check.c (gfc_check_associated): Pick up EXPR_NULL for pointer
	as well as target and put error return at end of function.

2006-06-03  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/19777
	* trans-array.c (gfc_conv_array_ref): Don't perform out-of-bounds
	checking for assumed-size arrrays.

2006-06-03  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/27524
	* trans-array.c (gfc_trans_dummy_array_bias): Don't use stride as
	a temporary variable when -fbounds-check is enabled, since its
	value will be needed later.

2006-06-01  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/25098
	PR fortran/25147
	* interface.c (compare_parameter): Return 1 if the actual arg
	is external and the formal is a procedure.
	(compare_actual_formal): If the actual argument is a variable
	and the formal a procedure, this an error.  If a gsymbol exists
	for a procedure of the same name, this is not yet resolved and
	the error is cleared.

	* trans-intrinsic.c (gfc_conv_associated): Make provision for
	zero array length or zero string length contingent on presence
	of target, for consistency with standard.

2006-05-31  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/23151
	Backport from mainline.
	* io.c (match_io):  print (1,*) is an error.

2006-05-30  H.J. Lu  <hongjiu.lu@intel.com>

	PR fortran/27662
	Backport from mainline
	2006-05-18  H.J. Lu  <hongjiu.lu@intel.com>
	* trans-array.c (gfc_conv_expr_descriptor): Don't zero the
	first stride to indicate a temporary.
	* trans-expr.c (gfc_conv_function_call): Likewise.

2005-05-28  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/27470
	Backport from trunk.
	* trans-array.c(gfc_array_allocate):  If ref->next exists
	that is if there is a statement like ALLOCATE(foo%bar(2)),
	F95 rules require that bar should be a pointer.

2006-05-28  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/25082
	* resolve.c (resolve_code): Add error condition that the return
	expression must be scalar.

	PR fortran/27411
	* matchexp.c (gfc_get_parentheses): New function.
	(match_primary): Remove inline code and call above.
	* gfortran.h: Provide prototype for gfc_get_parentheses.
	* resolve.c (resolve_array_ref): Call the above, when start is a
	derived type variable array reference.

	PR fortran/27613
	* primary.c (gfc_match_rvalue): Test if symbol represents a
	direct recursive function reference.  Error if array valued,
	go to function0 otherwise.

	PR fortran/25746
	* interface.c (gfc_extend_assign): Use new EXEC_ASSIGN_CALL.
	* gfortran.h : Put EXEC_ASSIGN_CALL in enum.
	* trans-stmt.c (gfc_conv_elemental_dependencies): New function.
	(gfc_trans_call): Call it.  Add new boolian argument to flag
	need for dependency checking. Assert intent OUT and IN for arg1
	and arg2.
	(gfc_trans_forall_1): Use new code EXEC_ASSIGN_CALL.
	trans-stmt.h : Modify prototype of gfc_trans_call.
	trans.c (gfc_trans_code): Add call for EXEC_ASSIGN_CALL.
	st.c (gfc_free_statement): Free actual for EXEC_ASSIGN_CALL.
	* dependency.c (gfc_check_fncall_dependency): Don't check other
	against itself.

	PR fortran/27584
	* check.c (gfc_check_associated): Replace NULL assert with an
	error message, since it is possible to generate bad code that
	has us fall through to here..

	PR fortran/19015
	* iresolve.c (maxloc, minloc): If DIM is not present, pass the
	rank of ARRAY as the shape of the result.  Otherwise, pass the
	shape of ARRAY, less the dimension DIM.
	(maxval, minval): The same, when DIM is present, otherwise no
	change.

	PR fortran/27709
	* resolve.c (find_array_spec): Add gfc_symbol, derived, and
	use to track repeated component references.

	PR fortran/27155
	PR fortran/27449
	* trans-intrinsic.c (gfc_conv_intrinsic_array_transfer): Use
	se->string_length throughout and use memcpy to populate the
	expression returned to the scalarizer.
	(gfc_size_in_bytes): New function.

	* trans-intrinsic.c (gfc_conv_associated): If pointer in first
	arguments has zero array length of zero string length, return
	false.

2006-05-27  Francois-Xavier Coudert  <coudert@clipper.ens.fr>
	    Feng Wang  <fengwang@nudt.edu.cn>

	PR fortran/27552
	* dump-parse-tree.c (gfc_show_expr): Deal with Hollerith constants.
	* data.c (create_character_intializer): Set from_H flag if character is
	initialized by Hollerith constant.

2006-05-27  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/27320
	* dump-parse-tree.c (gfc_show_code_node): Try harder to find the
	called procedure name.

2006-05-27  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/26551
	* resolve.c (resolve_call, resolve_function): Issue an error
	if a function or subroutine call is recursive but the function or
	subroutine wasn't declared as such.

2006-05-24  Release Manager

	* GCC 4.1.1 released.

2006-05-17  H.J. Lu  <hongjiu.lu@intel.com>

	* Make-lang.in: Undo the last change.

2006-05-17  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/27553
	* parse.c (next_free): Return instead of calling decode_statement
	upon error.

2006-05-16  H.J. Lu  <hongjiu.lu@intel.com>

	PR driver/26885
	* Make-lang.in (GFORTRAN_D_OBJS): Replace gcc.o with
	$(GCC_OBJS).

2006-05-11  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/24549
	* parse.c (reject_statement): Clear gfc_new_block.

2006-05-11  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/20460
	* resolve.c (gfc_resolve_index): Make REAL array indices a
	GFC_STD_LEGACY feature.

2006-05-08  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/27378
	* parse.c (next_statement): Add check to avoid an ICE when
	gfc_current_locus.lb is not set.

2006-05-08  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/24813
	* trans-array.c (get_array_ctor_strlen): Remove static attribute.
	* trans.h: Add prototype for get_array_ctor_strlen.
	* trans-intrinsic.c (gfc_conv_intrinsic_len): Switch on EXPR_ARRAY
	and call get_array_ctor_strlen.

	PR fortran/27269
	* module.c: Add static flag in_load_equiv.
	(mio_expr_ref): Return if no symtree and in_load_equiv.
	(load_equiv): If any of the equivalence members have no symtree, free
	the equivalence and the associated expressions.

	PR fortran/27324
	* trans-common.c (gfc_trans_common): Invert the order of calls to
	finish equivalences and gfc_commit_symbols.

	PR fortran/25099
	* resolve.c (resolve_call): Check conformity of elemental
	subroutine actual arguments.

2006-05-05  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/25681
	* simplify.c (simplify_len): Character variables with constant
	length can be simplified.

2006-05-04  Tobias Schlüter  <tobias.schlueter@physik.uni-muenchen.de>

	Backport r113523 from the trunk
	* simplify.c (ascii_table): Fix wrong entry.

2006-04-29  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/26017
	Backport from trunk
	* trans-array.c(gfc_array_init_size):  Introduce or_expr
	which is true if the size along any dimension
	is negative.  Create a temporary variable with base
	name size.  If or_expr is true, set the temporary to 0,
	to the normal size otherwise.

2006-04-23  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/27122
	* resolve.c (resolve_function): Remove general restriction on auto
	character length function interfaces.
	(gfc_resolve_uops): Check restrictions on defined operator
	procedures.
	(resolve_types): Call the check for defined operators.

	PR fortran/27113
	* trans-array.c (get_array_ctor_var_strlen): Remove typo in enum.
	Part of the fix in 4.2, which does not work in 4.1 because the
	divergence is now too great.

	PR fortran/26822
	* intrinsic.c (add_functions): Mark LOGICAL as elemental.

	PR fortran/26787
	* expr.c (gfc_check_assign): Extend scope of error to include
	assignments to a procedure in the main program or, from a
	module or internal procedure that is not that represented by
	the lhs symbol. Use VARIABLE rather than l-value in message.

	PR fortran/25597
	* trans-decl.c (gfc_trans_deferred_vars): Check if an array
	result, is also automatic character length.  If so, process
	the character length. Note that this fixes the bug in 4.2
	but not here in 4.1 because the trees have diverged too much.
	Manifestly correct, so applied anyway.

	PR fortran/18003
	PR fortran/25669
	PR fortran/26834
	* trans_intrinsic.c (gfc_walk_intrinsic_bound): Set
	data.info.dimen for bound intrinsics.
	* trans_array.c (gfc_conv_ss_startstride): Pick out LBOUND and
	UBOUND intrinsics and supply their shape information to the ss
	and the loop.

	PR fortran/27124
	* trans_expr.c (gfc_trans_function_call):  Add a new block, post,
	in to which all the argument post blocks are put.  Add this block
	to se->pre after a byref call or to se->post, otherwise.

2006-04-22  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/26769
	* iresolve.c (gfc_resolve_reshape): Use reshape_r16 for real(16).
	(gfc_resolve_transpose): Use transpose_r16 for real(16).

2006-04-18  Steve Ellcey  <sje@cup.hp.com>

	* trans-io.c (gfc_build_io_library_fndecls): Align pad.

2006-04-16  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/26769
	* iresolve.c (gfc_resolve_reshape):  Remove doubling of
	kind for complex. For real(kind=10), call reshape_r10.
	(gfc_resolve_transpose):  For real(kind=10), call
	transpose_r10.

2006-04-12  H.J. Lu  <hongjiu.lu@intel.com>

	PR fortran/25619
	Backport from mainline
	2006-04-04  H.J. Lu  <hongjiu.lu@intel.com>

	* trans-array.c (gfc_conv_expr_descriptor): Only dereference
	character pointer when copying temporary.

	PR fortran/23634
	Backport from mainline
	2006-04-04  H.J. Lu  <hongjiu.lu@intel.com>

	* trans-array.c (gfc_conv_expr_descriptor): Properly copy
	temporary character with non constant size.

2006-04-11  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/26257
	* trans-array.c (gfc_conv_expr_descriptor): Exclude calculation
	of the offset and data when se->data_not_needed is set.
	* trans.h: Include the data_not_need bit in gfc_se.
	* trans-intrinsic.c (gfc_conv_intrinsic_size): Set it for SIZE.

2006-04-08  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/25031
	Backport from mainline
	* trans-array.h:  Adjust gfc_array_allocate prototype.
	* trans-array.c (gfc_array_allocate):  Change type of
	gfc_array_allocatate to bool.  Function returns true if
	it operates on an array.  Change second argument to gfc_expr.
	Find last reference in chain.
	If the function operates on an allocatable array, emit call to
	allocate_array() or allocate64_array().
	* trans-stmt.c (gfc_trans_allocate):  Code to follow to last
	reference has been moved to gfc_array_allocate.
	* trans.h:  Add declaration for gfor_fndecl_allocate_array and
	gfor_fndecl_allocate64_array.
	(gfc_build_builtin_function_decls):  Add gfor_fndecl_allocate_array
	and gfor_fndecl_allocate64_array.

2006-04-07 Jerry DeLisle  <jvdelisle@gcc.gnu.org>

	PR fortran/19101
	* gfortran.h: Add warn_ampersand.
	* invoke.texi: Add documentation for new option.
	* lang.opt: Add Wampersand.
	* options.c (gfc_init_options): Initialize warn_ampersand.
	(gfc_post_options): Set the warn if pedantic.
	(set_Wall): Set warn_ampersand.
	(gfc_handle_option: Add Wampersand for itself, -std=f95, and -std=f2003.
	* scanner.c (gfc_next_char_literal): Add test for missing '&' in
	continued character constant and give warning if missing.

2006-04-07  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/26891
	* trans.h : Prototype for gfc_conv_missing_dummy.
	* trans-expr (gfc_conv_missing_dummy): New function
	(gfc_conv_function_call): Call it and tidy up some of the code.
	* trans-intrinsic (gfc_conv_intrinsic_function_args): The same.

	PR fortran/26976
	* array.c (gfc_array_dimen_size): If available, return shape[dimen]
	* resolve.c (resolve_function): If available, use the argument shape
	for the function expression.
	* iresolve.c (gfc_resolve_transfer): Set shape[0] = size.

	PR fortran/26779
	*resolve.c (resolve_fl_procedure): Do not check the access of
	derived types for internal procedures.

2006-03-31  Asher Langton  <langton2@llnl.gov>

	PR fortran/25358
	*expr.c (gfc_check_assign): Allow cray pointee to be assumes-size.

2006-03-31  Thomas Koenig  <Thomas.Koenig@onlien.de>

	PR fortran/19303
	Backport from mainline
	* gfortran.h (gfc_option_t):  Add record_marker.
	* lang.opt:  Add -frecord-marker=4 and -frecord-marker=8.
	* trans-decl.c:  Add gfor_fndecl_set_record_marker.
	(gfc_build_builtin_function_decls): Set
	gfor_fndecl_set_record_marker.
	(gfc_generate_function_code):  If we are in the main program
	and -frecord-marker was provided, call set_record_marker.
	* options.c (gfc_handle_option):  Add handling for
	-frecord-marker=4 and -frecord-marker=8.
	* invoke.texi:  Document -frecord-marker.

2006-03-28  Steven G. Kargl  <kargls@comcast.net>

	* intrinsic.texi: s/floor/float in previous commit.

2006-03-28  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/26816 
	* intrinsic.c (add_functions): Allow FLOAT to accept all integer kinds.
	* intrinsic.texi: Document FLOAT.

2006-03-27  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/20935
	Backport from mainline
	* iresolve.c (gfc_resolve_maxloc):   If mask is scalar,
	prefix the function name with an "s".  If the mask is scalar
	or if its kind is smaller than gfc_default_logical_kind,
	coerce it to default kind.
	(gfc_resolve_maxval):  Likewise.
	(gfc_resolve_minloc):  Likewise.
	(gfc_resolve_minval):  Likewise.
	(gfc_resolve_product):  Likewise.
	(gfc_resolve_sum):  Likewise.

2006-03-27  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/25378
	Backport from mainline
	* trans-intrinsic.c (gfc_conv_intrinsic_minmaxloc): Set the
	initial position to zero and modify the condition for updating
	it, to implement the F2003 requirement for all(mask) is false.

2006-03-27  Jakub Jelinek  <jakub@redhat.com>

	* io.c (check_io_constraints): Don't look at
	dt->advance->value.charater.string, unless it is a CHARACTER
	constant.

	* f95-lang.c (gfc_get_alias_set): New function.
	(LANG_HOOKS_GET_ALIAS_SET): Define.

2006-03-22  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/17298
	*trans-intrinsic.c (gfc_conv_intrinsic_array_transfer): New
	function to implement array valued TRANSFER intrinsic.
	(gfc_conv_intrinsic_function): Call the new function if TRANSFER
	and non-null se->ss.
	(gfc_walk_intrinsic_function): Treat TRANSFER as one of the
	special cases by calling gfc_walk_intrinsic_libfunc directly.

2006-03-19  Tobias Schlüter  <tobias.schlueter@physik.uni-muenchen.de>

	(backport r110993)
	PR fortran/26277
	* io.c (match_ltag): Mark label as referenced.

2006-03-19  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/26741
	*expr.c (external_spec_function): Permit elemental functions.

	PR fortran/26716
	*interface.c (compare_actual_formal): Detect call for procedure
	usage and require rank checking, in this case, for assumed shape
	and deferred shape arrays.
	(gfc_procedure_use): Revert to pre-PR25070 call to
	compare_actual_formal that does not require rank checking..

2006-03-11  Toon Moene  <toon@moene.indiv.nluug.nl>

	PR fortran/26054
	* options.c: Do not warn for Fortran 2003 features
	by default.

2006-03-07  H.J. Lu  <hongjiu.lu@intel.com>

	PR fortran/26041
	PR fortran/26064
	Backport from mainline
	* resolve.c (resolve_types): New function.
	(resolve_codes): Likewise.
	(gfc_resolve): Use them.

2006-03-07  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/26107
	* resolve.c (resolve_function): Add name after test for pureness.

	* iresolve.c (gfc_resolve_dot_product):  Remove any difference in
	treatment of logical types.
	* trans-intrinsic.c (gfc_conv_intrinsic_dot_product):  New function. 

	PR fortran/26393
	* trans-decl.c (gfc_get_symbol_decl): Extend condition that symbols
	must be referenced to include unreferenced symbols in an interface
	body. 

	PR fortran/20938
	* trans-array.c (gfc_conv_resolve_dependencies): Add call to
	gfc_are_equivalenced_arrays.
	* symbol.c (gfc_free_equiv_infos, gfc_free_equiv_lists): New
	functions. (gfc_free_namespace): Call them.
	* trans-common.c (copy_equiv_list_to_ns): New function.
	(add_equivalences): Call it.
	* gfortran.h: Add equiv_lists to gfc_namespace and define
	gfc_equiv_list and gfc_equiv_info.
	* dependency.c (gfc_are_equivalenced_arrays): New function.
	(gfc_check_dependency): Call it.
	* dependency.h: Prototype for gfc_are_equivalenced_arrays.

	PR fortran/24519
	* dependency.c (gfc_is_same_range): Correct typo.
	(gfc_check_section_vs_section): Call gfc_is_same_range.

	PR fortran/25395
	* trans-common.c (add_equivalences): Add a new flag that is set when
	an equivalence is seen that prevents more from being reset until the
	start of a new traversal of the list, thus ensuring completion of
	all the equivalences.

	PR fortran/25054
	* resolve.c (is_non_constant_shape_array): New function.
	(resolve_fl_variable): Remove code for the new function and call it.
	(resolve_fl_namelist): New function.  Add test for namelist array
	with non-constant shape, using is_non_constant_shape_array.
	(resolve_symbol): Remove code for resolve_fl_namelist and call it.

	PR fortran/25089
	* match.c (match_namelist): Increment the refs field of an accepted
	namelist object symbol.
	* resolve.c (resolve_fl_namelist): Test namelist objects for a conflict
	with contained or module procedures.

	PR fortran/24557
	* trans-expr.c (gfc_add_interface_mapping): Use the actual argument
	for character(*) arrays, rather than casting to the type and kind
	parameters of the formal argument.

2006-03-05  Thomas Koenig <Thomas.Koenig@online.de>

	PR fortran/23092
	backport from mainline
	* trans-intrinsic.c (gfc_conv_intrinsic_minmaxloc):
	If the mask expression exists and has rank 0, enclose the
	generated loop in an "if (mask)".  Put the default
	initialization into the else branch.
	* trans-intrinsic.c (gfc_conv_intrinsic_arith):  If the
	mask expression exists and has rank 0, enclose the generated
	loop in an "if (mask)".
	* (gfc_conv_intrinsic_minmaxloc):  Likewise.

2006-03-05  Thomas Koenig <Thomas.Koenig@online.de>

	backport from mainline
	* gfortran.texi:  Document environment variables which
	influence runtime behavior.

2006-03-04  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/25045
	PR fortran/25075
	backport from mainline
        * check.c (dim_check):  Perform all checks if dim is optional.
        (gfc_check_minloc_maxloc):  Use dim_check and dim_rank_check
        to check dim argument.
        (check_reduction):  Likewise.
	check.c (identical_dimen_shape):  New function.
	(check_dot_product):  Use identical_dimen_shape() to check sizes
	for dot_product.
	(gfc_check_matmul):  Likewise.
	(gfc_check_merge):  Check conformance between tsource and fsource
	and between tsource and mask.
	(gfc_check_pack):  Check conformance between array and mask.

2006-03-04  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR libfortran/21303
	* gfortran.h (notification): New enumeration.
	(gfc_notification_std): Prototype for the new function.
	* error.c (gfc_notification_std): New function.
	* io.c (check_format): Handle the case of a L format descriptor
	without a width.

2006-02-28  Release Manager

	* GCC 4.1.0 released.

2006-02-20  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/26201
	* intrinsic.c (gfc_convert_type_warn): Call
	gfc_intrinsic_symbol() on the newly created symbol.

2006-02-14  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/25806
	* trans-array.c (gfc_trans_allocate_array_storage): New argument
	dealloc; free the temporary only if dealloc is true.
	(gfc_trans_allocate_temp_array): New argument bool dealloc, to be
	passed onwards to gfc_trans_allocate_array_storage.
	(gfc_trans_array_constructor, gfc_conv_loop_setup): Update call to
	gfc_trans_allocate_temp_array.
	* trans-array.h (gfc_trans_allocate_temp_array): Update function
	prototype.
	* trans-expr.c (gfc_conv_function_call): Set new argument 'dealloc'
	to gfc_trans_allocate_temp_array to false in case of functions
	returning pointers.
	(gfc_trans_arrayfunc_assign): Return NULL for functions returning
	pointers.

2006-02-14  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR libfortran/25425
	* trans-decl.c (gfc_generate_function_code): Add new argument,
	pedantic, to set_std call.

2006-02-13  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/26074
	PR fortran/25103
	* resolve.c (resolve_symbol): Extend the requirement that module
	arrays have constant bounds to those in the main program.  At the
	same time simplify the array bounds, to avoiding trapping parameter
	array references, and exclude automatic character length from main
	and modules. Rearrange resolve_symbol and resolve_derived to put as
	each flavor together, as much as is possible and move all specific
	code for flavors FL_VARIABLE, FL_PROCEDURE and FL_PARAMETER into new
	functions.
	(resolve_fl_var_and_proc, resolve_fl_variable, resolve_fl_procedure):
	New functions to do work of resolve_symbol.
	(resolve_index_expr): New function that is called from resolved_symbol
	and is extracted from resolve_charlen.
	(resolve_charlen): Call this new function.
	(resolve_fl_derived): Renamed resolve_derived to be consistent with
	the naming of the new functions for the other flavours.  Change the
	charlen checking so that the style is consistent with other similar
	checks. Add the generation of the gfc_dt_list, removed from resolve_
	symbol.

	PR fortran/20861
	* resolve.c (resolve_actual_arglist): Prevent internal procedures
	from being dummy arguments.

	PR fortran/20871
	* resolve.c (resolve_actual_arglist): Prevent pure but non-intrinsic
	procedures from being dummy arguments.

	PR fortran/25083
	* resolve.c (check_data_variable): Add test that data variable is in
	COMMON.

	PR fortran/25088
	* resolve.c (resolve_call): Add test that the subroutine does not
	have a type.

2006-02-13  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/26038
	* trans-stmt.c (gfc_trans_allocate): Provide assumed character length
	scalar with missing backend_decl for the hidden dummy charlen.

	PR fortran/25059
	* interface.c (gfc_extend_assign): Remove detection of non-PURE
	subroutine in assignment interface, with gfc_error, and put it in
	* resolve.c (resolve_code).

	PR fortran/25070
	* interface.c (gfc_procedure_use): Flag rank checking for non-
	elemental, contained or interface procedures in call to
	(compare_actual_formal), where ranks are checked for assumed
	shape arrays..

2006-02-11  Tobias Schlüter  <tobias.schlueter@physik.uni-muenchen.de>

	Backport r110819 and r110840 from the trunk
	PR fortran/14771
	* gfortran.h (gfc_intrinsic_op): Add INTRINSIC_PARENTHESES.
	* dump-parse-tree (gfc_show_expr): Handle INTRINSIC_PARENTHESES.
	* expr.c (simplify_intrinsic_op): Treat INTRINSIC_PARENTHESES as
	if it were INTRINSIC_UPLUS.
	* resolve.c (resolve_operator): Handle INTRINSIC_PARENTHESES.
	* match.c (intrinsic_operators): Add INTRINSIC_PARENTHESES.
	* matchexp.c (match_primary): Record parentheses surrounding
	numeric expressions.
	* module.c (intrinsics): Add INTRINSIC_PARENTHESES for module
	dumping.
	* trans-expr.c (gfc_conv_expr_op): Handle INTRINSIC_PARENTHESES.

	PR fortran/14771
	* arith.c (eval_intrinsic): Accept INTRINSIC_PARENTHESES.
	* expr.c (check_intrinsic_op): Likewise.
	* module.c (mio_expr): Likewise.
	
2006-02-10  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/25756
	* symbol.c (gfc_free_st_label): Give variable meaningful name. Remove
	unneeded parenthesis. Fix-up the head of the list (2 lines gleaned
	from g95).

2006-02-10  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/20858
	*decl.c (variable_decl): Improve error message.  Remove initialization
	typespec.  Wrap long line.
	*expr.c (gfc_check_pointer_assign): Permit checking of type, kind type,
	and rank.
	*simplify.c (gfc_simplify_null): Ensure type, kind type, and rank
	are set.


2005-02-08  Thomas Koenig  <Thomas.Koenig@online.de>

	PR libfortran/23815
	* gfortran.texi: Document the GFORTRAN_CONVERT_UNIT environment
	variable.
	* invoke.texi:  Mention the "Runtime" chapter.
	Document the -fconvert= option.
	* gfortran.h:  Add options_convert.
	* lang.opt:  Add fconvert=little-endian, fconvert=big-endian,
	fconvert=native and fconvert=swap.
	* trans-decl.c (top level):  Add gfor_fndecl_set_convert.
	(gfc_build_builtin_function_decls):  Set gfor_fndecl_set_convert.
	(gfc_generate_function_code):  If -fconvert was specified,
	and this is the main program, add a call to set_convert().
	* options.c:  Handle the -fconvert options.

2006-02-05  Jakub Jelinek  <jakub@redhat.com>

	* resolve.c (resolve_symbol): Initialize constructor_expr to NULL.

2006-02-04  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/26039
	PR fortran/25046
	* expr.c (gfc_check_conformance):  Reorder error message
	to avoid plural.
	* check.c(gfc_check_minloc_maxloc):  Call gfc_check_conformance
	for checking arguments array and mask.
	(check_reduction):  Likewise.

2006-02-03  Steven G. Kargl  <kargls@comcast>
	    Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/20845
	* resolve.c (resolve_symbol): Default initialization of derived type
	component reguires the SAVE attribute.

2006-02-02  Steven G. Kargl  <kargls@comcast>

	PR fortran/24958
	match.c (gfc_match_nullify):  Free the list from head not tail.

	PR fortran/25072
	* match.c (match_forall_header): Fix internal error caused by bogus
	gfc_epxr pointers.

2005-01-31  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/24266
	* trans-io.c (set_internal_unit): Check the rank of the
	expression node itself instead of its symbol.

2006-01-30  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/18578
	PR fortran/18579
	PR fortran/20857
	PR fortran/20885
	* interface.c (compare_actual_formal): Error for INTENT(OUT or INOUT)
	if actual argument is not a variable.

	PR fortran/17911
	* expr.c (gfc_check_assign, gfc_check_pointer_assign): Emit error if
	the lvalue is a use associated procedure.

	PR fortran/20895
	PR fortran/25030
	* expr.c (gfc_check_pointer_assign): Emit error if lvalue and rvalue
	character lengths are not the same.  Use gfc_dep_compare_expr for the
	comparison.
	* gfortran.h: Add prototype for gfc_dep_compare_expr.
	* dependency.h: Remove prototype for gfc_dep_compare_expr.

2005-01-27  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/25951
	* resolve.c (resolve_function): Add GFC_ISYM_LOC to the list of
	generic_ids exempted from assumed size checking.

	PR fortran/25964
	* resolve.c (resolve_function): Exclude statement functions from
	global reference checking.

	PR fortran/25084
	PR fortran/20852
	PR fortran/25085
	PR fortran/25086
	* resolve.c (resolve_function): Declare a gfc_symbol to replace the
	references through the symtree to the symbol associated with the
	function expresion. Give error on reference to an assumed character
	length function is defined in an interface or an external function
	that is not a dummy argument.
	(resolve_symbol): Give error if an assumed character length function
	is array-valued, pointer-valued, pure or recursive. Emit warning
	that character(*) value functions are obsolescent in F95.

	PR fortran/25416
	* trans-expr.c (gfc_conv_function_call): The above patch to resolve.c
	prevents any assumed character length function call from getting here
	except intrinsics such as SPREAD. In this case, ensure that no
	segfault occurs from referencing non-existent charlen->length->
	expr_type and provide a backend_decl for the charlen from the charlen
	of the first actual argument.

	Cure temp name confusion.
	* trans-expr.c (gfc_get_interface_mapping_array): Change name of
	temporary from "parm" to "ifm" to avoid clash with temp coming from
	trans-array.c.

	PR fortran/25124
	PR fortran/25625
	* decl.c (get_proc_name): If there is an existing
	symbol in the encompassing namespace, call errors
	if it is a procedure of the same name or the kind
	field is set, indicating a type declaration.

	PR fortran/20881
	PR fortran/23308
	PR fortran/25538
	PR fortran/25710
	* decl.c (add_global_entry): New function to check
	for existing global symbol with this name and to
	create new one if none exists.
	(gfc_match_entry): Call add_global_entry before
	matching argument lists for subroutine and function
	entries.
	* gfortran.h: Prototype for existing function, global_used.
	* resolve.c (resolve_global_procedure): New function
	to check global symbols for procedures.
	(resolve_call, resolve_function): Calls to this
	new function for non-contained and non-module
	procedures.
	* match.c (match_common): Add check for existing
	global symbol, creat one if none exists and emit
	error if there is a clash.
	* parse.c (global_used): Remove static and use the
	gsymbol name rather than the new_block name, so that
	the function can be called from resolve.c.
	(parse_block_data, parse_module, add_global_procedure):
	Improve checks for existing gsymbols.  Emit error if
	already defined or if references were to another type.
	Set defined flag.

	PR fortran/24276
	* trans-expr.c (gfc_conv_aliased_arg): New function called by 
	gfc_conv_function_call that coverts an expression for an aliased
	component reference to a derived type array into a temporary array
	of the same type as the component.  The temporary is passed as an
	actual argument for the procedure call and is copied back to the
	derived type after the call.
	(is_aliased_array): New function that detects an array reference
	that is followed by a component reference.
	(gfc_conv_function_call): Detect an aliased actual argument with
	is_aliased_array and convert it to a temporary and back again
	using gfc_conv_aliased_arg.

2006-01-27  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/25324
	* Make-lang.in (fortran/scanner.o): Depend on toplev.h.
	* lang.opt (fpreprocessed): New option.
	* scanner.c: Include toplev.h.
	(gfc_src_file, gfc_src_preprocessor_lines): New variables.
	(preprocessor_line): Unescape filename if there were any
	backslashes.
	(load_file): If initial and gfc_src_file is not NULL,
	use it rather than opening the file.  If gfc_src_preprocessor_lines
	has non-NULL elements, pass it to preprocessor_line.
	(unescape_filename, gfc_read_orig_filename): New functions.
	* gfortran.h (gfc_option_t): Add flag_preprocessed.
	(gfc_read_orig_filename): New prototype.
	* options.c (gfc_init_options): Clear flag_preprocessed.
	(gfc_post_options): If flag_preprocessed, call
	gfc_read_orig_filename.
	(gfc_handle_option): Handle OPT_fpreprocessed.
	* lang-specs.h: Pass -fpreprocessed to f951 if preprocessing
	sources.

2005-01-27  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/25716
	* symbol.c (free_old_symbol): New function.
	(gfc_commit_symbols): Use it.
	(gfc_commit_symbol): New function.
	(gfc_use_derived): Use it.
	* gfortran.h: Add prototype for gfc_commit_symbol.
	* intrinsic.c (gfc_find_function): Search in 'conversion'
	if not found in 'functions'.
	(gfc_convert_type_warn): Add a symtree to the new
	expression node, and commit the new symtree->n.sym.
	* resolve.c (gfc_resolve_index): Make sure typespec is
	properly initialized.

2005-01-25  Steven Bosscher  <stevenb.gcc@gmail.com>
	Tobias Schlüter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/18540
	* resolve.c (resolve_branch): Allow FORTRAN 66 cross-block GOTOs
	as extension.

2005-01-23  Paul Thomas  <pault@gcc.gnu.org>

	Fix regression in testing of admissability of attributes.
	* symbol.c (gfc_add_attribute): If the current_attr has non-zero
	intent, do not do the check for a dummy being used.
	* decl.c (attr_decl1): Add current_attr.intent as the third argument
	in the call to gfc_add_attribute.
	* gfortran.h: Add the third argument to the prototype for
	gfc_add_attribute.

2006-01-21  Joseph S. Myers  <joseph@codesourcery.com>

	* gfortranspec.c (lang_specific_driver): Update copyright notice
	date.

2006-01-18  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/20869
	PR fortran/20875
	PR fortran/25024
	* symbol.c (check_conflict): Add pointer valued elemental
	functions and internal procedures with the external attribute
	to the list of conflicts.
	(gfc_add_attribute): New catch-all function to perform the
	checking of symbol attributes for attribute declaration
	statements.
	* decl.c (attr_decl1): Call gfc_add_attribute for each of -
	(gfc_match_external, gfc_match_intent, gfc_match_intrinsic,
	gfc_match_pointer, gfc_match_dimension, gfc_match_target):
	Remove spurious calls to checks in symbol.c.  Set the
	attribute directly and use the call to attr_decl() for
	checking.
	* gfortran.h:  Add prototype for gfc_add_attribute.

	PR fortran/25785
	* resolve.c (resolve_function): Exclude PRESENT from assumed size
	argument checking. Replace strcmp's with comparisons with generic
	codes.

2006-01-14  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/22146
	* trans-array.c (gfc_reverse_ss): Remove static attribute.
	(gfc_walk_elemental_function_args): Replace gfc_expr * argument for
	the function call with the corresponding gfc_actual_arglist*.  Change
	code accordingly.
	(gfc_walk_function_expr): Call to gfc_walk_elemental_function_args
	now requires the actual argument list instead of the expression for
	the function call.
	* trans-array.h: Modify the prototype for gfc_walk_elemental_function_args
	and provide a prototype for gfc_reverse_ss.
	* trans-stmt.h (gfc_trans_call): Add the scalarization code for the case
	where an elemental subroutine has array valued actual arguments.

	PR fortran/25029
	PR fortran/21256
	PR fortran/20868
	PR fortran/20870
	* resolve.c (check_assumed_size_reference): New function to check for upper
	bound in assumed size array references.
	(resolve_assumed_size_actual): New function to do a very restricted scan
	of actual argument expressions of those procedures for which incomplete
	assumed size array references are not allowed.
	(resolve_function, resolve_call): Switch off assumed size checking of
	actual arguments, except for elemental procedures and intrinsic
	inquiry functions, in some circumstances.
	(resolve_variable): Call check_assumed_size_reference.

2006-01-11  Bernhard Fischer  <rep.nop@aon.at>

	PR fortran/25486
	* scanner.c (load_line): use maxlen to determine the line-length used
	for padding lines in fixed form.

2005-01-11  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/25730
	* trans-types.c (copy_dt_decls_ifequal): Copy backend decl for
	character lengths.

2006-01-09  Andrew Pinski  <pinskia@physics.uc.edu>

	fortran/24936
	* trans-stmt.c (gfc_trans_pointer_assign_need_temp): Use fold_convert
	to avoid type mismatch.

2006-01-09  Andrew Pinski  <pinskia@physics.uc.edu>

	PR fortran/21977
	* trans-decl.c (gfc_generate_function_code): Move the NULLing of
	current_fake_result_decl down to below generate_local_vars.

2005-01-09  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/25093
	* resolve.c (resolve_fntype): Check that PUBLIC functions
	aren't of PRIVATE type.

2006-01-09  Feng Wang  <fengwang@nudt.edu.cn>

	PR fortran/12456
	* trans-expr.c (gfc_to_single_character): New function that converts
	string to single character if its length is 1.
	(gfc_build_compare_string):New function that compare string and handle
	single character specially.
	(gfc_conv_expr_op): Use gfc_build_compare_string.
	(gfc_trans_string_copy): Use gfc_to_single_character.
	* trans-intrinsic.c (gfc_conv_intrinsic_strcmp): Use
	gfc_build_compare_string.
	* trans.h (gfc_build_compare_string): Add prototype.

2006-01-09  Feng Wang  <fengwang@nudt.edu.cn>

	* simplify.c (gfc_simplify_char): Use UCHAR_MAX instead of literal
	constant.
	(gfc_simplify_ichar): Get the result from unsinged char and in the
	range 0 to UCHAR_MAX instead of CHAR_MIN to CHAR_MAX.

2006-01-07  Jerry DeLisle  <jvdelisle@gcc.gnu.org>

	PR fortran/24268
	* io.c (next_char_not_space): New function that returns the next
	character that is not white space.
	(format_lex): Use the new function to skip whitespace within
	a format string.

2006-01-06 Steven G. Kargl  <kargls@comcast.net>

	PR fortran/25101
	* resolve.c (resolve_forall_iterators):  Check for scalar variables;
	Check stride is nonzero.

	PR fortran/24640
	* parse.c (next_free): Check for whitespace after the label;
	Update copyright year.
	* match.c (gfc_match_small_literal_int): Initialize cnt variable;
	Update copyright year.


2006-01-05  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/23675
	* expr.c (gfc_expr_set_symbols_referenced): New function.
	* gfortran.h: Add a function prototype for it.
	* resolve.c (resolve_function): Use it for
	use associated character functions lengths.
	* expr.c, gfortran.h, resolve.c: Updated copyright years.

2005-12-31  Steven G. Kargl <kargls@comcast.net>
 
	PR fortran/25106
	PR fortran/25055
	* io.c (match_dt_format): Remove second arg in gfc_match_st_label.
	* match.c (gfc_match_small_literal_int): Add cnt argument;
	(gfc_match_st_label,gfc_match_stopcode): Account for cnt argument.
	(gfc_match_st_label): Remove allow_zero (second argument), and use
	cnt for errors.
	(gfc_match_do,gfc_match_goto):  Remove second arg in gfc_match_st_label
	* match.h (gfc_match_small_literal_int,gfc_match_st_label):
	Update prototypes.
	* decl.c (match_char_length,gfc_match_old_kind_spec): Account for cnt.
	* parse.c (next_free): Account for cnt; Remove second arg in
	gfc_match_st_label
	* primary.c (match_kind_param): Ditto.

2005-12-30  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/22607
	* trans-decl.c(gfc_get_extern_function_decl): Don't set
	DECL_IS_PURE (fndecl) = 1 for return-by-reference
	functions.

	fortran/PR 25396
	* interface.c (gfc_extend_expr): Initialize
	e->value.function.name to NULL.

2005-12-29  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/25532
	* trans-types.c (copy_dt_decls_ifequal): Copy declarations for
	components of derived type components by recursing into
	gfc_get_derived_type.

2005-12-28  Andrew Pinski  <pinskia@physics.uc.edu>

	PR fortran/25587
	* trans-io.c (gfc_build_st_parameter): Correct off by one error.

2005-12-26  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/20889
	* resolve.c (resolve_structure_cons): Do not attempt to convert
	the type of mismatched pointer type components, except when
	the constructor component is BT_UNKNOWN; emit error instead.

	PR fortran/25018
	* expr.c (check_inquiry): Return FAILURE if there is no symtree to
	provide a name. Error/warning for assumed character length argument
	to LEN for an initialization expression, using GFC_GNU_STD. Add an
	argument to flag that the expression is not restricted.
	(check_init_expr): Improve the message for a failing variable.
	(gfc_match_init_expr): Call check_enquiry again to make sure that
	unsimplified expressions are not causing unnecessary errors.

	PR fortran/19362
	PR fortran/20244
	PR fortran/20864
	PR fortran/25391
	* interface.c (gfc_compare_types): Broken into two.
	(gfc_compare_derived_types): Second half of gfc_compare_types with
	corrections for a missing check that module name is non-NULL and
	a check for private components.
	* symbol.c (gfc_free_dt_list): New function.
	(gfc_free_namespace): Call gfc_free_dt_list.
	* resolve.c (resolve_symbol): Build the list of derived types in the
	symbols namespace.
	* gfortran.h: Define the structure type gfc_dt_list.  Add a new field,
	derived_types to gfc_namespace.  Provide a prototye for the new
	function gfc_compare_derived_types.
	* trans_types.c(gfc_get_derived_type): Test for the derived type being
	available in the host namespace. In this case, the host backend
	declaration is used for the structure and its components.  If an
	unbuilt, equal structure that is not use associated is found in the
	host namespace, build it there and then.  On exit,traverse the
	namespace of the derived type to see if there are equal but unbuilt.
	If so, copy the structure and its component declarations.
	(copy_dt_decls_ifequal): New functions to copy declarations to other
	equal structure types.

	PR fortran/20862
	* io.c (gfc_match_format): Make the appearance of a format statement
	in a module specification block an error.

	PR fortran/23152
	* match.c (gfc_match_namelist): Set assumed shape arrays in
	namelists as std=GFC_STD_GNU and assumed size arrays as an
	unconditional error.

	PR fortran/25069
	* match.c (gfc_match_namelist): Set the respecification of a USE
	associated namelist group as std=GFC_STD_GNU.  Permit the concatenation
	on no error.

	PR fortran/25053
	PR fortran/25063
	PR fortran/25064
	PR fortran/25066
	PR fortran/25067
	PR fortran/25068
	PR fortran/25307
	* io.c (resolve_tag): Change std on IOSTAT != default integer to
	GFC_STD_GNU and change message accordingly.  Add same error for
	SIZE.
	(match_dt_element, gfortran.h): Add field err_where to gfc_dt and
	set it when tags are being matched.
	(gfc_resolve_dt): Remove tests that can be done before resolution
	and add some of the new ones here.
	(check_io_constraints): New function that checks for most of the
	data transfer constraints. Some of these were previously done in
	match_io, from where this function is called, and some were done
	in gfc_resolve_dt.
	(match_io): Remove most of the tests of constraints and add the
	call to check_io_constraints.

2005-12-24  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/18990
	* gfortran.h (gfc_charlen): Add resolved field.
	* expr.c (gfc_specification_expr): Accept NULL argument.
	* resolve.c (gfc_resolve_charlen, gfc_resolve_derived): New.
	(gfc_resolve_symbol): Resolve derived type definitions.  Use
	resolve_charlen to resolve character lengths.

2005-12-22  Steven G. Kargl  <kargls@comcast.net>

	* decl.c (gfc_match_old_kind_spec,match_type_spec): Use gfc_std_notify
	to report nonstandard intrinsic type declarations.

2005-12-21  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/25423
	* parse.c (parse_where_block): break instead of "fall
	through" after parsing nested WHERE construct.

2005-12-20  Jerry DeLisle  <jvdelisle@gcc.gnu.org>

	PR fortran/24268
	* io.c (format_lex): Allow whitespace within text of format specifier.

2005-12-20  Steven G. Kargl  <kargls@comcast.net>
            Tobias Schlueter <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/25458
	* simplify.c (gfc_simplify_ibset, gfc_simplify_not): Add call to
	twos_complement.

2005-12-14  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/18197
	* resolve.c (resolve_formal_arglist): Remove code to set
	the type of a function symbol from it's result symbol.

2005-12-12  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/25078
	* match.c (gfc_match_equivalence):  Count number of objects.

2005-12-13  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/23815
	* io.c (top level):  Add convert to io_tag.
	(resolve_tag):  convert is GFC_STD_GNU.
	(match_open_element):  Add convert.
	(gfc_free_open):  Likewise.
	(gfc_resolve_open):  Likewise.
	(gfc_free_inquire):  Likewise.
	(match_inquire_element):  Likewise.
	* dump-parse-tree.c (gfc_show_code_node):  Add
	convet for open and inquire.
	gfortran.h: Add convert to gfc_open and gfc_inquire.
	* trans-io.c (gfc_trans_open):  Add convert.
	(gfc_trans_inquire):  Likewise.
	* ioparm.def:  Add convert to open and inquire.
	* gfortran.texi:  Document CONVERT.

2005-12-08  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/25292
	* check.c (gfc_check_associated): Allow function results
	as actual arguments to ASSOCIATED.  Moved a misplaced
	comment.

2005-12-07  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/15809
	* trans-decl.c (gfc_get_symbol_decl):  In the case of automatic
	character length, dummy pointer arrays, build an expression for
	unit size of the array elements, to be picked up and used in the
	descriptor dtype.
	* trans-io.c (gfc_trans_transfer):  Modify the detection of
	components of derived type arrays to use the gfc_expr references
	instead of the array descriptor dtype.  This allows the latter
	to contain expressions.

2005-12-02  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/23912
	* iresolve.c (gfc_resolve_dim, gfc_resolve_mod,
	gfc_resolve_modulo): When arguments have different kinds, fold
	the lower one to the largest kind.
	* check.c (gfc_check_a_p): Arguments of different kinds is not
	a hard error, but an extension.
	* simplify.c (gfc_simplify_dim, gfc_simplify_mod,
	gfc_simplify_modulo): When arguments have different kinds, fold
	the lower one to the largest kind.

2005-12-01  Erik Schnetter  <schnetter@aei.mpg.de>

	* decl.c (gfc_match_old_kind_spec):  Improve handling of old style
	COMPLEX*N

2005-12-01  Bernhard Fischer <rep.nop@aon.at>

	PR fortran/21302
	* lang.opt: New options -ffree-line-length- and -ffree-line-length-none.
	* gfortran.h: Add free_line_length and add description of
	free_line_length and fixed_line_length.
	* options.c (gfc_init_options, gfc_handle_option): Initialize
	and set free_line_length and fixed_line_length.
	* scanner.c (load_line): Set free_line_length to 132 and
	fixed_line_length to 72 or user requested values.
	* scanner.c: Typo in comment.
	* invoke.texi: Document -ffree-line-length- and
	-ffree-line-length-none

2005-11-30  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/24223
	* resolve.c (resolve_contained_fntype) Error if an internal
	function is assumed character length.

	PR fortran/24705
	* trans-decl.c (gfc_create_module_variable) Skip ICE in
	when backend decl has been built and the symbol is marked
	as being in an equivalence statement.

2005-11-29  Jakub Jelinek  <jakub@redhat.com>

	* io.c (gfc_resolve_open): RESOLVE_TAG access field as well.

2005-11-27 Bernhard Fischer <rep.nop@aon.at>

	* gfortran.h: remove superfluous whitespace and use GNU
	comment-style for the documentation of backend_decl.

2005-11-26  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/24917
	* primary.c (match_boz_constant):  Implement postfix BOZ constants;
	(match_string_constant): Peek for b, o, z, and x

	* gfortran.dg/boz_6.f90: New test.

2005-11-21  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/14943
	PR fortran/21647
	* Make-lang.in (fortran/trans-io.o): Depend on fortran/ioparm.def.
	* dump-parse-tree.c (gfc_show_code_node): Dump c->block for
	EXEC_{READ,WRITE,IOLENGTH} nodes.
	* io.c (terminate_io, match_io, gfc_match_inquire): Put data
	transfer commands into EXEC_{READ,WRITE,IOLENGTH}'s code->block.
	* resolve.c (resolve_blocks): Handle EXEC_{READ,WRITE,IOLENGTH}.
	* trans-io.c (ioparm_unit, ioparm_err, ioparm_end, ioparm_eor,
	ioparm_list_format, ioparm_library_return, ioparm_iostat,
	ioparm_exist, ioparm_opened, ioparm_number, ioparm_named,
	ioparm_rec, ioparm_nextrec, ioparm_size, ioparm_recl_in,
	ioparm_recl_out, ioparm_iolength, ioparm_file, ioparm_file_len,
	ioparm_status, ioparm_status_len, ioparm_access, ioparm_access_len,
	ioparm_form, ioparm_form_len, ioparm_blank, ioparm_blank_len,
	ioparm_position, ioparm_position_len, ioparm_action,
	ioparm_action_len, ioparm_delim, ioparm_delim_len, ioparm_pad,
	ioparm_pad_len, ioparm_format, ioparm_format_len, ioparm_advance,
	ioparm_advance_len, ioparm_name, ioparm_name_len,
	ioparm_internal_unit, ioparm_internal_unit_len,
	ioparm_internal_unit_desc, ioparm_sequential, ioparm_sequential_len,
	ioparm_direct, ioparm_direct_len, ioparm_formatted,
	ioparm_formatted_len, ioparm_unformatted, ioparm_unformatted_len,
	ioparm_read, ioparm_read_len, ioparm_write, ioparm_write_len,
	ioparm_readwrite, ioparm_readwrite_len, ioparm_namelist_name,
	ioparm_namelist_name_len, ioparm_namelist_read_mode, ioparm_iomsg,
	ioparm_iomsg_len, ioparm_var): Remove.
	(enum ioparam_type, enum iofield_type, enum iofield,
	enum iocall): New enums.
	(gfc_st_parameter_field, gfc_st_parameter): New typedefs.
	(st_parameter, st_parameter_field, iocall): New variables.
	(ADD_FIELD, ADD_STRING): Remove.
	(dt_parm, dt_post_end_block): New variables.
	(gfc_build_st_parameter): New function.
	(gfc_build_io_library_fndecls): Use it.  Initialize iocall
	array rather than ioparm_*, add extra first arguments to
	the function types.
	(set_parameter_const): New function.
	(set_parameter_value): Add type argument, return a bitmask.
	Changed to set a field in automatic structure variable rather
	than set a field in a global _gfortran_ioparm variable.
	(set_parameter_ref): Likewise.  If requested var has different
	size than what field should point to, call with a temporary and
	then copy into the user variable.  Add postblock argument.
	(set_string): Remove var_len argument, add type argument, return
	a bitmask.  Changed to set fields in automatic structure variable
	rather than set a field in a global _gfortran_ioparm variable.
	(set_internal_unit): Remove iunit, iunit_len, iunit_desc arguments,
	add var argument.  Return a bitmask.  Changed to set fields in
	automatic structure variable rather than set a field in a global
	_gfortran_ioparm variable.
	(set_flag): Removed.
	(io_result): Add var argument.  Changed to read common.flags field
	from automatic structure variable and bitwise AND it with 3.
	(set_error_locus): Add var argument.  Changed to set fields in
	automatic structure variable rather than set a field in a global
	_gfortran_{filename,line} variables.
	(gfc_trans_open): Use gfc_start_block rather than gfc_init_block.
	Create a temporary st_parameter_* structure.  Adjust callers of
	all above mentioned functions.  Pass address of the temporary
	variable as first argument to the generated function call.
	Use iocall array rather than ioparm_* separate variables.
	(gfc_trans_close, build_filepos, gfc_trans_inquire): Likewise.
	(build_dt): Likewise.  Change first argument to tree from tree *.
	Don't dereference code->ext.dt if last_dt == INQUIRE.  Emit
	IOLENGTH argument setup here.  Set dt_parm/dt_post_end_block
	variables and gfc_trans_code the nested data transfer commands
	in code->block.
	(gfc_trans_iolength): Just set last_dt and call build_dt immediately.
	(transfer_namelist_element): Pass address of dt_parm variable
	to generated functions.  Use iocall array rather than ioparm_*
	separate variables.
	(gfc_trans_backspace, gfc_trans_endfile, gfc_trans_rewind,
	gfc_trans_flush, gfc_trans_read, gfc_trans_write): Use iocall array
	rather than ioparm_* separate variables.
	(gfc_trans_dt_end): Likewise.  Pass address of dt_parm variable
	as first argument to generated function.  Adjust io_result caller.
	Prepend dt_post_end_block before io_result code.
	(transfer_expr): Use iocall array rather than ioparm_* separate
	variables.  Pass address of dt_parm variables as first argument
	to generated functions.
	* ioparm.def: New file.

2005-11-20  Toon Moene  <toon@moene.indiv.nluug.nl>

	* invoke.texi: Remove superfluous @item.

2005-11-20  Janne Blomqvist  <jb@gcc.gnu.org>

	PR fortran/24862
	* trans-io.c (gfc_trans_transfer): Handle arrays of derived type.

2005-11-17  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/20811
	* scanner.c (gfc_open_included_file): Add an extra include_cwd
	argument. Only include files in the current working directory if
	its value is true.
	* gfortran.h: Change prototype for gfc_open_included_file.
	(load_file): Don't search for include files in the current working
	directory.
	* options.c (gfc_post_options): Add the directory of the source file
	to the list of paths for included files.
	* module.c (gfc_use_module): Look for module files in the current
	directory.

2005-11-16  Alan Modra  <amodra@bigpond.net.au>

	PR fortran/24096
	* trans-types.c (gfc_init_kinds): Use one less for max_exponent
	of IBM extended double format.

2005-11-13  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* intrinsic.c (add_functions): Add COMPLEX, FTELL, FGETC, FGET,
	FPUTC, FPUT, AND, XOR and OR intrinsic functions.
	(add_subroutines): Add FGETC, FGET, FPUTC, FPUT and FTELL intrinsic
	subroutines.
	* gfortran.h: Add GFC_ISYM_AND, GFC_ISYM_COMPLEX, GFC_ISYM_FGET,
	GFC_ISYM_FGETC, GFC_ISYM_FPUT, GFC_ISYM_FPUTC, GFC_ISYM_FTELL,
	GFC_ISYM_OR, GFC_ISYM_XOR.
	* iresolve.c (gfc_resolve_and, gfc_resolve_complex,
	gfc_resolve_or, gfc_resolve_fgetc, gfc_resolve_fget,
	gfc_resolve_fputc, gfc_resolve_fput, gfc_resolve_ftell,
	gfc_resolve_xor, gfc_resolve_fgetc_sub, gfc_resolve_fget_sub,
	gfc_resolve_fputc_sub, gfc_resolve_fput_sub, gfc_resolve_ftell_sub):
	New functions.
	* check.c (gfc_check_complex, gfc_check_fgetputc_sub,
	gfc_check_fgetputc, gfc_check_fgetput_sub, gfc_check_fgetput,
	gfc_check_ftell, gfc_check_ftell_sub, gfc_check_and): New functions.
	* simplify.c (gfc_simplify_and, gfc_simplify_complex, gfc_simplify_or,
	gfc_simplify_xor): New functions.
	* trans-intrinsic.c (gfc_conv_intrinsic_function): Add cases for
	GFC_ISYM_AND, GFC_ISYM_COMPLEX, GFC_ISYM_FGET, GFC_ISYM_FGETC,
	GFC_ISYM_FPUT, GFC_ISYM_FPUTC, GFC_ISYM_FTELL, GFC_ISYM_OR and
	GFC_ISYM_XOR.
	* intrinsic.h: Add prototypes for all functions added to iresolve.c,
	simplify.c and check.c.

2005-11-10  Paul Thomas  <pault@gcc.gnu.org>
	    Steven G. Kargl <kargls@comcast.net>

	PR fortran/15976
	* resolve.c (resolve_symbol): Disallow automatic arrays in module scope.

2005-11-10  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/24655
	PR fortran/24755
	* match.c (recursive_stmt_fcn): Add checks that symtree exists
	for the expression to weed out inline intrinsic functions and
	parameters.

	PR fortran/24409
	* module.c (mio_symtree_ref): Correct the patch of 0923 so that
	a symbol is not substituted for by a the symbol for the module
	itself and to prevent the promotion of a formal argument.

2005-11-10  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/24643
	* primary.c (match_varspec): Check for implicitly typed CHARACTER
	variables before matching substrings.

2005-11-09  Steven G. Kargl  <kargls@comcast.net>

	* trans-intrinsic.c: Typo in comment.

2005-11-09  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/22607
	* trans-decl.c(build_function_decl): Don't set
	DECL_IS_PURE (fndecl) = 1 for return-by-reference
	functions.

2005-11-08  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* dump-parse-tree.c: Fix comment typo, add a few blank lines.

2005-11-07  Steven G. Kargl  <kargls@comcast.net>

	* error.c: Use flag_fatal_error.
	* invoke.texi:  Remove -Werror from list of options.

2005-11-06  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/24534
	* resolve.c (resolve_symbol): Exclude case of PRIVATE declared
	within derived type from error associated with PRIVATE type
	components within derived type.

	PR fortran/20838
	PR fortran/20840
	* gfortran.h: Add prototype for gfc_has_vector_index.
	* io.c (gfc_resolve_dt): Error if internal unit has a vector index.
	* expr.c (gfc_has_vector_index): New function to check if any of
	the array references of an expression have vector inidices.
	(gfc_check_pointer_assign): Error if internal unit has a vector index.

	PR fortran/17737
	* data.c (gfc_assign_data_value): Remove gcc_assert that caused the ICE
	and replace by a standard dependent warning/error if overwriting an
	existing initialization.
	* decl.c (gfc_data_variable): Remove old error for already initialized
	variable and the unused error check for common block variables.  Add
	error for hots associated variable and standard dependent error for
	common block variables, outside of blockdata.
	* symbol.c (check_conflict): Add constraints for DATA statement.

2005-11-06  Janne Blomqvist <jb@gcc.gnu.org>

	PR fortran/24174
	PR fortran/24305
	* fortran/trans-io.c (gfc_build_io_library_fndecls): Add kind
	argument to transfer_array.
	(transfer_array_desc): Add kind argument.

2005-11-06  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* intrinsic.c (add_functions): Add ctime and fdate intrinsics.
	(add_subroutines): Likewise.
	* intrinsic.h: Prototypes for gfc_check_ctime,
	gfc_check_ctime_sub, gfc_check_fdate_sub, gfc_resolve_ctime,
	gfc_resolve_fdate, gfc_resolve_ctime_sub, gfc_resolve_fdate_sub.
	* gfortran.h: Add GFC_ISYM_CTIME and GFC_ISYM_FDATE.
	* iresolve.c (gfc_resolve_ctime, gfc_resolve_fdate,
	gfc_resolve_ctime_sub, gfc_resolve_fdate_sub): New functions.
	* trans-decl.c (gfc_build_intrinsic_function_decls): Add
	gfor_fndecl_fdate and gfor_fndecl_ctime.
	* check.c (gfc_check_ctime, gfc_check_ctime_sub,
	gfc_check_fdate_sub): New functions.
	* trans-intrinsic.c (gfc_conv_intrinsic_ctime,
	gfc_conv_intrinsic_fdate): New functions.
	(gfc_conv_intrinsic_function): Add cases for GFC_ISYM_CTIME
	and GFC_ISYM_FDATE.
	* intrinsic.texi: Documentation for the new CTIME and FDATE
	intrinsics.
	* trans.h: Declarations for gfor_fndecl_ctime and gfor_fndecl_fdate.

2005-11-05  Kazu Hirata  <kazu@codesourcery.com>

	* decl.c, trans-decl.c: Fix comment typos.
	* gfortran.texi: Fix a typo.

2005-11-05  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* intrinsic.c (add_functions): Add function version of TTYNAM.
	* intrinsic.h: Add prototypes for gfc_check_ttynam and
	gfc_resolve_ttynam.
	* gfortran.h: Add case for GFC_ISYM_TTYNAM.
	* iresolve.c (gfc_resolve_ttynam): New function.
	* trans-decl.c (gfc_build_intrinsic_function_decls): Add a tree
	for function call to library ttynam.
	* check.c (gfc_check_ttynam): New function.
	* trans-intrinsic.c (gfc_conv_intrinsic_ttynam): New function.
	(): Call gfc_conv_intrinsic_ttynam.
	* trans.h: Add prototype for gfor_fndecl_ttynam.

2005-11-04  Steven G. Kargl <kargls@comcast.net>

	PR fortran/24636
	* match.c (gfc_match_stopcode):  Set stop_code = -1.

2005-11-04  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/18452
	* lang-specs.h: Pass -lang-fortran to the preprocessor.

2005-11-02  Andrew Pinski  <pinskia@physics.uc.edu>

	PR fortran/18157
	* trans-array.c (gfc_conv_resolve_dependencies): Use the correct
	type for the temporary array.
	* trans-expr.c (gfc_trans_assignment): Pass lss
	instead of lss_section
	to gfc_conv_resolve_dependencies to get the
	correct type.

2005-11-02  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* decl.c (gfc_match_entry): Function entries don't need an argument
	list if there's no RESULT clause.

2005-11-01  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/24008
	* decl.c (gfc_match_entry): Function entries need an argument list.

2005-11-01  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR 24245
	* trans.c (gfc_generate_code): Move code to create a main
	program symbol from here ...
	* parse.c (main_program_symbol): ... to this new
	function, setting the locus from gfc_current_locus
	instead of ns->code->loc.
	(gfc_parse_file):  Call main_program_symbol for main programs.

2005-11-01  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/24404
	* resolve.c (resolve_symbol): Output symbol names in more error
	messages, clarify error message.

2005-11-01  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* dump-parse-tree.c (show_symtree): Revert change unintentionally
	committed in r106246.

2005-11-01  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/21565
	* symbol.c (check_conflict): An object cannot be in a namelist and in
	block data.

	PR fortran/18737
	* resolve.c (resolve_symbol): Set the error flag to
	gfc_set_default_type, in the case of an external symbol, so that
	an error message is emitted if IMPLICIT NONE is set.

	PR fortran/14994
	* gfortran.h (gfc_generic_isym_id): Add GFC_ISYM_SECNDS to enum.
	* check.c (gfc_check_secnds): New function.
	* intrinsic.c (add_functions): Add call to secnds.
	* iresolve.c (gfc_resolve_secnds): New function.
	* trans-intrinsic (gfc_conv_intrinsic_function): Add call to
	secnds via case GFC_ISYM_SECNDS.
	* intrinsic.texi: Add documentation for secnds.

2005-10-31  Andreas Schwab  <schwab@suse.de>

	* Make-lang.in (GFORTRAN_TARGET_INSTALL_NAME): Define.
	(GFORTRAN_CROSS_NAME): Remove.
	(fortran.install-common): Correctly install a cross compiler.
	(fortran.uninstall): Use GFORTRAN_TARGET_INSTALL_NAME instead of
	GFORTRAN_CROSS_NAME.

2005-10-30  Erik Edelmann  <eedelman@gcc.gnu.org>

	* gfortran.texi: Update contributors.

2005-10-30  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/18883
	* trans-decl.c (gfc_finish_var_decl): Add decl to the
	current function, rather than the parent.  Make
	assertion accept fake result variables.
	* trans-expr.c (gfc_conv_variable): If the character
	length of an ENTRY isn't set, get the length from
	the master function instead.

2005-10-30  Thomas Koenig  <Thomas.Koenig@online.de>

	* gfortran.texi:  Remove reservations about I/O usability.  Document
	that array intrinsics mostly work.

2005-10-30  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.texi: Move license stuff to back.  Add information
	on ENUM and ENUMERATOR.
	* invoke.texi: Document -fshort-enums.

2005-10-30  Gaurav Gautam  <gauravga@noida.hcltech.com>
	    Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* arith.c (gfc_enum_initializer): New function.
	(gfc_check_integer_range): Made extern.
	* decl.c (enumerator_history): New typedef.
	(last_initializer, enum_history, max_enum): New variables.
	(create_enum_history, gfc_free_enum_history): New functions.
	(add_init_expr_to_sym): Call create_enum_history if parsing ENUM.
	(variable_decl): Modified to parse enumerator definition.
	(match_attr_spec): Add PARAMETER attribute to ENUMERATORs.
	(gfc_match_data_decl): Issues error, if match_type_spec do not
	return desired return values.
	(set_enum_kind, gfc_match_enum, gfc_match_enumerator_def): New
	functions.
	(gfc_match_end): Deal with END ENUM.
	* gfortran.h (gfc_statement): ST_ENUM, ST_ENUMERATOR, ST_END_ENUM
	added.
	(symbol_attribute): Bit field for enumerator added.
	(gfc_options): Add fshort_enums.
	(gfc_enum_initializer, gfc_check_integer_range): Add prototypes.
	* options.c: Include target.h
	(gfc_init_options): Initialize fshort_enums.
	(gfc_handle_option): Deal with fshort_enums.
	* parse.c (decode_statement): Match ENUM and ENUMERATOR statement.
	(gfc_ascii_statement): Deal with the enumerator statements.
	(parse_enum): New function to parse enum construct.
	(parse_spec): Added case ST_ENUM.
	* parse.h (gfc_compile_state): COMP_ENUM added.
	(gfc_match_enum, gfc_match_enumerator_def, gfc_free_enum_history):
	Prototype added.
	* symbol.c (gfc_copy_attr): Copy enumeration attribute.
	* lang.opt (fshort-enums): Option added.

2005-10-30  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* check.c (gfc_check_malloc, gfc_check_free): New functions.
	* gfortran.h (gfc_generic_isym_id): Add GFC_ISYM_MALLOC.
	* intrinsic.c (add_functions): Add symbols for MALLOC function.
	(add_subroutines): Add symbol for FREE subroutine.
	* intrinsic.h: Prototypes for gfc_check_malloc, gfc_check_free,
	gfc_resolve_malloc and gfc_resolve_free.
	* intrinsic.texi: Add doc for FREE and MALLOC intrinsics.
	* iresolve.c (gfc_resolve_malloc, gfc_resolve_free): New
	functions.
	* trans-intrinsic.c (gfc_conv_intrinsic_function): Add case for
	GFC_ISYM_MALLOC.

2005-10-30  Steven Bosscher  <stevenb@suse.de>

	* gfortran.texi: Update contributors.

2005-10-29  Steven Bosscher  <stevenb@suse.de>

	* interface.c: Fix previous checkin (an incomplete patch
	was commited for me).

2005-10-29  Joseph S. Myers  <joseph@codesourcery.com>

	* intrinsic.texi: Remove empty @cindex line.

2005-10-28  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* check.c (gfc_check_alarm_sub, gfc_check_signal,
	gfc_check_signal_sub): New functions.
	* gfortran.h (gfc_generic_isym_id): Add GFC_ISYM_SIGNAL.
	* intrinsic.c (add_functions): Add signal intrinsic.
	(add_subroutines): Add signal and alarm intrinsics.
	* intrinsic.texi: Document the new intrinsics.
	* iresolve.c (gfc_resolve_signal, gfc_resolve_alarm_sub,
	gfc_resolve_signal_sub): New functions.
	* trans-intrinsic.c (gfc_conv_intrinsic_function): Add case
	for GFC_ISYM_SIGNAL.
	* intrinsic.h: Add prototypes for gfc_check_alarm_sub,
	gfc_check_signal, gfc_check_signal_sub, gfc_resolve_signal,
	gfc_resolve_alarm_sub, gfc_resolve_signal_sub.

2005-10-28  Steven Bosscher  <stevenb@suse.de>

	PR fortran/24545
	* interface.c (gfc_match_end_interface): Fix typo in 
	INTERFACE_USER_OP case.

2005-10-26  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/15586
	* resolve.c (resolve_symbol): Remove the use of whynot, so that
	error messages are not built from pieces.

2005-10-26  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/24158
	* decl.c (gfc_match_data_decl): Correct broken bit of code
	that prevents undefined derived types from being used as
	components of another derived type.
	* resolve.c (resolve_symbol): Add backstop error when derived
	type variables arrive here with a type that has no components.

2005-10-25  Jakub Jelinek  <jakub@redhat.com>

	* trans.h (gfc_conv_cray_pointee): Remove.
	* trans-expr.c (gfc_conv_variable): Revert 2005-10-24 change.
	* trans-array.c (gfc_conv_array_parameter): Likewise.
	* trans-decl.c (gfc_conv_cray_pointee): Remove.
	(gfc_finish_cray_pointee): New function.
	(gfc_finish_var_decl): Use it.  Don't return early for Cray
	pointees.
	(gfc_create_module_variable): Revert 2005-10-24 change.
	* decl.c (cray_pointer_decl): Update comment.
	* gfortran.texi: Don't mention Cray pointees aren't visible in the
	debugger.

	* symbol.c (check_conflict): Add conflict between cray_pointee
	and in_common resp. in_equivalence.
	* resolve.c (resolve_equivalence): Revert 2005-10-24 change.

	* module.c (ab_attribute): Add AB_CRAY_POINTER and AB_CRAY_POINTEE.
	(attr_bits): Likewise.
	(mio_symbol_attribute): Save and restore cray_pointe{r,e} attributes.
	(mio_symbol): For cray_pointee write/read cp_pointer reference.

2005-10-25  Feng Wang  <fengwang@nudt.edu.cn>

	PR fortran/22290
	* trans-decl.c (gfc_add_assign_aux_vars): New function. Add two
	auxiliary variables.
	(gfc_get_symbol_decl): Use it when a variable, including dummy
	argument, is assigned a label.
	(gfc_trans_assign_aux_var): New function. Set initial value of
	the auxiliary variable explicitly.
	(gfc_trans_deferred_vars): Use it.
	* trans-stmt.c (gfc_conv_label_variable): Handle dummy argument.

2005-10-24  Asher Langton  <langton2@llnl.gov>

	PR fortran/17031
	PR fortran/22282
	* check.c (gfc_check_loc): New function.
	* decl.c (variable_decl): New variables cp_as and sym.  Added a
	check for variables that have already been declared as Cray
	Pointers, so we can get the necessary attributes without adding
	a new symbol.
	(attr_decl1): Added code to catch pointee symbols and "fix"
	their array specs.
	(cray_pointer_decl): New method.
	(gfc_match_pointer): Added Cray pointer parsing code.
	(gfc_mod_pointee_as): New method.
	* expr.c (gfc_check_assign): Added a check to catch vector-type
	assignments to pointees with an unspecified final dimension.
	* gfortran.h: (GFC_ISYM_LOC): New.
	(symbol_attribute): Added cray_pointer and cray_pointee bits.
	(gfc_array_spec): Added cray_pointee and cp_was_assumed bools.
	(gfc_symbol): Added gfc_symbol *cp_pointer.
	(gfc_option): Added flag_cray_pointer.
	(gfc_add_cray_pointee): Declare.
	(gfc_add_cray_pointer ): Declare.
	(gfc_mod_pointee_as): Declare.
	* intrinsic.c (add_functions): Add code for loc() intrinsic.
	* intrinsic.h (gfc_check_loc): Declare.
	(gfc_resolve_loc): Declare.
	* iresolve.c (gfc_resolve_loc): New.
	* lang.opt: Added fcray-pointer flag.
	* options.c (gfc_init_options): Initialized.
	gfc_match_option.flag_cray_pointer.
	(gfc_handle_option): Deal with -fcray-pointer.
	* parse.c:(resolve_equivalence): Added code prohibiting Cray
	pointees in equivalence statements.
	* resolve.c (resolve_array_ref): Added code to prevent bounds
	checking for Cray Pointee arrays.
	(resolve_equivalence): Prohibited pointees in equivalence
	statements.
	* symbol.c (check_conflict): Added Cray pointer/pointee
	attribute checking.
	(gfc_add_cray_pointer): New.
	(gfc_add_cray_pointee): New.
	(gfc_copy_attr): New code for Cray pointers and pointees.
	* trans-array.c (gfc_trans_auto_array_allocation): Added code to
	prevent space from being allocated for pointees.
	(gfc_conv_array_parameter): Added code to catch pointees and
	correctly set their base address.
	* trans-decl.c (gfc_finish_var_decl): Added code to prevent
	pointee declarations from making it to the back end.
	(gfc_create_module_variable): Same.
	* trans-expr.c (gfc_conv_variable): Added code to detect and
	translate pointees.
	(gfc_conv_cray_pointee): New.
	* trans-intrinsic.c (gfc_conv_intrinsic_loc): New.
	(gfc_conv_intrinsic_function): Added entry point for loc
	translation.
	* trans.h (gfc_conv_cray_pointee): Declare.

	* gfortran.texi: Added section on Cray pointers, removed Cray
	pointers from list of proposed extensions.
	* intrinsic.texi: Added documentation for loc intrinsic.
	* invoke.texi: Documented -fcray-pointer flag.

2005-10-24  Asher Langton  <langton2@llnl.gov>

	* decl.c (gfc_match_save): Changed duplicate SAVE errors to
	warnings in the absence of strict standard conformance
	* symbol.c (gfc_add_save): Same.

2005-10-24  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/15586
	* arith.c (gfc_arith_error): Change message to include locus.
	(check_result, eval_intrinsic, gfc_int2int, gfc_real2real,
	gfc_real2complex, gfc_complex2real, gfc_complex2complex): Use
	the new gfc_arith_error.
	(arith_error): Rewrite full error messages instead of building
	them from pieces.
	* check.c (must_be): Removed.
	(type_check, numeric_check, int_or_real_check, real_or_complex_check,
	kind_check, double_check, logical_array_check, array_check,
	scalar_check, same_type_check, rank_check, kind_value_check,
	variable_check, gfc_check_allocated, gfc_check_associated,
	gfc_check_cmplx, gfc_check_dcmplx, gfc_check_dot_product,
	gfc_check_index, gfc_check_kind, gfc_check_matmul, gfc_check_null,
	gfc_check_pack, gfc_check_precision, gfc_check_present,
	gfc_check_spread): Rewrite full error messages instead of
	building them from pieces.
	* decl.c (gfc_match_entry): Rewrite full error messages instead
	of building them from pieces.
	* parse.c (gfc_state_name): Remove.
	* parse.h: Remove prototype for gfc_state_name.

2005-10-23  Andrew Pinski  <pinskia@physics.uc.edu>

	PR fortran/23635
	* check.c (gfc_check_ichar_iachar): Move the code around so
	that the check on the length is after check for
	references.

2005-10-23  Asher Langton  <langton2@llnl.gov>

	* decl.c (match_type_spec): Add a BYTE type as an extension.

2005-10-23  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/18022
	* trans-expr.c (gfc_trans_arrayfunc_assign): Return NULL
	if there is a component ref during an array ref to force
	use of temporary in assignment.

	PR fortran/24311
	PR fortran/24384
	* fortran/iresolve.c (check_charlen_present): New function to
	add a charlen to the typespec, in the case of constant
	expressions.
	(gfc_resolve_merge, gfc_resolve_spread): Call.the above.
	(gfc_resolve_spread): Make calls to library functions that
	handle the case of the spread intrinsic with a scalar source.

2005-10-22  Erik Edelmann  <eedelman@gcc.gnu.org>

	PR fortran/24426
	* decl.c (variable_decl): Don't assign default initializers to
	pointers.

2005-10-21  Jakub Jelinek  <jakub@redhat.com>

	* interface.c (compare_actual_formal): Issue error when attempting
	to pass an assumed-size array as assumed-shape array argument.

2005-10-20  Erik Edelmann  <erik.edelmann@iki.fi>

	PR fortran/21625
	* resolve.c (expr_to_initialize): New function.
	(resolve_allocate_expr): Take current statement as new
	argument. Add default initializers to variables of
	derived types, if they need it.
	(resolve_code): Provide current statement as argument to
	resolve_allocate_expr().

2005-10-19  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/24440
	* resolve.c (resolve_symbol): Correct error in check for
	assumed size array with default initializer by testing
	for arrayspec before dereferencing it.

2005-10-17  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/23446
	* gfortran.h: Primitive for gfc_is_formal_arg.
	* resolve.c(gfc_is_formal_arg): New function to signal across
	several function calls that formal argument lists are being
	processed.
	(resolve_formal_arglist): Set/reset the flag for gfc_is_formal_arg.
	*expr.c(check_restricted): Add check, via gfc_is_formal_arg, if
	symbol is part of an formal argument declaration.

	PR fortran/21459
	* decl.c (add_init_expr_to_sym): Make a new character
	length for each variable, when the expression is NULL
	and link to cl_list.

	PR fortran/20866
	* match.c (recursive_stmt_fcn): New function that tests if
	a statement function resurses through itself or other other
	statement functions.
	(gfc_match_st_function): Call recursive_stmt_fcn to check
	if this is recursive and to raise error if so.

	PR fortran/20849
	PR fortran/20853
	* resolve.c (resolve_symbol): Errors for assumed size arrays
	with default initializer and for external objects with an
	initializer.

	PR fortran/20837
	* decl.c (match_attr_spec): Prevent PUBLIC from being used
	outside a module.

2005-10-16  Erik Edelmann  <erik.edelmann@iki.fi>

	PR 22273
	* expr.c (check_inquiry): Add "len" to inquiry_function.

2005-10-14  Jakub Jelinek  <jakub@redhat.com>

	* primary.c (match_boz_constant): Add missing break after gfc_error.

2005-10-12  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/24092
	* trans-types.c (gfc_get_derived_type): Insert code to obtain backend
	declaration for derived types, building if necessary.  Return the
	derived type if the fields have been built by this process.  Otherwise,
	continue as before but using the already obtained backend_decls for the
	derived type components.  Change the gcc_assert to act on the field.

2005-10-12  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/18082
	* decl.c (variable_decl): Make a new copy of the character
	length for each variable, when the expression is not a
	constant.

2005-10-12  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* gfortran.h: Add bitmasks for different FPE traps. Add fpe
	member to options_t.
	* invoke.texi: Document the new -ffpe-trap option.
	* lang.opt: Add -ffpe-trap option.
	* options.c (gfc_init_options): Initialize the FPE option.
	(gfc_handle_fpe_trap_option): New function to parse the argument
	of the -ffpe-trap option.
	(gfc_handle_option): Add case for -ffpe-trap.
	* trans-decl.c: Declare a tree for the set_fpe library function.
	(gfc_build_builtin_function_decls): Build this tree.
	(gfc_generate_function_code): Generate a call to set_fpe at
	the beginning of the main program.
	* trans.h: New tree for the set_fpe library function.

2005-10-12  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/20847
	PR fortran/20856
	* symbol.c (check_conflict): Prevent common variables and
	function results from having the SAVE attribute,as required
	by the standard.

2005-10-12  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/24207
	* resolve.c (resolve_symbol): Exclude use and host associated
	symbols from the test for private objects in a public namelist.

2005-10-12  Jakub Jelinek  <jakub@redhat.com>

	* trans-common.c (build_field): Fix comment typo.
	(create_common): Set backend_decl of COMMON or EQUIVALENCEd
	variables to a VAR_DECL with the COMPONENT_REF in
	DECL_HAS_VALUE_EXPR rather than COMPONENT_REF directly.
	* f95-lang.c (gfc_expand_function): Emit debug info for
	EQUIVALENCEd variables if the equiv union is going to be output.

2005-10-11  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/20786
	* iresolve.c (gfc_resolve_aint, gfc_resolve_anint): Type conversion
	of the argument.

2005-10-11  Jakub Jelinek  <jakub@redhat.com>

	* f95-lang.c (gfc_init_decl_processing): Initialize
	void_list_node.

2005-10-07  Erik Edelmann  <erik.edelmann@iki.fi>

	PR 18568
	* resolve.c (find_array_spec): Search through the list of
	components in the symbol of the type instead of the symbol of the
	variable.

2005-10-05  Richard Guenther  <rguenther@suse.de>

	PR fortran/24176
	* parse.c (gfc_parse_file): Exit early for empty files.

2005-10-03  Steve Ellcey  <sje@cup.hp.com>

	* fortran/trans-types.c (gfc_init_kinds): Only pass float, double,
	and long double floating point types through to Fortran compiler.

2005-10-03  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/20120
	* f95-lang.c (DO_DEFINE_MATH_BUILTIN): Add support for long
	double builtin function.
	(gfc_init_builtin_functions): Add mfunc_longdouble,
	mfunc_clongdouble and func_clongdouble_longdouble trees. Build
	them for round, trunc, cabs, copysign and pow functions.
	* iresolve.c (gfc_resolve_reshape, gfc_resolve_transpose): Add
	case for kind 10 and 16.
	* trans-decl.c: Add trees for cpowl10, cpowl16, ishftc16,
	exponent10 and exponent16.
	(gfc_build_intrinsic_function_decls): Build nodes for int16,
	real10, real16, complex10 and complex16 types. Build all possible
	combinations for function _gfortran_pow_?n_?n. Build function
	calls cpowl10, cpowl16, ishftc16, exponent10 and exponent16.
	* trans-expr.c (gfc_conv_power_op): Add case for integer(16),
	real(10) and real(16).
	* trans-intrinsic.c: Add suppport for long double builtin
	functions in BUILT_IN_FUNCTION, LIBM_FUNCTION and LIBF_FUNCTION
	macros.
	(gfc_conv_intrinsic_aint): Add case for integer(16), real(10) and
	real(16) kinds.
	(gfc_build_intrinsic_lib_fndecls): Add support for real10_decl
	and real16_decl in library functions.
	(gfc_get_intrinsic_lib_fndecl): Add cases for real and complex
	kinds 10 and 16.
	(gfc_conv_intrinsic_exponent): Add cases for real(10) and real(16)
	kinds.
	(gfc_conv_intrinsic_sign): Likewise.
	(gfc_conv_intrinsic_ishftc): Add case for integer(16) kind.
	* trans-types.c (gfc_get_int_type, gfc_get_real_type,
	gfc_get_complex_type, gfc_get_logical_type): Doesn't error out in
	the case of kinds not available.
	* trans.h: Declare trees for cpowl10, cpowl16, ishftc16,
	exponent10 and exponent16.

2005-10-01  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/16404
	PR fortran/20835
	PR fortran/20890
	PR fortran/20899
	PR fortran/20900
	PR fortran/20901
	PR fortran/20902
	* gfortran.h: Prototype for gfc_add_in_equivalence.
	* match.c (gfc_match_equivalence): Make a structure component
	an explicit,rather than a syntax, error in an equivalence
	group.  Call gfc_add_in_equivalence to add the constraints
	imposed in check_conflict.
	* resolve.c (resolve_symbol): Add constraints: No public
	structures with private-type components and no public
	procedures with private-type dummy arguments.
	(resolve_equivalence_derived): Add constraint that prevents
	a structure equivalence member from having a default
	initializer.
	(sequence_type): New static function to determine whether an
	object is default numeric, default character, non-default
	or mixed sequence. Add corresponding enum typespec.
	(resolve_equivalence): Add constraints to equivalence groups
	or their members: No more than one initialized member and
	that different types are not equivalenced for std=f95.  All
	the simple constraints have been moved to check_conflict.
	* symbol.c (check_conflict): Simple equivalence constraints
	added, including those removed from resolve_symbol.
	(gfc_add_in_equivalence): New function to interface calls
	match_equivalence to check_conflict.

2005-09-27  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/18518
	* trans-common.c (build_equiv_decl): Add IS_SAVED argument.
	If it is true, set TREE_STATIC on the decl.
	(create_common): If any symbol in equivalence has SAVE attribute,
	pass true as last argument to build_equiv_decl.

2005-09-24  Janne Blomqvist  <jblomqvi@cc.hut.fi>

	* trans-io.c (gfc_build_io_library_fndecls): Add entry
	iocall_x_array for transfer_array.
	(transfer_array_desc): New function.
	(gfc_trans_transfer): Add code to call transfer_array_desc.

2005-09-26  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/23677
	* symbol.c (gfc_is_var_automatic): Return true if character length
	is non-constant rather than constant.
	* resolve.c (gfc_resolve): Don't handle !gfc_option.flag_automatic
	here.
	* options.c (gfc_post_options): Set gfc_option.flag_max_stack_var_size
	to 0 for -fno-automatic.

2005-09-23  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/16861
	* module.c (mio_component_ref): Return if the symbol is NULL
	and wait for another iteration during module reads.
	(mio_symtree_ref): Suppress the writing of contained symbols,
	when a symbol is available in the main namespace.
	(read_module): Restrict scope of special treatment of contained
	symbols to variables only and suppress redundant call to
	find_true_name.

2005-09-22  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/24005
	* interface.c (check_interface1): Fix NULL dereference.

2005-09-22  Erik Edelmann  <erik.edelmann@iki.fi>

	PR fortran/23843
	* resolve.c (derived_inaccessible): New function.
	(resolve_transfer): Use it to check for private
	components.

2005-09-22  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/23516
	* intrinsic.c (add_function): Add IMAG, IMAGPART, and REALPART
	intrinsics.
	* intrinsic.h: Prototypes for gfc_simplify_realpart and
	gfc_resolve_realpart.
	* intrinsic.texi: Document intrinsic procedures.
	* simplify.c (gfc_simplify_realpart): New function.
	* irseolve.c (gfc_resolve_realpart): New function.

2005-09-21  Erik Edelmann  <erik.edelmann@iki.fi>

	PR fortran/19929
	* trans-stmt.c (gfc_trans_deallocate): Check if the
	object to be deallocated is an array by looking at
	expr->rank instead of expr->symtree->n.sym->attr.dimension.

2005-09-20  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/23420
	* io.c (resolve_tag): Don't allow non-CHARACTER constants as formats.
	(match_io): Fix usage of gfc_find_symbol.

2005-09-20  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/23663
	* primary.c (match_actual_arg): Handle ENTRY the same way
	as FUNCTION.

2005-09-18  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* Make-lang.in: Make check-fortran alias for check-gfortran.

2005-09-18  Andreas Jaeger  <aj@suse.de>

	* module.c (read_module): Add missed line from last patch.

2005-09-18  Erik Edelmann  <erik.edelmann@iki.fi>

	PR fortran/15975
	* resolve.c (resolve_symbol): Don't assign default
	initializer to pointers.

2005-09-18  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/16861
	* module.c (read_module): Give symbols from module procedures
	different true_name entries to those from the module proper.

2005-09-17  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/15586
	* arith.c (gfc_arith_error): Add translation support for error
	messages.
	* array.c (gfc_match_array_ref): Likewise.
	(gfc_match_array_spec): Likewise.
	* check.c (must_be): Add msgid convention to third argument.
	(same_type_check): Add translation support for error message.
	(rank_check): Likewise.
	(kind_value_check): Likewise.
	(gfc_check_associated): Correct typo.
	(gfc_check_reshape): Add translation support for error message.
	(gfc_check_spread): Likewise.
	* error.c (error_printf): Add nocmsgid convention to argument.
	(gfc_warning, gfc_notify_std, gfc_warning_now, gfc_warning_check)
	(gfc_error, gfc_error_now): Likewise.
	(gfc_status): Add cmsgid convention to argument.
	* expr.c (gfc_extract_int): Add translation support for error
	messages.
	(gfc_check_conformance): Add msgid convention to argument.
	(gfc_check_pointer_assign): Correct tabbing.
	* gfortran.h: Include intl.h header. Remove prototype for gfc_article.
	* gfortranspec.c: Include intl.h header.
	(lang_specific_driver): Add translation support for --version.
	* io.c (check_format): Add translation support for error message.
	(format_item_1): Likewise.
	(data_desc): Likewise.
	* matchexp.c: Likewise.
	* misc.c (gfc_article): Remove function.
	* module.c (bad_module): Use msgid convention. Add translation support
	for error messages.
	(require_atom): Add translation support for error messages.
	* parse.c (gfc_ascii_statement): Likewise.
	(gfc_state_name): Likewise.
	* primary.c (match_boz_constant): Reorganise error messages for
	translations.
	* resolve.c (resolve_entries): Likewise.
	(resolve_operator): Add translation support for error messages.
	(gfc_resolve_expr): Use msgid convention. Reorganise error messages
	for translations.
	(resolve_symbol): Add translation support for error messages.
	* symbol.c (gfc_add_procedure): Remove use of gfc_article function.
	* trans-const.c (gfc_build_string_const): Use msgid convention.

2005-09-16  Paul Brook  <paul@codesourcery.com>

	PR fortran/23906
	* dependency.c (transform_sections): Divide by correct value.
	Elaborate comment.

2005-09-14  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/21875 Internal Unit Array I/O, NIST
	* fortran/trans-io.c (gfc_build_io_library_fndecls): Add field for
	array descriptor to IOPARM structure.
	* fortran/trans-io.c (set_internal_unit): New function to generate code
	to store the character (array) and the character length for an internal
	unit.
	* fortran/trans-io (build_dt): Use the new function set_internal_unit.

2005-09-14  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/19358
	* trans-array.c (gfc_trans_dummy_array_bias): correct the typo
	which uses dim[i].upper for lbound, rather than dim[i].lower.

2005-09-13  Erik Edelmann  <erik.edelmann@iki.fi>

	PR fortran/17740
	* trans-expr.c (gfc_trans_arrayfunc_assign): Check value
	of attr.elemental for specific function instead of generic name.

2005-09-13  Richard Sandiford  <richard@codesourcery.com>

	PR fortran/18899
	* trans-intrinsic.c (gfc_conv_intrinsic_bound): Move initialization
	of argse.  Remove now-redundant want_pointer assignment.
	* trans-array.c (gfc_conv_expr_descriptor): When not assigning to
	a pointer, keep the original bounds of a full array reference.

2005-09-13  Richard Sandiford  <richard@codesourcery.com>

	PR target/19269
	* iresolve.c (gfc_resolve_cshift, gfc_resolve_eoshift)
	(gfc_resolve_pack, gfc_resolve_reshape, gfc_resolve_spread)
	(gfc_resolve_transpose, gfc_resolve_unpack): Add "_char" to the name
	for character-based operations.
	(gfc_resolve_pack): Remove ATTRIBUTE_UNUSED from array argument.
	(gfc_resolve_unpack): Copy the whole typespec from the vector.
	* trans-array.c (gfc_conv_expr_descriptor): In the EXPR_FUNCTION
	case, get the string length from the scalarization state.

2005-09-14  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* Make-lang.in: Change targets prefixes from f95 to fortran.
	* config-lang.in: Change language name to "fortran".
	* lang.opt: Change language name to "fortran".
	* options.c: Change CL_F95 to CL_Fortran.

2005-09-09  Thomas Koenig  <Thomas.Koenig@online.de>

	gfortran.texi:  Document IOSTAT= specifier.

2005-09-09  Thomas Koenig  <Thomas.Koenig@online.de>

	* gfortran.h:  Add iomsg to gfc_open, gfc_close, gfc_filepos,
	gfc_inquire and gfc_dt.
	* dump-parse-tree.c (gfc_show_code_node):  Add iomsg
	for open, close, file positioning, inquire and namelist.
	* io.c (io_tag):  Add tag_iomsg.
	(resolve_tag): Add standards warning for iomsg.
	(match_open_element):  Add iomsg.
	(gfc_free_open):  Add iomsg.
	(gfc_resolve_open):  Add iomsg.
	(gfc_free_close):  Add iomsg.
	(match_close_element):  Add iomsg.
	(gfc_resolve_close):  Add iomsg.
	(gfc_free_filepos):  Add iomsg.
	(match_file_element):  Add iomsg.
	(gfc_resolve_filepos):  Add iostat and iomsg.
	(match-dt_element):  Add iomsg.
	(gfc_free_dt):  Add iomsg.
	(gfc_resolve_dt):  Add iomsg.
	(gfc_free_inquire):  Add iomsg.
	(match_inquire_element):  Add iomsg.
	(gfc_resolve_inquire):  Add iomsg.
	* trans_io.c:  Add ioparm_iomsg and ioparm_iomsg_len.
	(gfc_build_io_library_fndecls):  Add iomsg as last field.
	(gfc_trans_open):  Add iomsg.
	(gfc_trans_close):  Add iomsg.
	(build_fileos):  Call set_string for iomsg.
	(gfc_trans_inquire):  Add iomsg.
	(build_dt):  Add iomsg.

2005-09-09  Richard Sandiford  <richard@codesourcery.com>

	* match.h (gfc_match_equiv_variable): Declare.

2005-09-09  Richard Sandiford  <richard@codesourcery.com>

	PR fortran/19239
	* Makefile.in (fortran/trans-expr.o): Depend on dependency.h.
	* dependency.h (gfc_ref_needs_temporary_p): Declare.
	* dependency.c (gfc_ref_needs_temporary_p): New function.
	(gfc_check_fncall_dependency): Use it instead of inlined check.
	By so doing, take advantage of the fact that character substrings
	within an array reference also need a temporary.
	* trans.h (GFC_SS_VECTOR): Adjust comment.
	* trans-array.c (gfc_free_ss): Remove GFC_SS_VECTOR case.
	(gfc_set_vector_loop_bounds): New function.
	(gfc_add_loop_ss_code): Call it after evaluating the subscripts of
	a GFC_SS_SECTION.  Deal with the GFC_SS_VECTOR case by evaluating
	the vector expression and caching its descriptor for use within
	the loop.
	(gfc_conv_array_index_ref, gfc_conv_vector_array_index): Delete.
	(gfc_conv_array_index_offset): Handle scalar, vector and range
	dimensions as separate cases of a switch statement.  In the vector
	case, use the loop variable to calculate a vector index and use the
	referenced element as the dimension's index.  Perform bounds checking
	on this final index.
	(gfc_conv_section_upper_bound): Return null for vector indexes.
	(gfc_conv_section_startstride): Give vector indexes a start value
	of 0 and a stride of 1.
	(gfc_conv_ss_startstride): Adjust for new GFC_SS_VECTOR representation.
	(gfc_conv_expr_descriptor): Expand comments.  Generalize the
	handling of the !want_pointer && !direct_byref case.  Use
	gfc_ref_needs_temporary_p to decide whether the variable case
	needs a temporary.
	(gfc_walk_variable_expr): Handle DIMEN_VECTOR by creating a
	GFC_SS_VECTOR index.
	* trans-expr.c: Include dependency.h.
	(gfc_trans_arrayfunc_assign): Fail if the target needs a temporary.

2005-09-09  Richard Sandiford  <richard@codesourcery.com>

	PR fortran/21104
	* trans.h (gfc_interface_sym_mapping, gfc_interface_mapping): Moved
	from trans-expr.c.
	(gfc_init_interface_mapping, gfc_free_interface_mapping)
	(gfc_add_interface_mapping, gfc_finish_interface_mapping)
	(gfc_apply_interface_mapping): Declare.
	* trans-array.h (gfc_set_loop_bounds_from_array_spec): Declare.
	(gfc_trans_allocate_temp_array): Add pre and post block arguments.
	* trans-array.c (gfc_set_loop_bounds_from_array_spec): New function.
	(gfc_trans_allocate_array_storage): Replace loop argument with
	separate pre and post blocks.
	(gfc_trans_allocate_temp_array): Add pre and post block arguments.
	Update call to gfc_trans_allocate_array_storage.
	(gfc_trans_array_constructor, gfc_conv_loop_setup): Adjust for new
	interface to gfc_trans_allocate_temp_array.
	* trans-expr.c (gfc_interface_sym_mapping, gfc_interface_mapping):
	Moved to trans.h.
	(gfc_init_interface_mapping, gfc_free_interface_mapping)
	(gfc_add_interface_mapping, gfc_finish_interface_mapping)
	(gfc_apply_interface_mapping): Make extern.
	(gfc_conv_function_call): Build an interface mapping for array
	return values too.  Call gfc_set_loop_bounds_from_array_spec.
	Adjust call to gfc_trans_allocate_temp_array so that code is
	added to SE rather than LOOP.

2005-09-09  Richard Sandiford  <richard@codesourcery.com>

	PR fortran/12840
	* trans.h (gfor_fndecl_internal_realloc): Declare.
	(gfor_fndecl_internal_realloc64): Declare.
	* trans-decl.c (gfor_fndecl_internal_realloc): New variable.
	(gfor_fndecl_internal_realloc64): New variable.
	(gfc_build_builtin_function_decls): Initialize them.
	* trans-array.h (gfc_trans_allocate_temp_array): Add a fourth argument.
	* trans-array.c (gfc_trans_allocate_array_storage): Add an argument
	to say whether the array can grow later.  Don't allocate the array
	on the stack if so.  Don't call malloc for zero-sized arrays.
	(gfc_trans_allocate_temp_array): Add a similar argument here.
	Pass it along to gfc_trans_allocate_array_storage.
	(gfc_get_iteration_count, gfc_grow_array): New functions.
	(gfc_iterator_has_dynamic_bounds): New function.
	(gfc_get_array_constructor_element_size): New function.
	(gfc_get_array_constructor_size): New function.
	(gfc_trans_array_ctor_element): Replace pointer argument with
	a descriptor tree.
	(gfc_trans_array_constructor_subarray): Likewise.  Take an extra
	argument to say whether the variable-sized part of the constructor
	must be allocated using realloc.  Grow the array when this
	argument is true.
	(gfc_trans_array_constructor_value): Likewise.
	(gfc_get_array_cons_size): Delete.
	(gfc_trans_array_constructor): If the loop bound has not been set,
	split the allocation into a static part and a dynamic part.  Set
	loop->to to the bounds for static part before allocating the
	temporary.  Adjust call to gfc_trans_array_constructor_value.
	(gfc_conv_loop_setup): Allow any constructor to determine the
	loop bounds.  Check whether the constructor has a dynamic size
	and prefer to use something else if so.  Expect the loop bound
	to be set later.  Adjust call to gfc_trans_allocate_temp_array.
	* trans-expr.c (gfc_conv_function_call): Adjust another call here.

2005-09-09  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/18878
	* module.c (find_use_name_n): Based on original
	find_use_name. Either counts number of use names for a
	given real name or returns use name n.
	(find_use_name, number_use_names): Interfaces to the
	function find_use_name_n.
	(read_module): Add the logic and calls to these functions,
	so that mutiple reuses of the same real name are loaded.

2005-09-09  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/22304
	PR fortran/23270
	PR fortran/18870
	PR fortran/16511
	PR fortran/17917
	* gfortran.h: Move definition of BLANK_COMMON_NAME from trans-
	common.c so that it is accessible to module.c. Add common_head
	field to gfc_symbol structure. Add field for the equivalence
	name AND new attr field, in_equivalence.
	* match.c (gfc_match_common, gfc_match_equivalence): In loops
	that flag common block equivalences, emit an error if the
	common blocks are different, using sym->common_head as the
	common block identifier. Ensure that symbols that are equivalence
	associated with a common block are marked as being in_common.
	* module.c (write_blank_common): New.
	(write_common): Use unmangled common block name.
	(load_equiv): New function ported from g95.
	(read_module): Call load_equiv.
	(write_equiv): New function ported from g95. Correct
	string referencing for gfc functions. Give module
	equivalences a unique name.
	(write_module): Call write_equiv and write_blank_common.
	* primary.c (match_variable) Old gfc_match_variable, made
	static and third argument provided to indicate if parent
	namespace to be visited or not.
	(gfc_match_variable) New. Interface to match_variable.
	(gfc_match_equiv_variable) New. Interface to match_variable.
	* trans-common.c (finish_equivalences): Provide the call
	to create_common with a gfc_common_header so that
	module equivalences are made external, rather than local.
	(find_equivalences): Ensure that all members in common block
	equivalences are marked as used. This prevents the subsequent
	call to this function from making local unions.
	* trans-decl.c (gfc_generate_function_code): Move the call to
	gfc_generate_contained_functions to after the call to
	gfc_trans_common so the use-associated, contained common
	blocks produce the correct references.
	(gfc_create_module_variable): Return for equivalenced symbols
	with existing backend declaration.

2005-09-08  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/23765
	* match.c (gfc_match_common): Remove unnecessary / wrong special
	cases for end-of-statement.

2005-09-08  Janne Blomqvist  <jblomqvi@cc.hut.fi>

	* gfortran.texi: Add section about implemented F2003 features.

2005-09-08  Richard Sandiford  <richard@codesourcery.com>

	PR fortran/15326
	* trans-array.c (gfc_add_loop_ss_code): Set ss->string_length in
	the GFC_SS_FUNCTION case too.
	* trans-expr.c (gfc_conv_function_val): Allow symbols to be bound
	to function pointers as well as function decls.
	(gfc_interface_sym_mapping, gfc_interface_mapping): New structures.
	(gfc_init_interface_mapping, gfc_free_interface_mapping)
	(gfc_get_interface_mapping_charlen, gfc_get_interface_mapping_array)
	(gfc_set_interface_mapping_bounds, gfc_add_interface_mapping)
	(gfc_finish_interface_mapping, gfc_apply_interface_mapping_to_cons)
	(gfc_apply_interface_mapping_to_ref)
	(gfc_apply_interface_mapping_to_expr)
	(gfc_apply_interface_mapping): New functions.
	(gfc_conv_function_call): Evaluate the arguments before working
	out where the result should go.  Make the null pointer case provide
	the string length in parmse.string_length.  Cope with non-constant
	string lengths, using the above functions to evaluate such lengths.
	Use a temporary typespec; don't assign to sym->cl->backend_decl.
	Don't assign to se->string_length when returning a cached array
	descriptor.

2005-09-08  Richard Sandiford  <richard@codesourcery.com>

	PR fortran/19928
	* trans-array.c (gfc_conv_array_ref): Call gfc_advance_se_ss_chain
	after handling scalarized references.  Make "indexse" inherit from
	"se" when handling AR_ELEMENTs.
	(gfc_walk_variable_expr): Add GFC_SS_SCALAR entries for each
	substring or scalar reference that follows an array section.
	* trans-expr.c (gfc_conv_variable): When called from within a
	scalarization loop, start out with "ref" pointing to the scalarized
	part of the reference.  Don't call gfc_advance_se_ss_chain here.

2005-09-07  Richard Sandiford  <richard@codesourcery.com>

	PR fortran/23373
	* trans-expr.c (gfc_trans_pointer_assignment): Assign to a temporary
	descriptor if the rhs is not a null pointer or variable.

2005-09-07  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/20848
	* symbol.c(check_conflict):  Add conflict for parameter/save,

2005-09-06  Richard Sandiford  <richard@codesourcery.com>

	PR fortran/19269
	* simplify.c (gfc_simplify_transpose): Set the result's typespec from
	the source, not the first element of the return value.

2005-09-04  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/23661
	* io.c (match_io): Correctly backup if PRINT followed by
	symbol which is not a namelist.  Force blank between PRINT
	and namelist in free form.

2005-08-31  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/20592
	* gfortran.h (gfc_option_t): Add flag_automatic.
	* invoke.texi: Document the -fno-automatic option.
	* lang.opt: Add a -fautomatic option.
	* options.c (gfc_init_options): Default for -fautomatic is on.
	(gfc_handle_option): Add handling of -fautomatic option.
	* resolve.c (gfc_resolve): When -fno-automatic is used, mark
	needed variables as SAVE.

2005-08-27  Erik Edelmann  <erik.edelmann@iki.fi>

	* trans-array.c (gfc_trans_deferred_array): Fix comments.

2005-08-27  Erik Schnetter  <schnetter@aei.mpg.de>

	* primary.c (match_charkind_name): Fix typo in comment leading to
	function.

2005-08-25  Erik Edelmann  <eedelman@acclab.helsinki.fi>

	PR fortran/20363
	* symbol.c (find_special): Remove.
	(build_sym, add_init_expr, attr_decl1): Remove calls to
	find_special in favor of calls to gfc_get_symbol.

2005-08-24  Thomas Koenig  <Thomas.Koenig@online.de>

	PR fortran/17758
	* gfortran.h (symbol_attribute):  Add noreturn to the structure.
	(gfc_intrinsic_sym):  Add noreturn to the structure.
	* intrinsic.c (make_noreturn):  New function.
	(add_subroutines):  Mark subroutines abort and exit as noreturn.
	(gfc_intrinsic_sub_interface):  Copy noreturn attribute from
	isym to the resolved symbol.
	* trans-decl.c (gfc_get_extern_function_decl): Set function
	as VOLATILE (== noreturn) if the noreturn attribute is set.

2005-08-21  Steven G. Kargl  <kargls@comcast.net>

	* decl.c: Typo in comment.

2005-08-21  Steven G. Kargl  <kargls@comcast.net>

	* array.c: Bump GFC_MAX_AC_EXPAND from 100 to 65535.

2005-08-21  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.h (gfc_option_t): Remove source field.  Add
	flag_d_lines field.
	(gfc_new_file): Remove arguments in prototype.
	(gfc_source_file): Make 'const char *'.
	* f95-lang.c (gfc_init): Use gfc_source_file instead of
	gfc_option.source.  Call gfc_new_file without arguments.
	* invoke.texi: Document new options '-fd-lines-as-code' and
	'-fd-lines-as-comment'.
	* lang.opt: Add new options.  Alphabetize.
	* options.c (gfc_init_options): Initialize gfc_source_file instead
	of gfc_option.source.  Initialize gfc_option.flag_d_lines.
	(form_from_filename): Move here from scanner.c.  Make
	'filename' argument 'const'.
	(gfc_post_options): Set gfc_source_file.  Determine source form.
	Warn if 'd-lines*' are used in free form.
	* scanner.c (gfc_source_file): Constify.
	(skip_fixed_comments): Deal with d-lines.
	(get_file): Constify argument 'name'.
	(load_file): Constify argument 'filename'.
	(form_from_filename): Moved to options.c.
	(gfc_new_file): Remove arguments.  Don't initialize
	gfc_source_file, don't determine source form.
	* trans-const.c (gfc_init_constants): Use gfc_source_file instead
	of gfc_option.source.

2005-08-19  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/23065
	* gfortran.h: Remove PATH_MAX definition.
	* module.c (write_module, gfc_dump_module): Use alloca to allocate
	buffers.
	* scanner.c (gfc_release_include_path, form_from_filename): Ditto.

2004-08-16  Huang Chun  <chunhuang73@hotmail.com>

	* trans-expr.c (gfc_conv_power_op): Evaluate the expression before
	expand.

2005-08-14  Asher Langton  <langton2@llnl.gov>

	* parse.c (match): Enclose macro in do...while(0) and braces.

2005-08-14  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/21432.
	* gfortran.texi: Document PRINT namelist.

2005-08-14  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/21432.
	* io.c (match_io): Add code to implement PRINT namelist.

2005-08-14  Canqun Yang  <canqun@nudt.edu.cn>

	* trans-stmt.c (gfc_trans_arithmetic_if): Optimized in case of equal
	labels.

2005-08-11  Francois-Xavier Coudert  <coudert@clipper.ens.fr>
	    Steven Bosscher  <stevenb@suse.de>

	PR libfortran/20006
	* gfortran.h: Add is_main_program member to symbol_attribute.
	* trans-decl: Add a gfor_fndecl_set_std tree.
	(gfc_build_builtin_function_decls): Create it.
	(gfc_generate_function_code): Add this call at the beginning of
	the main program.
	* trans.c (gfc_generate_code): Move main_program and attr.
	* trans.h: Add declaration for gfor_fndecl_set_std.

2005-08-10  Thomas Koenig  <Thomas.Koenig@online.de>

	PR libfortran/22143
	gfortran.h:  Declare new function gfc_resolve_dim_arg.
	resolve.c:  New function gfc_resolve_dim_arg.
	iresolve.c (gfc_resolve_all):  Use gfc_resolve_dim_arg.
	(gfc_resolve_any):  Likewise.
	(gfc_resolve_count):  Likewise.
	(gfc_resolve_cshift):  Likewise.  If the kind of shift is less
	gfc_default_integer_kind, convert it to default integer type.
	(gfc_resolve_eoshift):  Likewise.
	(gfc_resolve_maxloc):  Use gfc_resolve_dim_arg.
	(gfc_resolve_maxval):  Likewise.
	(gfc_resolve_minloc):  Likewise.
	(gfc_resolve_minval):  Likewise.
	(gfc_resolve_product):  Likewise.
	(gfc_resolve_spread):  Likewise.
	(gfc_resolve_sum):  Likewise.

2005-08-09  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* check.c (gfc_check_ttynam_sub, gfc_check_isatty): Add check
	functions for new intrinsics TTYNAM and ISATTY.
	* intrinsic.c (add_functions, add_subroutines): Add new
	intrinsics.
	* intrinsic.h: Add prototypes for new check and resolve
	functions.
	* iresolve.c (gfc_resolve_isatty, gfc_resolve_ttynam_sub): New
	resolve functions for intrinsics TTYNAM and ISATTY.
	* gfortran.h (gfc_generic_isym_id): Add symbol for ISATTY.
	* trans-intrinsic.c: Add case for GFC_ISYM_ISATTY.

2005-08-09  Jakub Jelinek  <jakub@redhat.com>

	* scanner.c (preprocessor_line): Don't write beyond the end of flag
	buffer.

2005-08-07   Janne Blomqvist  <jblomqvi@cc.hut.fi>

	PR fortran/22390
	* dump-parse-tree.c (gfc_show_code_node): Add case for FLUSH.
	* gfortran.h: Add enums for FLUSH.
	* io.c (gfc_free_filepos,match_file_element,match_filepos): Modify
	comment appropriately.  (gfc_match_flush): New function.
	* match.c (gfc_match_if): Add match for flush.
	* match.h: Add prototype.
	* parse.c (decode_statement): Add flush to 'f' case.
	(next_statement): Add case for flush. (gfc_ascii_statement): Likewise.
	* resolve.c (resolve_code): Add flush case.
	* st.c (gfc_free_statement): Add flush case.
	* trans-io.c: Add prototype for flush.
	(gfc_build_io_library_fndecls): Build fndecl for flush.
	(gfc_trans_flush): New function.
	* trans-stmt.h: Add prototype.
	* trans.c (gfc_trans_code): Add case for flush.

2005-08-06  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* primary.c (match_hollerith_constant): Fix typo.

2005-08-06  Kazu Hirata  <kazu@codesourcery.com>

	* decl.c, dump-parse-tree.c, gfortran.texi, intrinsic.texi,
	invoke.texi, resolve.c, trans-array.c, trans-array.h,
	trans-common.c, trans-expr.c, trans-io.c, trans.h: Fix
	comment/doc typos.  Follow spelling conventions.

2005-08-06  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/18833
	PR fortran/20850
	* primary.c (match_varspec): If equiv_flag, don't look at sym's
	attributes, call gfc_match_array_ref up to twice and don't do any
	substring or component processing.
	* resolve.c (resolve_equivalence): Transform REF_ARRAY into
	REF_SUBSTRING or nothing if needed.  Check that substrings
	don't have zero length.

2005-08-05  Thomas Koenig  <Thomas.Koenig@online.de>

	* trans-expr.c  (gfc_build_builtin_function_decls):  Mark
	stop_numeric and stop_string as non-returning.

2005-08-04  Paul Brook  <paul@codesourcery.com>

	* trans-expr.c (gfc_conv_expr, gfc_conv_expr_type): Update comments.
	(gfc_conv_expr_lhs): Fix assertion.
	(gfc_conv_expr_val): Merge post block.  Set se.expr to new value.

2005-08-02  David Edelsohn  <edelsohn@gnu.org>

	PR fortran/22491
	* expr.c (simplify_parameter_variable): Do not copy the subobject
	references if the expression value is a constant.

	* expr.c (gfc_simplify_expr): Evaluate constant substrings.

2005-07-31  Jerry DeLisle  <jvdelisle@verizon.net>

	* intrinsic.texi: Add documentation for exponent, floor, and fnum and
	fix description of ceiling in index.

2005-07-31  Steven Bosscher  <stevenb@suse.de>

	* trans-decl.c (gfc_build_builtin_function_decls): Give the internal
	malloc functions the 'malloc' attribute.  Give runtime_error the
	'noreturn' attribute.

2005-07-31  Steven Bosscher  <stevenb@suse.de>

	* trans-stmt.c (gfc_trans_goto): Jump to the known label instead
	of the assigned goto variable.

2005-07-29  Steven Bosscher  <stevenb@suse.de>

	* trans-types.h (gfc_array_range_type): Add missing GTY decl for this.

2005-07-28  Andrew Pinski  <pinskia@physics.uc.edu>

	* fortran/f95-lang.c (language_function): Remove
	named_labels, shadowed_labels, returns_value, returns_abnormally,
	warn_about_return_type, and extern_inline fields.
	(named_labels): Remove variable.
	(gfc_init_decl_processing): Remove setting of named_labels.

2005-07-27  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	PR fortran/22503
	* resolve.c (resolve_operator): Improve diagnostic for comparison
	of logicals with invalid operator.

2005-07-25  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/20063
	* data.c (gfc_assign_data_value_range): Call
	create_character_initializer if last_ts is a character type.

2005-07-22  Manfred Hollstein  <mh@suse.com>

	* match.c (gfc_match_symbol): Fix uninitialised warnings.
	* matchexp.c (gfc_match_expr): Likewise.

2005-07-20  Giovanni Bajo  <giovannibajo@libero.it>

	Make CONSTRUCTOR use VEC to store initializers.
	* trans-array.c (gfc_build_null_descriptor,
	gfc_trans_array_constructor_value, gfc_conv_array_initializer):
	Update to cope with VEC in CONSTRUCTOR_ELTS.
	* trans-common.c (create_common): Likewise.
	* trans-expr.c (gfc_conv_structure): Likewise.
	* trans-stmt.c (gfc_trans_character_select): Use
	build_constructor_from_list instead of build_constructor.

2005-07-19  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/16940
	* resolve.c (resolve_symbol): A symbol with FL_UNKNOWN
	is matched against interfaces in parent namespaces. If there
	the symtree is set to point to the interface.

2005-07-16  David Edelsohn  <edelsohn@gnu.org>

	PR fortran/21730
	* decl.c (do_parm): Adjust character initializer to character length
	of symbol before assigning.

2005-07-14  Steve Ellcey  <sje@cup.hp.com>

	* trans-types.c (MAX_REAL_KINDS): Increase from 4 to 5.

2005-07-14  Jakub Jelinek  <jakub@redhat.com>

	* gfortran.h (MAX_ERROR_MESSAGE): Remove.
	(gfc_error_buf): Add allocated and index fields.  Change message
	field from array to a pointer.
	* error.c (use_warning_buffer, error_ptr, warning_ptr): Remove.
	(cur_error_buffer): New variable.
	(error_char): Use cur_error_buffer->{message,index} instead of
	{warning,error}_{buffer.message,ptr}.  Reallocate message buffer
	if too small.
	(gfc_warning, gfc_notify_std, gfc_error, gfc_error_now): Setup
	cur_error_buffer and its index rather than {warning,error}_ptr
	and use_warning_buffer.
	(gfc_warning_check, gfc_error_check): Don't print anything if
	message is NULL.
	(gfc_push_error): Allocate saved message with xstrdup.
	(gfc_pop_error): Free saved message with gfc_free.
	(gfc_free_error): New function.
	* primary.c (match_complex_constant): Call gfc_free_error if
	gfc_pop_error will not be called.
	* match.c (gfc_match_st_function): Likewise.

	PR fortran/22417
	* scanner.c (preprocessor_line): Don't treat flag 3 as the start of a new
	file.  Fix file left but not entered warning.

2005-07-14  Feng Wang  <fengwang@nudt.edu.cn>
	Steven G. Kargl  <kargls@comcast.net>

	* array.c (resolve_character_array_constructor): Allocate gfc_charlen
	for the array and attach to namespace list for automatic deallocation.

2005-07-13  Andreas Schwab  <schwab@suse.de>

	* Make-lang.in (fortran/dependency.o): Depend on
	$(GFORTRAN_TRANS_DEPS).

2005-07-11  Jakub Jelinek  <jakub@redhat.com>

	* trans-stmt.c (gfc_trans_forall_loop): Clear maskindex before
	the outermost loop.
	(gfc_trans_assign_need_temp, gfc_trans_pointer_assign_need_temp,
	gfc_trans_forall_1, gfc_evaluate_where_mask, gfc_trans_where_2):
	Don't clear maskindexes here.

2005-07-08  Daniel Berlin  <dberlin@dberlin.org>

	* trans-decl.c (create_function_arglist): DECL_ARG_TYPE_AS_WRITTEN
	is removed.

2005-07-08  Jakub Jelinek  <jakub@redhat.com>

	* primary.c (gfc_match_rvalue): Handle ENTRY the same way
	as FUNCTION.

2005-07-07  Jakub Jelinek  <jakub@redhat.com>

	* scanner.c (load_line): Add pbuflen argument, don't make
	buflen static.  If maxlen == 0 or preprocessor_flag,
	don't truncate at buflen, but at maxlen.  In xrealloc add
	1 byte at the end for the terminating '\0'.  Don't fill
	with spaces up to buflen, but gfc_option.fixed_line_length.
	(load_file): Adjust load_line caller.  Add line_len variable.

	* scanner.c (preprocessor_line): Only set current_file->line when errors
	have not been encountered.  Warn and don't crash if a file leave
	preprocessor line has no corresponding entering line.  Formatting.

2005-07-07  Steven Bosscher  <stevenb@suse.de>

	* primary.c (match_hollerith_constant): Use int, not unsigned int,
	for the hollerith length.  Fix indentation.

2005-07-07  Feng Wang  <fengwang@nudt.edu.cn>

	PR fortran/16531
	PR fortran/15966
	PR fortran/18781
	* arith.c (gfc_hollerith2int, gfc_hollerith2real,
	gfc_hollerith2complex, gfc_hollerith2character, gfc_hollerith2logical):
	New functions.
	(eval_intrinsic): Don't evaluate if Hollerith constant arguments exist.
	* arith.h (gfc_hollerith2int, gfc_hollerith2real,
	gfc_hollerith2complex, gfc_hollerith2character, gfc_hollerith2logical):
	Add prototypes.
	* expr.c (free_expr0): Free memery allocated for Hollerith constant.
	(gfc_copy_expr): Allocate and copy string if Expr is from Hollerith.
	(gfc_check_assign): Enable conversion from Hollerith to other.
	* gfortran.h (bt): Add BT_HOLLERITH.
	(gfc_expr): Add from_H flag.
	* intrinsic.c (gfc_type_letter): Return 'h' for BT_HOLLERITH.
	(add_conversions): Add conversions from Hollerith constant to other.
	(do_simplify): Don't simplify if  Hollerith constant arguments exist.
	* io.c (resolve_tag): Enable array in FORMAT tag under GFC_STD_GNU.
	* misc.c (gfc_basetype_name): Return "HOLLERITH" for BT_HOLLERITH.
	(gfc_type_name): Print "HOLLERITH" for BT_HOLLERITH.
	* primary.c (match_hollerith_constant): New function.
	(gfc_match_literal_constant): Add match Hollerith before Integer.
	* simplify.c (gfc_convert_constant): Add conversion from Hollerith
	to other.
	* trans-const.c (gfc_conv_constant_to_tree): Use VIEW_CONVERT_EXPR to
	convert Hollerith constant to tree.
	* trans-io.c (gfc_convert_array_to_string): Get array's address and
	length to set string expr.
	(set_string): Deal with array assigned Hollerith constant and character
	array.
	* gfortran.texi: Document Hollerith constants as extention support.

2005-07-07  Feng Wang  <fengwang@nudt.edu.cn>

	PR fortran/22327
	* trans-array.c (gfc_trans_array_constructor_value): Fix index of data.

2005-07-07  Jakub Jelinek  <jakub@redhat.com>

	* decl.c (gfc_match_entry): Allow ENTRY without parentheses
	even in FUNCTIONs.

2005-07-03  Kazu Hirata  <kazu@codesourcery.com>

	* gfortran.texi, intrinsic.texi: Fix typos.
	* symbol.c: Fix a comment typo.

2005-07-03  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* error.c (error_printf, error_print): Use ATTRIBUTE_GCC_GFC.
	* gfortran.h (ATTRIBUTE_GCC_GFC): New.
	(gfc_warning, gfc_warning_now, gfc_error, gfc_error_now,
	gfc_fatal_error, gfc_internal_error, gfc_notify_std): Use
	ATTRIBUTE_GCC_GFC.

2005-07-03  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/20842
	* io.c (match_dt_element): Do not allow END tag in PRINT or
	WRITE statement.

2005-07-02  Joseph S. Myers  <joseph@codesourcery.com>

	* lang.opt: Remove "." from end of help texts.

2005-07-01  Jerry DeLisle  <jvdelisle@verizon.net>

	* gfortran.texi: Fix typos and grammar.
	* invoke.texi: Fix typos and grammar.
	* intrinsic.texi: Add documentaion for eoshift, epsilon, etime, and
	exit. Fixed alignment of text for dtime syntax. Fixed a few line
	lengths.

2005-06-25  Jakub Jelinek  <jakub@redhat.com>

	* trans-stmt.c (gfc_trans_forall_1): Prefer to use smaller logical
	type than boolean_type_node.

2005-06-25  Kelley Cook  <kcook@gcc.gnu.org>

	* all files: Update FSF address in copyright headers.

2005-06-24  Jerry DeLisle  <jvdelisle@verizon.net>

	PR fortran/21915
	* gfortran.h: Add symbols for new intrinsic functions.
	* intrinsic.c: Add new functions acosh, asinh, and atanh.
	* intrinsic.h: Add prototypes for the new functions.
	* iresolve.c (gfc_resolve_acosh): New function.
	(gfc_resolve_asinh): New function.
	(gfc_resolve_atanh): New function.
	* mathbuiltins.def: Add defines.
	* simplify.c (gfc_simplify_acosh): New function.
	(gfc_simplify_asinh): New function.
	(gfc_simplify_atanh): New function.

2005-06-24  Feng Wang  <fengwang@nudt.edu.cn>

	* simplify.c (gfc_simplify_modulo): Don't clear before get result.

2005-06-22  Paul Brook  <paul@codesourcery.com>

	PR fortran/21034
	* symbol.c (gfc_is_var_automatic): New function.
	(save_symbol): Use it.

2005-06-21  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>
	    Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/22010
	Port from g95.
	* module.c (mio_namelist): New function. Correct to set
	namelist_tail and to give error on renaming namelist by use
	association.
	(mio_symbol): Call mio_namelist.

2005-06-19  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* gfortran.h: Add flag_backslash compile-time option.
	* lang.opt: Add support for -fbackslash option.
	* options.c: Likewise.
	* primary.c: Implement behavior for -fno-backslash.
	* invoke.texi: Add doc for -fbackslash option.
	* gfortran.texi: Remove mention of -fno-backslash as a
	possible extension.

2005-06-20  Steven G. Kargl  <kargls@comcast.net>
	(port from g95)

	PR fortran/21257
	* match.c (gfc_match_label): Detect duplicate labels.


2005-06-20  Erik Edelmann  <erik.edelmann@iki.fi>

	* intrinsic.c (check_intrinsic_standard): Fix spelling error
	in a warning message.

2005-06-18  Erik Edelman  <eedelman@acclab.helsinki.fi>
	    Steven G. Kargl  <kargls@comast.net>

	PR fortran/19926
	* primary.c (gfc_match_rvalue):  expr_type can be EXPR_CONSTANT
	for an array; check that sym->as is NULL.


2005-06-18  Steven G. Kargl  <kargls@comcast.net>

	* intrinsic.c (gfc_intrinsic_func_interface): Enable errors for generic
	functions whose simplification routine return FAILURE.

2005-06-13  Geoffrey Keating  <geoffk@apple.com>

	* Make-lang.in (fortran.install-man): Doesn't depend on installdirs.
	(rule for installing f95.1 manpage): Does depend on installdirs.

2005-06-13  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/22038
	* trans-stmt.c (gfc_trans_forall_loop): Only increment maskindex
	in the innermost loop.

	* trans-expr.c (gfc_conv_function_call): Return int instead of
	void.  Use a local variable for has_alternate_specifier and
	return it.  Avoid modification of function type's return value
	in place, since it may be shared.
	* trans.h (has_alternate_specifier): Remove.
	(gfc_conv_function_call): Change return type.
	* trans-stmt.c (has_alternate_specifier): Remove.
	(gfc_trans_call): Add a local has_alternate_specifier variable,
	set it from gfc_conv_function_call return value.

2005-06-12  Richard Henderson  <rth@redhat.com>

	* trans-array.c (gfc_conv_descriptor_data_get): Rename from
	gfc_conv_descriptor_data.  Cast the result to the DATAPTR type.
	(gfc_conv_descriptor_data_set, gfc_conv_descriptor_data_addr): New.
	(gfc_trans_allocate_array_storage): Use them.
	(gfc_array_allocate, gfc_array_deallocate): Likewise.
	(gfc_trans_dummy_array_bias, gfc_conv_expr_descriptor): Likewise.
	(gfc_trans_deferred_array): Likewise.
	* trans-expr.c (gfc_conv_function_call): Likewise.
	(gfc_trans_subcomponent_assign): Likewise.
	(gfc_trans_pointer_assignment): Likewise.
	* trans-intrinsic.c (gfc_conv_allocated): Likewise.
	* trans-types.c (gfc_array_descriptor_base): New.
	(gfc_get_element_type): Use GFC_TYPE_ARRAY_DATAPTR_TYPE.
	(gfc_get_array_descriptor_base): Break out from ...
	(gfc_get_array_type_bounds): ... here.  Create type variants.
	* trans-array.h (gfc_conv_descriptor_data_get): Declare.
	(gfc_conv_descriptor_data_set, gfc_conv_descriptor_data_addr): Declare.

2005-06-12  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-expr.c (gfc_conv_variable): POINTER results don't need f2c
	calling conventions.  Look at sym instead of sym->result.
	* trans-types.c (gfc_sym_type): Remove workaround for frontend bug.
	Remove condition which is always false with workaround removed.
	(gfc_return_by_reference): Always look at sym, never at sym->result.

2005-06-11  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/17792
	PR fortran/21375
	* trans-array.c (gfc_array_deallocate): pstat is new argument
	(gfc_array_allocate): update gfc_array_deallocate() call.
	(gfc_trans_deferred_array): ditto.
	* trans-array.h: update gfc_array_deallocate() prototype.
	* trans-decl.c (gfc_build_builtin_function_decls): update declaration
	* trans-stmt.c (gfc_trans_deallocate): Implement STAT= feature.

2005-06-07  Jerry DeLisle  <jvdelisle@verizon.net>

	* intrinsic.texi: Add documentation for	dcmplx, digits,
	dim, idim, ddim, dot_product, dprod, dreal, and dtime.

2005-06-05  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/21912
	* trans-array.c (gfc_trans_array_constructor_value): Slightly reorder.
	Generate correct exit condition in case of negative steps in
	implied-do loops.

	* invoke.texi: Fix description of flags required for compatibility
	with g77.

2005-06-04  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>
	Erik Schnetter  <schnetter@aei.mpg.de>

	PR fortran/19195
	* trans.c (gfc_get_backend_locus): Remove unnecessary adjustment,
	remove FIXME comment.

2005-06-04  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* match.c (match_forall_iterator): Don't immediately give error if '='
	is not followed by an expression.

2005-06-04  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>
	Erik Edelmann  <erik.edelmann@iki.fi>

	* array.c (gfc_match_array_constructor): Disallow empty array
	constructor.

2005-06-03  Jerry DeLisle  <jvdelisle@verizon.net>

	* fortran/intrinsic.texi: Add documentation for
	command_argument_count, conjg, dconjg, count,
	cpu_time, cshift, date_and_time, dble, dfloat.

2005-06-01  Roger Sayle  <roger@eyesopen.com>

	* intrinsic.c (add_conv): No longer take a "simplify" argument as
	its always gfc_convert_constant, instead take a "standard" argument.
	(add_conversions): Change all existing calls of add_conv to pass
	GFC_STD_F77 as appropriate.  Additionally, if we're allowing GNU
	extensions support integer-logical and logical-integer conversions.
	(gfc_convert_type_warn): Warn about use the use of these conversions
	as a extension when appropriate, i.e. with -pedantic.
	* simplify.c (gfc_convert_constant): Add support for integer to
	logical and logical to integer conversions, using gfc_int2log and
	gfc_log2int.
	* arith.c (gfc_log2int, gfc_int2log): New functions.
	* arith.h (gfc_log2int, gfc_int2log): Prototype here.
	* gfortran.texi: Document this new GNU extension.

2005-06-01  Paul Thomas  <pault@gcc.gnu.org>

	* fortran/trans-expr.c (gfc_conv_variable): Clean up bracketting.
	* fortran/trans-expr.c (gfc_conv_function_call): Insert spaces.
	Correct comments and replace convert of integer_one_node with
	build_int_cst.

2005-06-01  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/21729
	* resolve.c (resolve_contained_fntype): Use sym->attr.untyped
	to avoid giving error multiple times.
	(resolve_entries): Don't error about BT_UNKNOWN here.
	(resolve_unknown_f): Capitalize IMPLICIT for consistency.
	(resolve_fntype): New function.
	(gfc_resolve): Call resolve_fntype.

2005-06-01  Feng Wang  <fengwang@nudt.edu.cn>

	PR fortran/20883
	* fortran/io.c (resolve_tag): Fix error message.

2005-05-31  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fortran/trans-decl.c: Don't include errors.h.
	* fortran/Make-lang.in: Updates dependencies.

2005-05-31  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/18109
	PR fortran/18283
	PR fortran/19107
	* fortran/trans-array.c (gfc_conv_expr_descriptor): Obtain the
	string length from the expression typespec character length value
	and set temp_ss->stringlength and backend_decl. Obtain the
	tree expression from gfc_conv_expr rather than gfc_conv_expr_val.
	Dereference the expression to obtain the character.
	* fortran/trans-expr.c (gfc_conv_component_ref): Remove the
	dereference of scalar character pointer structure components.
	* fortran/trans-expr.c (gfc_trans_subarray_assign): Obtain the
	string length for the structure component from the component
	expression.

2005-05-30  Roger Sayle  <roger@eyesopen.com>

	* gfortran.h (GFC_STD_LEGACY): New "standard" macro.  Reindent.
	* options.c (gfc_init_options): By default, allow legacy extensions
	but warn about them.
	(gfc_post_options): Make -pedantic warn about legacy extensions
	even with -std=legacy.
	(gfc_handle_option): Make -std=gnu follow the default behaviour
	of warning about legacy extensions, but allowing them. Make the
	new -std=legacy accept everything and warn about nothing.
	* lang.opt (std=legacy): New F95 command line option.
	* invoke.texi: Document both -std=f2003 and -std=legacy.
	* gfortran.texi: Explain the two types of extensions and document
	how they are affected by the various -std= command line options.

2005-05-30  Kazu Hirata  <kazu@cs.umass.edu>

	* trans-expr.c: Remove trailing ^M.

	* trans-expr.c: Fix comment typos.

2005-05-29  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/16939
	PR fortran/17192
	PR fortran/17193
	PR fortran/17202
	PR fortran/18689
	PR fortran/18890
	* fortran/trans-array.c (gfc_conv_resolve_dependencies): Add string
	length to temp_ss for character pointer array assignments.
	* fortran/trans-expr.c (gfc_conv_variable): Correct errors in
	dereferencing of characters and character pointers.
	* fortran/trans-expr.c (gfc_conv_function_call): Provide string
	length as return argument for various kinds of handling of return.
	Return a char[]* temporary for character pointer functions and
	dereference the temporary upon return.

2005-05-29  Janne Blomqvist  <jblomqvi@vipunen.hut.fi>
	    Steven G. Kargl  <kargls@comcast.net>

	fortran/PR20846
	* io.c (gfc_match_inquire): Implement constraints on UNIT and FILE usage.

2005-05-29  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR libfortran/20006
	* io.c (format_item_1): Add check and extension warning for
	$ edit descriptor.

2005-05-28  Steven G. Kargl  <kargls@comcast.net>

	* arith.c (gfc_arith_init_1): Fix off by one problem;
	(gfc_check_integer_range): Chop extra bits in subnormal numbers.

2005-05-28  Jerry DeLisle   <jvdelisle@verizon.net>
	    Steven G. Kargl  <kargls@comcast.net>

	* intrinsic.texi: added documentation for BIT_SIZE, BTEST, CHAR, CEILING
	and CMPLX

2005-05-27  Steven G. Kargl  <kargls@comcast.net>

	* trans-array.c (gfc_trans_deferred_array): Use build_int_cst to force
	like types in comparsion.

2005-05-26  Kazu Hirata  <kazu@cs.umass.edu>

	* data.c, parse.c, trans-array.c, trans-decl.c,
	trans-intrinsic.c, trans-stmt.c, trans-types.c, trans.c,
	trans.h: Fix comment typos.  Follow spelling conventions.

2005-05-22  Roger Sayle  <roger@eyesopen.com>

	* gfortran.texi: Document some more GNU extensions.

2005-05-22  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* error.c (gfc_warning): Fix typo in comment.

2005-05-18  Thomas Koenig  <Thomas.Koenig@online.de>

	PR libfortran/21127
	* fortran/iresolve.c (gfc_resolve_reshape): Add
	gfc_type_letter (BT_COMPLEX) for complex to
	to resolved function name.

2005-05-18  Erik Edelmann  <erik.edelmann@iki.fi>

	* array.c (gfc_match_array_constructor): Support [ ... ]
	style array constructors.

2005-05-18  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* f95-lang.c (gfc_init_builtin_functions): Define BUILT_IN_TRUNC
	and BUILT_IN_TRUNCF instead of BUILT_IN_FLOOR and BUILT_IN_FLOORF.
	* trans-intrinsic.c (build_fix_expr): Change 'op' argument
	to correct enum type.
	(gfc_conv_intrinsic_aint): Likewise.  Clarify comment in front of
	function.  Add default case to switch, deal with FIX_TRUNC_EXPR
	instead of FIX_FLOOR_EXPR.

2005-05-18  Feng Wang  <fengwang@nudt.edu.cn>

	PR fortran/20954
	* trans-const.c (gfc_conv_const_charlen): Use gfc_charlen_type_node to
	build character length.

2005-05-17  Zdenek Dvorak  <dvorakz@suse.cz>

	* trans-types.c (gfc_array_range_type): New variable.
	(gfc_init_types): Initialize gfc_array_range_type.
	(gfc_get_array_type_bounds): Use gfc_array_range_type.

2005-05-17  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/15080
	* trans-stmt.c (generate_loop_for_temp_to_lhs): Remove SIZE and COUNT2
	arguments.  If LSS is gfc_ss_terminator, increment COUNT1 by 1, instead
	of incrementing COUNT2 and using COUNT1+COUNT2 increment COUNT1 and use
	just that as index.
	(generate_loop_for_rhs_to_temp): Likewise.
	(compute_overall_iter_number): Add INNER_SIZE_BODY argument.
	It non-NULL, add it to body.
	(allocate_temp_for_forall_nest_1): New function, split from
	allocate_temp_for_forall_nest.
	(allocate_temp_for_forall_nest): Add INNER_SIZE_BODY argument,
	propagate it down to compute_overall_iter_number.  Use
	allocate_temp_for_forall_nest_1.
	(gfc_trans_assign_need_temp): Remove COUNT2.  Call
	compute_inner_temp_size into a new stmtblock_t.  Adjust calls to
	allocate_temp_for_forall_nest, generate_loop_for_rhs_to_temp
	and generate_loop_for_temp_to_lhs.
	(gfc_trans_pointer_assign_need_temp): Adjust calls to
	allocate_temp_for_forall_nest.
	(gfc_evaluate_where_mask): Call compute_inner_temp_size into a new
	stmtblock_t.  Call compute_overall_iter_number just once, then
	allocate_temp_for_forall_nest_1 twice with the same size.
	Initialize mask indexes if nested_forall_info != NULL.
	(gfc_trans_where_2): Initialize mask indexes before calling
	gfc_trans_nested_forall_loop.

2005-05-15  Feng Wang  <fengwang@nudt.edu.cn>
	Jerry DeLisle  <jvdelisle@verizon.net>

	PR fortran/17432
	* trans-stmt.c (gfc_trans_label_assign): fix pointer type, to
	resolve ICE on assign of format label.
	* trans-io.c (set_string): add fold-convert to properly
	handle assigned format label in write.

2005-05-13  Paul Brook  <paul@codesourcery.com>

	* trans-stmt.c (gfc_trans_forall_1): Fix comment typo.

2005-05-12  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-types.c (gfc_is_nodesc_array): Remove redundant check.

2005-05-11  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/21260
	* io.c (check_format): Look for literal characters inside
	hollerith constant.

2005-05-11  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* resolve.c (resolve_symbol): Copy 'pointer' and 'dimension'
	attribute from result symbol to function symbol.
	* trans-expr.c (gfc_conv_function_call): Look at sym->attr.dimension
	instead of sym->result->attr.dimension.

2005-05-10  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/20178
	* gfortran.h (gfc_option): Add flag_f2c.
	* invoke.texi: Document '-ff2c' command line option.  Adapt
	documentation for '-fno-second-underscore' and '-fno-underscoring'.
	* lang.opt (ff2c): New entry.
	* options.c (gfc-init_options): Set default calling convention
	to -fno-f2c.  Mark -fsecond-underscore unset.
	(gfc_post_options): Set -fsecond-underscore if not explicitly set
	by user.
	(handle_options): Set gfc_option.flag_f2c according to requested
	calling	convention.
	* trans-decl.c (gfc_get_extern_function_decl): Use special f2c
	intrinsics where necessary.
	(gfc_trans_deferred_vars): Change todo error to	assertion.
	* trans-expr.c (gfc_conv_variable): Dereference access
	to hidden result argument.
	(gfc_conv_function_call): Add hidden result argument to argument
	list if f2c calling conventions requested.  Slightly restructure
	tests.  Convert result of default REAL function to requested type
	if f2c calling conventions are used.  Dereference COMPLEX result
	if f2c cc are used.
	* trans-types.c (gfc_sym_type):  Return double for default REAL
	function if f2c cc are used.
	(gfc_return_by_reference): Slightly restructure logic.  Return
	COMPLEX by reference depending on calling conventions.
	(gfc_get_function_type): Correctly make hidden result argument a
	pass-by-reference argument for COMPLEX.  Remove old code which does
	this for derived types.

2005-05-09  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* match.c (gfc_match_return): Only require space after keyword when
	it is obligatory.  Only give stdwarn to after matching is successful.
	* dump-parse-tree.c (gfc_show_symbol): Deal with alternate returns.

2005-05-08  Kazu Hirata  <kazu@cs.umass.edu>

	* intrinsic.texi: Fix typos.

2005-05-07  Steven G. Kargl  <kargls@comcast.net>

	* intrinsic.texi:  Document ASSOCIATED and ATAN2.  Update Bessel function
	description to include information about scalar arguments.

2005-05-03  Kazu Hirata  <kazu@cs.umass.edu>

	* Make-lang.in, dump-parse-tree.c, invoke.texi, lang.opt,
	match.h, trans-array.h: Update copyright.

2005-04-29  Tom Tromey  <tromey@redhat.com>

	* f95-lang.c (poplevel): Updated for change to build_block.

2005-04-29  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/13082
	PR fortran/18824
	* trans-expr.c (gfc_conv_variable): Handle return values in functions
	with alternate entry points.
	* resolve.c (resolve_entries): Remove unnecessary string termination
	after snprintf.  Set result of entry master.
	If all entries have the same type, set entry master's type
	to that common type, otherwise set mixed_entry_master attribute.
	* trans-types.c (gfc_get_mixed_entry_union): New function.
	(gfc_get_function_type): Use it for mixed_entry_master functions.
	* gfortran.h (symbol_attribute): Add mixed_entry_master bit.
	* decl.c (gfc_match_entry): Set entry->result properly for
	function ENTRY.
	* trans-decl.c (gfc_get_symbol_decl): For entry_master, skip over
	__entry argument.
	(build_entry_thunks): Handle return values in entry thunks.
	Clear BT_CHARACTER's ts.cl->backend_decl, so that it is not
	shared between multiple contexts.
	(gfc_get_fake_result_decl): Use DECL_ARGUMENTS from
	current_function_decl instead of sym->backend_decl.  Skip over
	entry master's entry id argument.  For mixed_entry_master entries or
	their results, return a COMPONENT_REF of the fake result.
	(gfc_trans_deferred_vars): Don't warn about missing return value if
	at least one entry point uses RESULT.
	(gfc_generate_function_code): For entry master returning
	CHARACTER, copy ts.cl->backend_decl to all entry result syms.
	* trans-array.c (gfc_trans_dummy_array_bias): Don't consider return
	values optional just because they are in entry master.

2005-04-29  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* gfortran.h (gfc_namespace): Add seen_implicit_none field,
	Tobias forgot this in previous commit.

2005-04-29  Paul Brook   <paul@codesourcery.com>

	* trans-expr.c (gfc_conv_expr_present): Fix broken assert.  Update
	comment.

2005-04-29  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.h (gfc_namespace): Add seen_implicit_none field.
	* symbol.c (gfc_set_implicit_none): Give error if there's a previous
	IMPLICIT NONE, set seen_implicit_none.
	(gfc_merge_new_implicit): Error if there's an IMPLICIT NONE statement.

2005-04-28  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.h (gfc_gsymbol): Make name a const char *.
	* symbol.c (gfc_get_gsymbol): Allocate gsymbol name via
	gfc_get_string.

2005-04-28  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/20865
	* resolve.c (resolve_actual_arglist): Issue an error if a statement
	functions is used as actual argument.

2005-04-27  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/21177
	* interface.c (compare_parameter): Ignore type for EXPR_NULL
	only if type is BT_UNKNOWN.

2005-04-25  Paul Brook  <paul@codesourcery.com>
	Steven G. Kargl  <kargls@comcast.net>

	PR fortran/20879
	* check.c (gfc_check_ichar_iachar): New function.
	* instinsic.h (gfc_check_ichar_iachar): Add prototype.
	* intrinsic.c (add_functions): Use it.
	* primary.c (match_varspec, gfc_match_rvalue): Clear incorrect
	character expression lengths.

2005-04-24  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/20059
	* trans-common.c (translate_common): Cast offset and
	common_segment->offset to type int for warning message.

2005-04-23  DJ Delorie  <dj@redhat.com>

	* trans-decl.c: Adjust warning() callers.

2005-04-23  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-const.c (gfc_conv_mpfr_to_tree): Use hexadecimal string as
	intermediate representation.  Fix typo in comment.

2005-04-21  Steven G. Kargl  <kargls@comcast.net>

	* trans-const.c (gfc_conv_mpfr_to_tree): Remove unneeded computation;
	simplify logic; Add a gcc_assert.

2005-04-19  Steven G. Kargl  <kargls@comcast.net>

	* trans-const.c (gfc_conv_mpz_to_tree): Fix comment.

2005-04-19  Arnaud Desitter  <arnaud.desitter@ouce.ox.ac.uk>
	    Steven G. Kargl  <kargls@comcast.net>

	* invoke.texi: Update -Waliasing description

2005-04-19  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/16861
	* resolve.c (resolve_variable): If e->symtree is not set, this
	ought to be a FAILURE, and not a segfault.

2005-04-17  Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/17472
	PR fortran/18209
	PR fortran/18396
	PR fortran/19467
	PR fortran/19657
	* fortran/trans-io.c (gfc_build_io_library_fndecls): Create
	declaration for	st_set_nml_var and st_set_nml_var_dim. Remove
	declarations of old namelist functions.
	(build_dt): Simplified call to transfer_namelist_element.
	(nml_get_addr_expr): Generates address expression for start of
	object data. New function.
	(nml_full_name): Qualified name for derived type components. New
	function.
	(transfer_namelist_element): Modified for calls to new functions
	and improved derived type handling.

2005-04-17  Richard Guenther  <rguenth@gcc.gnu.org>

	* scanner.c (gfc_next_char_literal): Reset truncation flag
	for lines ending in a comment for both fixed and free form.
	(load_line): Do not set truncated flag if only truncating
	the EOL marker.

2005-04-15  Richard Guenther  <rguenth@gcc.gnu.org>

	PR fortran/14569
	* gfortran.h (gfc_linebuf): Add truncated field.
	* parse.c (next_statement): Handle warning for truncated
	lines.
	* scanner.c (load_line): Return if line was truncated.
	No longer warn for truncated lines.  Remove unused parameters.
	(load_file): Store load_line return value to linebuf.
	(gfc_error_recovery): Do not advance line at the end.

2005-04-14  Steven G. Kargl  <kargls@comcast.net>

	* gfortran.h (gfc_real_info): Add subnormal struct member.
	* arith.c (gfc_arith_init_1): Set it.
	(gfc_check_real_range): Use it.
	* simplify.c (gfc_simplify_nearest): Fix nearest(0.,1.).

2005-04-12  Kazu Hirata  <kazu@cs.umass.edu>

	* simplify.c: Fix a comment typo.

2005-04-11  Richard Sandiford  <rsandifo@redhat.com>

	* lang.opt: Refer to the GCC internals documentation instead of c.opt.

2005-04-11  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* simplify.c (gfc_simplify_nearest): Overhaul.

2005-04-10  Kazu Hirata  <kazu@cs.umass.edu>

	* interface.c: Fix a comment typo.

2005-04-10  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* match.c (match_arithmetic_if): Arithmetic IF is obsolete in
	Fortran 95.

2005-04-09  Steven G. Kargl  <kargls@comcast.net>

	* simplify.c (gfc_simplify_anint): Use mpfr_round()
	(gfc_simplify_dnint): ditto.
	(gfc_simplify_nint): ditto.

2005-04-09  Andrew Pinski  <pinskia@physics.uc.edu>

	PR fortran/13257
	* io.c (check_format): Allow an optional comma
	between descriptors.

2005-04-09  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* match.c (match_arithmetic_if): Remove gfc_ prefix and correct
	comment according to GNU coding style.
	(gfc_match_if): Remove gfc_ prefix in call to
	match_arithmetic_if.

2005-04-08  Diego Novillo  <dnovillo@redhat.com>

	* match.c (gfc_match_arithmetic_if): Declare static.

2005-04-08  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	PR fortran/17229
	* match.c (gfc_match_arithmetic_if): New function to match an
	arithmetic IF statement.
	(gfc_match_if): Use gfc_match_arithmetic_if to match an
	arithmetic IF statement embedded in a simple IF statement.

2005-04-07  Steven G. Kargl  <kargls@comcast.net>

	* simplify.c (gfc_simplify_exponent): Fix exponent(tiny(x))

2005-04-06  Steven G. Kargl  <kargls@comcast.net>

	* invoke.texi: Remove documentation of -std=f90

2005-04-06  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* expr.c (gfc_check_assign): Don't allow NULL as rhs in a
	non-pointer assignment.

2005-04-05  Feng Wang  <fengwang@nudt.edu.cn>

	PR fortran/15959
	PR fortran/20713

	* array.c (resolve_character_array_constructor): New function. Set
	constant character array's character length.
	(gfc_resolve_array_constructor): Use it.
	* decl.c (add_init_expr_to_sym): Set symbol and initializer character
	length.
	(gfc_set_constant_character_len): New function. Set constant character
	expression according the given length.
	* match.h (gfc_set_constant_character_len): Add prototype.

2005-04-04  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* intrinsic.texi: BES?? functions are not in the f95 standard.

2005-04-03  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* intrinsic.texi: Document COS, EXP, LOG, LOG10, SIN, SQRT, TAN.

2005-04-03  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* intrinsic.texi: Document BESJ0, BESJ1, BESJN, BESY0, BESY1,
	BESYN, ATAN, COSH, ERF, ERC, SINH, TANH.

2005-04-02  Steven G. Kargl  <kargls@comcast.net>

	* intrinsic.texi: Document ALLOCATED, ANINT, ANY, ASIN; fix typos

2005-04-01  Kazu Hirata  <kazu@cs.umass.edu>

	* decl.c, f95-lang.c, interface.c, module.c, trans-stmt.c,
	trans.h: Fix comment typos.

2005-03-29  Steven G. Kargl  <kargls@comcast.net>

	* gfortran.h (option_t): Change d8, i8, r8 to flag_default_double,
	flag_default_integer, flag_default_real
	* invoke.texi: Update documentation
	* lang.opt: Remove d8, i8, r8 definitions; Add fdefault-double-8
	fdefault-integer-8, and fdefault-real-8 definitions.
	* options.c (gfc_init_options): Set option defaults
	(gfc_handle_option): Handle command line options.
	* trans-types.c (gfc_init_kinds): Use options.

2005-03-29  Keith Besaw  <kbesaw@us.ibm.com>

	* f95-lang.c (builtin_function): Process the attrs parameter
	and apply the "const" attribute to the builtin if found.

2005-03-27  Steven G. Kargl  <kargls@comcast.net>

	* intrinsic.texi: Document AIMAG, AINT, ALL

2005-03-26  Steven G. Kargl  <kargls@comcast.net>

	* arith.c (check_result): Fix illogical logic.

2005-03-26  Canqun Yang  <canqun@nudt.edu.cn>

	* trans-common.c (create_common): Build RECORD_NODE for common blocks
	contain no equivalence objects.
	(add_equivalences): New argument saw_equiv.
	(trans_common): New local variable saw_equiv.
	(finish_equivalences): Add a local variable dummy, Always pass true
	for the 3rd parameter to create_common.

2005-03-25  Steven G. Kargl  <kargls@comcast.net>

	* intrinsic.texi: Fix "make dvi"

2005-03-24  Steven G. Kargl  <kargls@comcast.net>

	* intrinsic.texi: New file.
	* gfortran.texi: Include it; white space change; fix typo.

2005-03-23  Joseph S. Myers  <joseph@codesourcery.com>

	* f95-lang.c (LANG_HOOKS_TRUTHVALUE_CONVERSION): Remove.

2005-03-23  Steven Bosscher  <stevenb@suse.de>

	* convert.c (convert): Replace fold (buildN (...)) with fold_buildN.
	* trans-array.c (gfc_trans_allocate_array_storage,
	gfc_trans_allocate_temp_array gfc_trans_array_constructor_value,
	gfc_conv_array_index_ref, gfc_trans_array_bound_check,
	gfc_conv_array_index_offset, gfc_conv_scalarized_array_ref,
	gfc_conv_array_ref, gfc_trans_preloop_setup, gfc_conv_ss_startstride,
	gfc_conv_loop_setup, gfc_array_init_size, gfc_trans_array_bounds,
	gfc_trans_auto_array_allocation, gfc_trans_dummy_array_bias,
	gfc_conv_expr_descriptor): Likewise.
	* trans-expr.c (gfc_conv_powi, gfc_conv_string_tmp,
	gfc_conv_concat_op, gfc_conv_expr_op): Likewise.
	* trans-intrinsic.c (build_round_expr, gfc_conv_intrinsic_bound,
	gfc_conv_intrinsic_cmplx, gfc_conv_intrinsic_sign,
	gfc_conv_intrinsic_minmaxloc, gfc_conv_intrinsic_minmaxval,
	gfc_conv_intrinsic_btest, gfc_conv_intrinsic_bitop,
	gfc_conv_intrinsic_singlebitop, gfc_conv_intrinsic_ibits,
	gfc_conv_intrinsic_ishft, gfc_conv_intrinsic_ishftc,
	gfc_conv_intrinsic_merge, prepare_arg_info,
	gfc_conv_intrinsic_rrspacing, gfc_conv_intrinsic_repeat): Likewise.
	* trans-stmt.c (gfc_trans_simple_do, gfc_trans_do, gfc_trans_do_while,
	gfc_trans_forall_loop, gfc_do_allocate, generate_loop_for_temp_to_lhs,
	generate_loop_for_rhs_to_temp, compute_inner_temp_size,
	allocate_temp_for_forall_nest, gfc_trans_pointer_assign_need_temp,
	gfc_trans_forall_1, gfc_evaluate_where_mask, gfc_trans_where_assign):
	Likewise.
	* trans-types.c (gfc_get_dtype, gfc_get_array_type_bounds): Likewise.
	* trans.c (gfc_add_modify_expr): Likewise.

2005-03-22  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* check.c (gfc_check_chdir, gfc_check_chdir_sub, gfc_check_kill,
	gfc_check_kill_sub, gfc_check_link, gfc_check_link_sub,
	gfc_check_symlnk, gfc_check_symlnk_sub, gfc_check_rename,
	gfc_check_rename_sub, gfc_check_sleep_sub, gfc_check_gerror,
	gfc_check_getlog, gfc_check_hostnm, gfc_check_hostnm_sub,
	gfc_check_perror): new functions to check newly implemented
	g77 intrinsics.
	* gfortran.h: adding symbols for new intrinsics.
	* intrinsic.c (add_functions): adding new intrinsics.
	(add_subroutines): adding new intrinsics.
	* intrinsic.h: prototype for all checking and resolving
	functions.
	* iresolve.c (gfc_resolve_chdir, gfc_resolve_chdir_sub,
	gfc_resolve_hostnm, gfc_resolve_ierrno, gfc_resolve_kill,
	gfc_resolve_link, gfc_resolve_rename, gfc_resolve_symlnk,
	gfc_resolve_time, gfc_resolve_time8, gfc_resolve_rename_sub,
	gfc_resolve_kill_sub, gfc_resolve_link_sub,
	gfc_resolve_symlnk_sub, gfc_resolve_sleep_sub,
	gfc_resolve_gerror, gfc_resolve_getlog, gfc_resolve_hostnm_sub,
	gfc_resolve_perror): new functions to resolve intrinsics.
	* trans-intrinsic.c (gfc_conv_intrinsic_function): add case
	for new symbols.

2005-03-19  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* dump-parse-tree.c (gfc_show_expr): Dump name of namespace
	in which the variable is declared.

	PR fortran/18525
	* resolve.c (was_declared): Also check for dummy attribute.

2005-03-19  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.h (arith): Remove ARITH_0TO0.
	* arith.c (gfc_arith_error): Remove handling of ARITH_0TO0.
	(gfc_arith_power): Remove special casing of zero to integral
	power zero.

2005-03-18  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Make-lang.in (fortran-warn): Remove -Wno-error.
	(expr.o-warn, resolve.o-warn, simplify.o-warn,
	trans-common.o-warn): Specify -Wno-error.

2005-03-17  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-array.c (gfc_trans_static_array_pointer,
	get_array_ctor_var_strlen, gfc_conv_array_index_offset): Fix
	comment and formatting typos.

2005-03-17  Francois-Xavier Coudert  <coudert@clipper.ens.fr>

	* invoke.texi: Fix typos.

2005-03-15  Zack Weinberg  <zack@codesourcery.com>

	* Make-lang.in (GFORTRAN_TEXI): Add gcc-vers.texi.

2005-03-15  Feng Wang  <fengwang@nudt.edu.cn>

	* trans-stmt.c (gfc_trans_label_assign): Don't set DECL_ARTIFICIAL flag
	to zero on label_tree.

2005-03-15  Feng Wang  <fengwang@nudt.edu.cn>

	PR fortran/18827
	* io.c (resolve_tag): Add checking on assigned label.
	(match_dt_format): Does not set symbol assign attribute.
	* match.c (gfc_match_goto):Does not set symbol assign attribute.
	* resolve.c (resolve_code): Add checking on assigned label.
	* trans-common.c (build_field): Deals with common variable assigned
	a label.
	* trans-stmt.c (gfc_conv_label_variable): New function.
	(gfc_trans_label_assign): Use it.
	(gfc_trans_goto): Ditto.
	* trans-io.c (set_string): Ditto.
	* trans.h (gfc_conv_label_variable): Add prototype.

2005-03-14  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/20467
	* symbol.c (check_conflict): A dummy argument can't be a statement
	function.

2005-03-14  Zdenek Dvorak  <dvorakz@suse.cz>

	* fortran/trans-intrinsic.c (gfc_conv_intrinsic_ishft): Convert
	the argument of the shift to the unsigned type.

2005-03-13  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/16907
	* resolve.c (gfc_resolve_index): Allow REAL indices as an extension.

2005-03-13  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/20323
	* resolve.c (gfc_resolve): Check if character lengths are
	specification expressions.

2005-03-12  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/20361
	* trans-array.c (gfc_stack_space_left): Remove unused variable.
	(gfc_can_put_var_on_stack): Move to trans-decl.c, remove #if 0'ed
	code.
	* trans-array.h (gfc_stack_space_left, gfc_can_put_var_on_stack):
	Remove declaration / prototype.
	* trans-common.c (build_equiv_decl): Give union a name.  Check if
	it can be put on the stack.
	* trans-decl.c (gfc_stack_space_left): Move function here.
	(gfc_build_qualified_array): Fix comment typo.
	* trans.h (gfc_put_var_on_stack): Add prototype.

2005-03-11  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Make-lang.in (fortran-warn): Set to $(STRICT_WARN) -Wno-error.
	* decl.c, trans.c: Don't use C++ style comments.
	* gfortran.h (sym_flavor, procedure_type, sym_intent, gfc_access,
	ifsrc): Give names to enums and use ENUM_BITFIELD.
	(gfc_access): Remove trailing comma.

2005-03-05  Steven G. Kargl  <kargls@comcast.net>

	PR 19936
	* primary.c (match_complex_constant): Mangled complex constant may
	be an implied do-loop.  Give implied do-loop matcher a chance.

2005-03-05  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/19754
	* resolve.c (compare_shapes):  New function.
	(resolve_operator): Use it.

2005-03-05  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-const.c (gfc_conv_constant_to_tree): Use correct tree
	type for COMPLEX constants.

2005-03-04  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/19673
	* trans-expr.c (gfc_conv_function_call): Correctly dereference
	argument from a pointer function also if it has a result clause.

2005-03-04  Steven G. Kargl  <kargls@comcast.net>

	* expr.c (gfc_copy_shape_excluding): Change && to ||.

2005-03-04  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-intrinsic.c (gfc_get_symbol_for_expr): Fix comment typo,
	clarify comment.

2005-02-28  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>
	(port from g95)

	PR fortran/19479
	* simplify.c (gfc_simplify_bound): Rename to ...
	(simplify_bound): ... this and overhaul.

2005-02-28  Steven G. Kargl  <kargl@gcc.gnu.org>

	* trans-intrinsic.c (gfc_conv_intrinsic_iargc): remove boolean argument.
	(gfc_conv_intrinsic_function): update function calls

2005-02-27  Steven G. Kargl  <kargl@gcc.gnu.org>

	PR fortran/20058
	* trans-types.c (gfc_max_integer_kind): Declare
	(gfc_init_kinds): Initialize it.
	* gfortran.h (gfc_max_integer_kind): extern it.
	* primary.c (match_boz_constant): Use it; remove gfortran extension
	of kind suffixes on BOZ literal constants


2005-02-27  Steven G. Kargl  <kargls@comcast.net>

	* arith.c (gfc_check_real_range):  Remove multiple returns
	(check_result): New function.
	(gfc_arith_uminus,gfc_arith_plus,gfc_arith_times,
	gfc_arith_divide,gfc_arith_power,gfc_arith_minus): Use it.


2005-02-24  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* decl.c, resolve.c, trans-array.c, trans.h: Fix comment typo(s).


2005-02-24  Tobias Schl"uter  <tobias.schlueter@physik.uni-meunchen.de>

	Unrevert previously reverted patch.  Adding this fix:
	* module.c (find_true_name): Deal with NULL module.

2005-02-24  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	Revert yesterday's patch:
	2005-02-23  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

		* gfortran.h (gfc_component, gfc_actual_arglist, ...
		... argument.  Copy string instead of pointing to it.

2005-02-23  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.h (gfc_get_namespace): Add second argument to prototype.
	* intrinsic.c (gfc_intrinsic_init_1): Pass second argument to
	gfc_get_namespace.
	* module.c (mio_namespace_ref, load_needed): Likewise.
	* parse.c (parse_interface, parse_contained): Likewise.  Here the
	correct second argument matters.
	* symbol.c (gfc_get_namespace): Add parent_types argument, only copy
	parent's implicit types if this is set.
	(gfc_symbol_init_2): Pass second argument to gfc_get_namespace.
	* trans-common.c (build_common_decl): Likewise.

	* gfortran.h (symbol_attribute): New 'untyped' field, fix comment
	formatting.
	* symbol.c (gfc_set_default_type): Issue error only once, by setting
	and checking 'untyped' attribute.

	* gfortran.h (gfc_expr): Move 'operator', 'op1', 'op2', and 'uop'
	fields into new struct 'op' inside the 'value' union.
	* arith.c (eval_intrinsic): Adapt all users.
	* dependency.c (gfc_check_dependency): Likewise.
	* dump-parse-tree.c (gfc_show_expr): Likewise.
	* expr.c (gfc_get_expr): Don't clear removed fields.
	(free_expr0, gfc_copy_expr, gfc_type_convert_binary,
	gfc_is_constant_expr, simplify_intrinsic_op, check_init_expr,
	check_intrinsic_op): Adapt to new field names.
	* interface.c (gfc_extend_expr): Likewise.  Also explicitly
	nullify 'esym' and 'isym' fields of new function call.
	* iresolve.c (gfc_resolve_dot_product, gfc_resolve_matmul):
	Adapt to renamed structure fields.
	* matchexp.c (build_node, match_level_1, match_expr): Likewise.
	* module.c (mio_expr): Likewise.
	* resolve.c (resolve_operator): Likewise.
	(gfc_find_forall_index): Likewise.  Only look through operands
	if dealing with EXPR_OP
	* trans-array.c (gfc_walk_op_expr): Adapt to renamed fields.
	* trans-expr.c (gfc_conv_unary_op, gfc_conv_power_op,
	gfc_conv_concat_op, gfc_conv_expr_op): Likewise.

	[ Reverted ]
	* gfortran.h (gfc_component, gfc_actual_arglist, gfc_user_op): Make
	'name' a 'const char *'.
	(gfc_symbol): Likewise, also for 'module'.
	(gfc_symtree): Make 'name' a 'const char *'.
	(gfc_intrinsic_sym): Likewise, also for 'lib_name'.
	(gfc_get_gsymbol, gfc_find_gsymbol): Add 'const' qualifier to
	'char *' argument.
	(gfc_intrinsic_symbol): Use 'gfc_get_string' instead of 'strcpy' to
	initialize 'SYM->module'.
	* check.c (gfc_check_minloc_maxloc, check_reduction): Check for NULL
	pointer instead of empty string.
	* dump-parse-tree.c (gfc_show_actual_arglist): Likewise.
	* interface.c (gfc_compare_types): Adapt check to account for possible
	NULL pointer.
	(compare_actual_formal): Check for NULL pointer instead of empty
	string.
	* intrinsic.c (gfc_current_intrinsic, gfc_current_intrinsic_arg):
	Add 'const' qualifier.
	(conv_name): Return a heap allocated string.
	(find_conv): Add 'const' qualifier to 'target'.
	(add_sym): Use 'gfc_get_string' instead of 'strcpy'.
	(make_generic): Check for NULL pointer instead of empty	string.
	(make_alias): Use 'gfc_get_string' instead of 'strcpy'.
	(add_conv): No need to strcpy result from 'conv_name'.
	(sort_actual): Check for NULL pointer instead of empty	string.
	* intrinsic.h (gfc_current_intrinsic, gfc_current_intrinsic_arg):
	Adapt prototype.
	* module.c (compare_true_names): Compare pointers instead of strings
	for 'module' member.
	(find_true_name): Initialize string fields with gfc_get_string.
	(mio_pool_string): New function.
	(mio_internal_string): Adapt comment.
	(mio_component_ref, mio_component, mio_actual_arg): Use
	'mio_pool_string' instead of 'mio_internal_string'.
	(mio_symbol_interface): Add 'const' qualifier to string arguments.
	Add level of indirection. Use 'mio_pool_string' instead of
	'mio_internal_string'.
	(load_needed, read_module): Use 'gfc_get_string' instead of 'strcpy'.
	(write_common, write_symbol): Use 'mio_pool_string' instead of
	'mio_internal_string'.
	(write_symbol0, write_symbol1): Likewise, also check for NULL pointer
	instead of empty string.
	(write_operator, write_generic): Pass correct type variable to
	'mio_symbol_interface'.
	(write_symtree): Use 'mio_pool_string' instead of
	'mio_internal_string'.
	* primary.c (match_keyword_arg): Adapt check to possible
	case of NULL pointer.  Use 'gfc_get_string' instead of 'strcpy'.
	* symbol.c (gfc_add_component, gfc_new_symtree, delete_symtree,
	gfc_get_uop, gfc_new_symbol): Use 'gfc_get_string' instead of
	'strcpy'.
	(ambiguous_symbol): Check for NULL pointer instead of empty string.
	(gfc_find_gsymbol, gfc_get_gsymbol): Add 'const' qualifier on string
	arguments.
	* trans-array.c (gfc_trans_auto_array_allocation): Check for NULL
	pointer instead of empty string.
	* trans-decl.c (gfc_sym_mangled_identifier,
	gfc_sym_mangled_function_id, gfc_finish_var_decl, gfc_get_symbol_decl,
	gfc_get_symbol_decl): Likewise.
	* trans-io.c (gfc_new_nml_name_expr): Add 'const' qualifier to
	argument.  Copy string instead of pointing to it.

2005-02-23  Kazu Hirata  <kazu@cs.umass.edu>

	* intrinsic.h, st.c: Update copyright.

2005-02-20  Steven G. Kargl  <kargls@comcast.net>

	* symbol.c: Typos in comments.

2005-02-20  Steven G. Kargl  <kargls@comcast.net>

	* expr.c (gfc_type_convert_binary): Typo in comment.

2005-02-19  Steven G. Kargl  <kargls@comcast.net>

	* check.c (gfc_check_selected_int_kind): New function.
	* intrinsic.h: Prototype it.
	* intrinsic.c (add_function): Use it.
	* simplify (gfc_simplify_ceiling,gfc_simplify_floor): Change
	  BT_REAL to BT_INTEGER and use gfc_default_integer_kind.

2005-02-19  Steven G. Kargl  <kargls@comcast.net>

	* check.c (gfc_check_int): improve checking of optional kind
	* simplify.c (gfc_simplify_int): Change BT_REAL to BT_INTEGER

2005-02-19  Steven G. Kargl  <kargls@comcast.net>

	* check.c (gfc_check_achar): New function
	* intrinsic.h: Prototype it.
	* intrinsic.c (add_function): Use it.

2005-02-13  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-stmt.c (generate_loop_for_temp_to_lhs,
	generate_loop_for_rhs_to_temp): Remove if whose condition is
	always true.

2005-02-12  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* symbol.c (gfc_use_ha_derived): Remove, fold functionality into ...
	(gfc_use_derived): ... this function.

2005-02-09  Richard Henderson  <rth@redhat.com>

	* f95-lang.c (gfc_init_builtin_functions): Call
	build_common_builtin_nodes; do not define any functions handled
	by it.

2005-02-08  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* expr.c (gfc_copy_expr): Don't copy 'op1' and 'op2' for
	EXPR_SUBSTRING.
	(gfc_is_constant_expr): Check 'ref' to determine if substring
	reference is constant.
	(gfc_simplify_expr): Simplify 'ref' instead of 'op1' and 'op2'.
	(check_init_expr, check_restricted): Check 'ref' instead of 'op1'
	and 'op2'.
	* module.c (mio_expr): Read / write 'ref' instead of 'op1' and 'op2'.

2005-02-07  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.h (gfc_add_dimension, gfc_add_result, gfc_add_save,
	gfc_add_dummy, gfc_add_generic, gfc_add_in_common, gfc_add_data,
	gfc_add_in_namelist, gfc_add_sequence, gfc_add_function,
	gfc_add_subroutine, gfc_add_access, gfc_add_flavor, gfc_add_entry,
	gfc_add_procedure): Add argument.
	* array.c (gfc_set_array_spec), decl.c (var_element, get_proc_name,
	gfc_match_null, match_type_spec, match_attr_spec,
	gfc_match_formal_arglist, match_result, gfc_match_function_decl):
	Update callers to match.
	(gfc_match_entry): Likewise, fix comment typo.
	(gfc_match_subroutine, attr_decl1, gfc_add_dimension,
	access_attr_decl, do_parm, gfc_match_save, gfc_match_modproc,
	gfc_match_derived_decl): Update callers.
	* interface.c (gfc_match_interface): Likewise.
	* match.c (gfc_match_label, gfc_add_flavor,
	gfc_match_call, gfc_match_common, gfc_match_block_data,
	gfc_match_namelist, gfc_match_module, gfc_match_st_function):
	Likewise.
	* parse.c (parse_derived, parse_interface, parse_contained),
	primary.c (gfc_match_rvalue, gfc_match_variable): Likewise.
	* resolve.c (resolve_formal_arglist, resolve_entries): Update callers.
	* symbol.c (check_conflict, check_used): Add new 'name' argument,
	use when printing error message.
	(gfc_add_dimension, gfc_add_result, gfc_add_save, gfc_add_dummy,
	gfc_add_generic, gfc_add_in_common, gfc_add_data,
	gfc_add_in_namelist, gfc_add_sequence, gfc_add_function,
	gfc_add_subroutine, gfc_add_access, gfc_add_flavor, gfc_add_entry,
	gfc_add_procedure): Add new 'name' argument.  Pass along to
	check_conflict and check_used.
	(gfc_add_allocatable, gfc_add_external, gfc_add_intrinsic,
	gfc_add_optional, gfc_add_pointer, gfc_add_target, gfc_add_elemental,
	gfc_add_pure, gfc_add_recursive, gfc_add_intent,
	gfc_add_explicit_interface, gfc_copy_attr): Pass NULL for new
	argument in calls to any of the modified functions.

2005-02-06  Joseph S. Myers  <joseph@codesourcery.com>

	* gfortran.texi: Don't give last update date.

2006-01-30  Richard Henderson  <rth@redhat.com>

	* options.c (gfc_init_options): Zero flag_errno_math.

2005-01-29  Paul Brook  <paul@codesourcery.com>

	PR fortran/18565
	* check.c (real_or_complex_check): New function.
	(gfc_check_fn_c, gfc_check_fn_r, gfc_check_fn_rc): New functions.
	* intrinsic.c (add_functions): Use new check functions.
	* intrinsic.h (gfc_check_fn_c, gfc_check_fn_r, gfc_check_fn_rc):
	Add prototypes.

2005-01-29  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/19589
	* expr.c (gfc_check_assign):  Check for conformance of logical operands

2004-01-27  Steven Bosscher  <stevenb@suse.de>

	* trans-decl.c (gfc_build_label_decl): Set DECL_ARTIFICAL and
	TREE_USED for all labels.
	(gfc_trans_entry_master_switch): Use it instead of building a
	label by hand.
	* trans-io.c (add_case): Likewise.
	* trans-stmt.c (gfc_trans_integer_select): Likewise.

2004-01-23  Paul Brook  <paul@codesourcery.com>
	Steven G. Kargl  <kargls@comcast.net>

	PR fortran/17941
	* arith.c (gfc_convert_real): Remove sign handling.
	* primary.c (match_digits): Allow whitespace after initial sign.
	(match_real_const): Handle signs here.  Allow whitespace after
	initial sign.  Remove dead code.
	(match_const_complex_part): Remove.
	(match_complex_part): Use match_{real,integer}_const.
	(match_complex_constant): Cross-promote integer types.

2005-01-23  James A. Morrison  <phython@gcc.gnu.org>

	PR fortran/19294
	* iresolve.c (gfc_resolve_transpose): Resolve to transpose_c4 or
	transpose_c8 for complex types.

2005-01-23  Kazu Hirata  <kazu@cs.umass.edu>

	* data.c, dependency.c, f95-lang.c, io.c, trans-array.c,
	trans-decl.c, trans-expr.c, trans-intrinsic.c, trans-io.c,
	trans-stmt.c, trans-types.c, trans.h: Fix comment typos.
	Follow spelling conventions.

2005-01-22  Bud Davis  <bdavis9659@comcast.net>

	PR fortran/19313
	* trans-io.c (gfc_trans_inquire): Added code to support
	pad.

2005-01-22  Steven G. Kargl  <kargls@comcast.net>

	* intrinsic.c (make_alias):  Add standard argument.
	(add_functions): Update make_alias calls.

2005-01-22  Paul Brook  <paul@codesourcery.com>

	* trans-expr.c (gfc_conv_function_call): Remove bogus TODO.

2005-01-22  Paul Brook  <paul@codesourcery.com>

	* gfortran.h (gfc_check_access): Add prototype.
	* match.c (gfc_match_namelist): Remove TODO.
	* module.c (check_access): Rename ...
	(gfc_check_access): ... to this.  Boolify.  Update callers.
	* resolve.c (resolve_symbol): Check for private objects in public
	namelists.

2005-01-22  Paul Brook  <paul@codesourcery.com>

	* primary.c (gfc_match_rvalue): Only apply implicit type if variable
	does not have an explicit type.
	(gfc_match_variable): Resolve implicit derived types in all cases.
	Resolve contained function types from their own namespace, not the
	parent.
	* resolve.c (resolve_contained_fntype): Remove duplicate sym->result
	checking.  Resolve from the contained namespace, not the parent.

2005-01-22  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/19543
	* trans-const.c (gfc_conv_constant_to_tree): Give logical
	constants the correct type.

	PR fortran/19194
	* trans-io.c (ADD_STRING): Use gfc_charlen_type_node for string
	length parameters.
	(gfc_build_io_library_fndecls): 'rec' and 'recl_in' are not
	pointer fields.

2005-01-18  Kazu Hirata  <kazu@cs.umass.edu>

	* arith.c, array.c, check.c, decl.c, expr.c, f95-lang.c,
	gfortran.h, interface.c, intrinsic.c, io.c, iresolve.c,
	match.c, matchexp.c, misc.c, module.c, options.c, parse.c,
	scanner.c, simplify.c, symbol.c, trans-array.c, trans-expr.c,
	trans-io.c, trans-stmt.c, trans.c: Update copyright.

2005-01-17  Ira Rosen  <irar@il.ibm.com>

	* f95-lang.c (gfc_init_builtin_functions): Call targetm.init_builtins.

2005-01-16  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/19182
	* error.c (error_char): Line-buffer errors / warnings.

2005-01-16  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-intrinsic.c (gfc_conv_intrinsic_ishft): Fix signed /
	unsigned issue.  Use build_int_cst instead of converting
	integer_zero_node.  Remove unnecessary conversion.

	* trans-types.c (gfc_get_character_type_len): Use
	gfc_charlen_type_node as basic type for the range field.

	* trans-intrinsic.c (build_fixbound_expr,
	gfc_conv_intrinsic_bound, gfc_conv_intrinsic_anyall,
	gfc_conv_intrinsic_count, gfc_conv_intrinsic_btest,
	gfc_conv_intrinsic_singlebitop): Use 'build_int_cst' instead
	of converting 'integer_zero_node' or 'integer_one_node'
	respectively.
	(gfc_conv_intrinsic_ishftc): Same, but store in local variable to
	evade re-building.
	(gfc_conv_intrinsic_strcmp, gfc_conv_intrinsic_rrspacing,
	gfc_conv_intrinsic_trim, gfc_conv_intrinsic_iargc): Use
	'build_int_cst' instead of converting 'integer_zero_node' or
	'integer_one_node' respectively.

	* trans-intrinsic.c (gfc_conv_intrinsic_index,
	gfc_conv_intrinsic_scan, gfc_conv_intrinsic_verify): Remove
	'gfc'-prefix from local variable, remove dead code, use correct
	type when inserting argument.

	* trans-intrinsic.c, trans-types.c: Update copyright years.

2005-01-16  Steven G. Kargl  <kargls@comcast.net>

	PR 19168
	* resolve.c (check_case_overlap): Typo in comment.
	(validate_case_label_expr):  Fix up kinds of case values
	(resolve_select): Properly handle kind mismatches.

2004-01-16  Paul Brook  <paul@codesourcery.com>

	PR fortran/17675
	* trans-common.c (translate_common): Remove duplicate function call.
	(finish_equivalences): Preserve alignment when biasing offsets.

2005-01-15  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de

	* primary.c (check_digit): Call 'ISXDIGIT' instead of assuming
	ASCII-like character encoding.

2005-01-14  Steven G. Kargl  <kargls@comcast.net>

	* resolve.c (compare_case): Cleanup.

2005-01-14  Steven G. Kargl  <kargls@comcast.net>

	* resolve.c (compare_case): Give arguments correct type.

2005-01-13  Kazu Hirata  <kazu@cs.umass.edu>

	* iresolve.c, trans-common.c, trans-types.c: Fix comment
	typos.

2005-01-09  Paul Brook  <paul@codesourcery.com>

	PR fortran/17675
	* trans-common.c (current_common, current_offset): Remove.
	(create_common): Add head argument.
	(align_segment): New function.
	(apply_segment_offset): New function.
	(translate_common): Merge code from new_segment.  Handle alignment.
	(new_segment): Remove.
	(finish_equivalences): Ensure proper alignment.

2005-01-08  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-const.c: Don't include unused math.h.

	* trans-intrinsic.c (gfc_get_intrinsic_lib_fndecl,
	gfc_conv_intrinsic_bound, gfc_conv_intrinsic_minmaxloc,
	gfc_conv_intrinsic_ishft, gfc_conv_intrinsic_len): Remove
	trailing whitespace.
	(prepare_arg_info): Fix formatting, indenting and remove trailing
	whitespace.
	(gfc_conv_intrinsic_spacing, gfc_conv_intrinsic_trim): Remove
	trailing whitespace.

	* arith.c (arctangent2, gfc_arith_init_1, gfc_arith_done_1,
	gfc_constant_result, gfc_range_check, gfc_arith_power,
	eval_type_intrinsic0, eval_intrinsic_f2, gfc_real2real,
	gfc_real2complex, gfc_complex2int, gfc_complex2real,
	gfc_complex2complex): Fix whitespace issues.
	* check.c (must_be, type_check, numeric_check, int_or_real_check,
	logical_array_check, array_check, scalar_check, nonoptional_check,
	variable_check, dim_check, check_a_kind, gfc_check_a_ikind,
	gfc_check_a_xkind, gfc_check_abs, gfc_check_all_any,
	gfc_check_allocated, gfc_check_a_p, gfc_check_besn,
	gfc_check_btest, gfc_check_char, gfc_check_cmplx, gfc_check_count,
	gfc_check_cshift, gfc_check_dcmplx, gfc_check_dble,
	gfc_check_digits, gfc_check_dot_product, gfc_check_eoshift,
	gfc_check_fnum, gfc_check_g77_math1, gfc_check_huge, gfc_check_i,
	gfc_check_iand, gfc_check_ibclr, gfc_check_ibits, gfc_check_ibset,
	gfc_check_idnint, gfc_check_ieor, gfc_check_index, gfc_check_int,
	gfc_check_ior, gfc_check_ishft, gfc_check_ishftc, gfc_check_kind,
	gfc_check_lbound, gfc_check_logical, min_max_args,
	gfc_check_min_max_integer, gfc_check_min_max_real,
	gfc_check_min_max_double, gfc_check_matmul,
	gfc_check_minval_maxval, gfc_check_merge, gfc_check_nearest,
	gfc_check_pack, gfc_check_precision, gfc_check_radix,
	gfc_check_range, gfc_check_real, gfc_check_repeat,
	gfc_check_scale, gfc_check_scan, gfc_check_selected_real_kind,
	gfc_check_set_exponent): Fix formatting issues.
	(gfc_check_size, gfc_check_sign): Alphabetize function order,
	remove whitespace-only line.
	(gfc_check_fstat, gfc_check_fstat_sub, gfc_check_stat,
	gfc_check_stat_sub, gfc_check_transfer, gfc_check_transpose,
	gfc_check_ubound, gfc_check_unpack, gfc_check_verify, gfc_check_x,
	gfc_check_cpu_time, gfc_check_date_and_time, gfc_check_mvbits,
	gfc_check_random_number, gfc_check_random_seed,
	gfc_check_second_sub, gfc_check_system_clock,
	gfc_check_getcwd_sub, gfc_check_exit, gfc_check_flush,
	gfc_check_umask, gfc_check_umask_sub, gfc_check_unlink,
	gfc_check_unlink_sub): Fix formatting issues.

2005-01-08  Tobias Schl"uter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.h: Remove outdated comment.  Don't include stdio.h
	explicitly.

2005-01-06  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortranspec.c (lang_specific_driver): Change year to 2005 in
	output of 'gfortran --version'.

2005-01-03  Steven G. Kargl  <kargls@comcast.net>

	* arith.c: Add system.h; remove string.h
	* decl.c: Ditto
	* matchexp.c: Ditto
	* parse.c: Ditto
	* resolve.c: Ditto
	* st.c: Ditto
	* check.c: Remove stdlib.h and stdarg.h
	* error.c: Remove stdlib.h, stdarg.h, stdio.h, string.h
	* expr.c: Add system.h; remove stdarg.h, stdio.h, and string.h
	* f95-lang.c: Add system.h; remove stdio.h
	* interface.c: Add system.h; remove stdlib.h and string.h
	* intrinsic.c: Remove stdarg.h, stdio.h, and string.h
	* io.c: Remove string.h
	* simplify.c: Ditto
	* match.c: Remove stdarg.h and string.h
	* misc.c: Update copyright; add system.h; remove stdlib.h,
	string.h, and sys/stat.h
	* module.c: Add system.h; remove string.h, stdio.h, errno.h,
	unistd.h, and time.h
	* option.c: Remove string.h and stdlib.h
	* primary.c: Ditto
	* scanner.c: Update copyright; add system.h; remove stdlib.h,
	stdio.h, string.h, and strings.h
	* symbol.c: Add system.h; remove stdlib.h, stdio.h, and string.h
	* trans-array.c: Remove stdio.h and gmp.h
	* trans-const.c: Ditto
	* trans-expr.c: Ditto
	* trans-io.c: Ditto
	* trans-stmt.c: Ditto
	* trans.c: Ditto
	* trans-intrinsic.c: Remove stdio.h and string.h

2004-12-29  Steven G. Kargl  <kargls@comcast.net>

	* gfortran.h (gfc_case): fix typo in comment.

2004-12-27  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-intrinsic.c (gfc_conv_intrinsic_ishft): Change to
	logical	shift.  Call fold.  Remove 0-bit shift shortcut.
	(gfc_conv_intrinsic_ishftc): Convert first argument to at least
	4 bytes bits.  Convert 2nd and 3rd argument to 4 bytes.  Convert
	result if width(arg 1) < 4 bytes.  Call fold.

	PR fortran/19032
	* trans-intrinsic.c (gfc_conv_intrinsic_mod): Update comment
	in front of function to match the standard.  Correct handling
	of MODULO.

2004-12-27  Andrew Pinski  <pinskia@physics.uc.edu>

	* trans-expr.c (gfc_conv_cst_int_power): Only check for
	flag_unsafe_math_optimizations if we have a float type.

2004-12-23  Steven G. Kargl  <kargls@comcast.net>

	* gfortran.texi: Fix typo.

2004-12-16  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-intrinsic.c (build_fixbound_expr): Clarify comment, fix
	comment typo.

2004-12-15  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/18993
	* match.c (gfc_match_if): Don't explicitly skip optional whitespace.
	(gfc_match_nullify): Make sure that ')' is in front of the end of
	statement.

	* scanner.c (skip_fixed_comments): Fix typo in comment preceding
	function.

2004-12-14  Richard Henderson  <rth@redhat.com>

	* gfortran.h (gfc_expr.function.name): Make const.
	(gfc_iresolve_init_1, gfc_iresolve_done_1): Remove.
	(gfc_get_string): Update prototype.
	* iresolve.c: Include tree.h.
	(string_node, HASH_SIZE, string_head, hash): Remove.
	(gfc_get_string): Use vsnprintf, get_identifier.
	(free_strings, gfc_iresolve_init_1, gfc_iresolve_done_1): Remove.
	* misc.c (gfc_init_1): Don't call gfc_iresolve_init_1.
	(gfc_done_1): Don't call gfc_iresolve_done_1.
	* module.c (mio_allocated_string): Take and return const char *,
	instead of modifying char**.
	(mio_expr): Update to match.
	* resolve.c (pure_function): Constify name argument.
	(resolve_function): Constify name.
	* trans-intrinsic.c (gfc_conv_intrinsic_function): Likewise.

2004-12-12  Richard Henderson  <rth@redhat.com>

	* iresolve.c (gfc_resolve_all, gfc_resolve_any, gfc_resolve_count,
	gfc_resolve_cshift, gfc_resolve_dot_product, gfc_resolve_eoshift,
	gfc_resolve_matmul, gfc_resolve_maxloc, gfc_resolve_maxval,
	gfc_resolve_minloc, gfc_resolve_minval, gfc_resolve_pack,
	gfc_resolve_product, gfc_resolve_reshape, gfc_resolve_shape,
	gfc_resolve_spread, gfc_resolve_sum, gfc_resolve_transpose,
	gfc_resolve_unpack: Use PREFIX.

2004-12-12  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/18869
	* match.c (gfc_match_common): Skip whitespace.

2004-12-12  Steven G. Kargl  <kargls@comcast.net>

	PR fortran/16581
	* check.c (gfc_check_iand, gfc_check_ibclr, gfc_check_ibits,
	gfc_check_ibset, gfc_check_ieor, gfc_check_ior): Remove default
	integer kind check; Issue error for -std=f95 when needed.
	* intrinsic.c (add_functions): Change ieor from GFC_STD_GNU to
	GFC_STD_F95.
	* iresolve.c (gfc_resolve_iand, gfc_resolve_ieor, gfc_resolve_ior):
	Promote arguments to same kind.

2004-12-12  Steven G. Kargl  <kargls@comcast.net>
	Paul Brook  <paul@codesourcery.com>

	PR fortran/16222
	* resolve.c (gfc_resolve_iterator_expr): New function.
	(gfc_resolve_iterator): Use it.  Add real_ok argument.  Convert
	start, end and stride to correct type.
	(resolve_code): Pass extra argument.
	* array.c (resolve_array_list): Pass extra argument.
	* gfortran.h (gfc_resolve): Add prototype.
	* trans-stmt.c (gfc_trans_do): Remove redundant type conversions.
	Handle real type iterators.

2004-12-11  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/17175
	* iresolve.c (gfc_resolve_scale): Convert 'I' argument if not of
	same kind as C's 'int'.
	(gfc_resolve_set_exponent): Convert 'I' argument if not of kind 4.

2004-12-08  Richard Henderson  <rth@redhat.com>

	* intrinsic.c (gfc_convert_type_warn): Propagate the input shape
	to the output expression.
	* iresolve.c (gfc_resolve_cshift, gfc_resolve_eoshift): Suppress
	warning conversion.
	(gfc_resolve_reshape): Force convert SHAPE and ORDER parameters
	to index kind.

2004-12-08  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/18826
	* resolve.c (resolve_code): Impose correct restrictions on
	assigned variable.

	* decl.c (gfc_match_end): Use locus of END when eos is an error.

2004-12-02  Steven G. Kargl  <kargls@comcast.net>
	Paul Brook  <paul@codesourcery.com>

	* check.c (gfc_check_flush, gfc_check_fnum): New functions.
	(gfc_check_fstat, gfc_check_fstat_sub): New functions.
	(gfc_check_stat, gfc_check_stat_sub): New functions.
	* gfortran.h (GFC_ISYM_FNUM,GFC_ISYM_FSTAT,GFC_ISYM_STAT): New symbols
	* intrinsic.c (add_functions,add_subroutines): Add flush, fnum,
	fstat, and stat to intrinsics symbol tables.
	* intrinsic.h (gfc_check_flush, gfc_resolve_stat_sub): Add prototypes.
	(gfc_resolve_fstat_sub, gfc_resolve_stat): Ditto.
	* iresolve.c (gfc_resolve_fnum, gfc_resolve_fstat): New functions.
	(gfc_resolve_stat, gfc_resolve_flush): New functions.
	(gfc_resolve_stat_sub,gfc_resolve_fstat_sub): New functions
	* trans-intrinsic.c (gfc_conv_intrinsic_function): Add new intrinsics.

2004-12-02  Steven G. Kargl  <kargls@comcast.net>

	* intrinsic.c: Fix and add comments, fix function declarations
	(OPTIONAL,REQUIRED): New symbols
	(add_functions,add_subroutines): Use symbols
	(gmp.h): Remove unused include

2004-11-25  Joseph S. Myers  <joseph@codesourcery.com>

	* f95-lang.c, gfortranspec.c, trans-decl.c: Avoid ` as left quote
	in diagnostics.

2004-11-24  Steven Bosscher  <stevenb@suse.de>

	* options.c (gfc_post_options): Don't clear flag_inline_functions.

2004-11-20  Steven G. Kargl  <kargls@comcast.net>

	* check.c (gfc_check_getcwd_sub): Fix seg fault.

	* check.c (gfc_check_exit,gfc_check_umask,gfc_check_umask_sub,
	gfc_check_unlink,gfc_check_unlink_sub): New functions
	* gfortran.h (GFC_ISYM_UMASK,GFC_ISYM_UNLINK): New symbols
	* intrinsic.c (add_functions,add_subroutines): Add umask, unlink,
	exit to intrinsics symbol tables.
	* intrinsic.h (gfc_check_umask,gfc_check_unlink,gfc_check_exit,
	gfc_check_umask_sub,gfc_check_unlink_sub,gfc_resolve_umask,
	gfc_resolve_unlink,gfc_resolve_exit,gfc_resolve_umask_sub,
	gfc_resolve_unlink_sub): Add and sort prototypes.
	* iresolve.c (gfc_resolve_umask,gfc_resolve_unlink,gfc_resolve_exit,
	gfc_resolve_umask_sub,gfc_resolve_unlink_sub): New functions
	* trans-intrinsic.c (gfc_conv_intrinsic_function): Use symbols

2004-11-16  Paul Brook  <paul@codesourcery.com>

	PR fortran/13010
	* trans-array.c (gfc_trans_allocate_temp_array): Use gfc_get_dtype.
	(gfc_array_init_size, gfc_conv_expr_descriptor): Ditto.
	* trans-types.c (gfc_get_dtype): Accept array type rather than element
	type.
	(gfc_get_nodesc_array_type): Don't set GFC_TYPE_ARRAY_DTYPE.
	(gfc_get_array_type_bounds): Ditto.
	(gfc_get_derived_type): Recurse into derived type pointers.
	* trans-types.h (gfc_get_dtype): Add prototype.
	* trans.h (GFC_TYPE_ARRAY_DTYPE): Add comment.

2004-11-15  Paul Brook  <paul@codesourcery.com>

	* trans-types.c (gfc_get_dtype): Remove obsolete TODO.

2004-11-10  Paul Brook  <paul@codesourcery.com>

	PR fortran/18375
	* trans-expr.c (gfc_trans_subarray_assign): Free shape before ss.
	* trans-io.c (transfer_array_component): Ditto.

2004-11-10  Paul Brook  <paul@codesourcery.com>

	* invoke.texi: Fix typo.

2004-11-08  Kazu Hirata  <kazu@cs.umass.edu>

	* arith.c, array.c, decl.c, expr.c, f95-lang.c, gfortran.h,
	gfortranspec.c, interface.c, intrinsic.c, iresolve.c, match.c,
	module.c, parse.c, parse.h, primary.c, resolve.c, scanner.c,
	trans-array.c, trans-array.h, trans-expr.c, trans-intrinsic.c,
	trans-io.c, trans-stmt.c, trans.h: Fix comment formatting.

2004-11-06  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/18023
	* io.c (resolve_tag): Tighten up exception for assigned FORMAT.

2004-11-06  Kazu Hirata  <kazu@cs.umass.edu>

	* gfortranspec.c: Replace GNU CC with GCC.

2004-11-05  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortranspec.c (lang_specific_driver): Change year to 2004.

2004-11-05  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/18111
	*  trans-decl.c (create_function_arglist): Set DECL_ARTIFICIAL for
	hidden parameters.

2004-11-05  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/15164
	* trans-decl.c (gfc_finish_var_decl): Don't declare arguments to
	module procedures as if they were module variables.

2004-11-03  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/17535
	PR fortran/17583
	PR fortran/17713
	* module.c (write_symbol1): Set module_name for dummy arguments.

2004-11-02  Paul Brook  <paul@codesourcery.com>

	* intrinsic.c (check_intrinsic_standard): Include error locus.
	Remove VLA.
	(gfc_intrinsic_func_interface, gfc_intrinsic_sub_interface): Pass
	locus to check_intrinsic_standard.

2004-10-31  Janne Blomqvist  <jblomqvi@cc.hut.fi>

	PR fortran/17590
	* gfortran.h: Change GFC_STD_* flags to more appropriate
	ones. (struct gfc_intrinsic_isym): Add field for standard. (struct
	gfc_option_t): Add field for warning about use of nonstandard
	intrinsics.
	* intrinsic.c (add_sym): Add parameter for standard version, check
	this against current standard.
	(add_sym_0): Pass standard parameter to add_sym.
	(add_sym_1, add_sym_0s, add_sym_1s, add_sym_1m, add_sym_2): Ditto.
	(add_sym_2s, add_sym_3, add_sym_3ml, add_sym_3red, add_sym_3s): Ditto.
	(add_sym_4, add_sym_4s, add_sym_5, add_sym_5s): Ditto.
	(make_generic): Add parameter for standard, check this
	against currently selected standard.
	(add_functions, add_subroutines): Add parameter to tell which
	standard an intrinsic belongs to.
	(check_intrinsic_standard): New function.
	(gfc_intrinsic_func_interface): Add call to check_intrinsic_standard.
	(gfc_intrinsic_sub_interface): Ditto.
	* lang.opt: Add Wnonstd-intrinsics option.
	* options.c (gfc_init_options): Change to use new GFC_STD_* flags,
	init new warning.
	(set_Wall): Add warning about nonstd intrinsics.
	(gfc_handle_option): Change to use new GFC_STD_* flags,
	handle new warning.
	* invoke.texi: Update manual to include -Wnonstd-intrinsics.

2004-10-30  Andrew Pinski  <pinskia@physics.uc.edu>

	* f95-lang.c (lang_tree_node): Add chain_next to be the TREE_CHAIN.

2004-10-30  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* simplify.c (twos_complement): Calculate mask in GMP arithmetic.

2004-10-30  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans.c (gfc_trans_code): Set global locus after recursing. Fix
	comment typo.

2004-10-30  Canqun Yang  <canqun@nudt.edu.cn>

	* check.c (gfc_check_rand): Allow missing optional argument.
	(gfc_check_irand): Ditto.
	* intrinsic.c (add_functions): Set arg optional flag for {i,}rand.

2004-10-28  Scott Robert Ladd  <scott.ladd@coyotegulch.com>

	PR fortran/13490, PR fortran/17912
	* gcc/fortran/gfortran.h: Added pedantic_min_int to gfc_integer_info
	* gcc/fortran/gfortran.h: Added ARITH_ASYMMETRIC to arith
	* gcc/fortran/arith.c: Added support for an "asymmetric integer"
	warning when compiling with pedantic.
	* gcc/fortran/arith.c: Set minimum integer values to reflect
	realities of two's complement signed integers. Added
	pedantic minimum.

2004-10-17  Andrew Pinski  <pinskia@physics.uc.edu>

	* Make-lang.in (F95_ADDITIONAL_OBJS): Kill.
	(f951): Do not depend on F95_ADDITIONAL_OBJS and don't
	link it in.

2004-10-14  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-decl.c (generate_local_decl): Simplify logic, fix comment
	typo.
	(gfc_generate_function_code): Fix formatting issue.

2004-10-10  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* module.c: Fix formatting issues.

2004-10-09  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* module.c (mio_interface_rest): Set where member of interface
	while loading.

2004-10-08  Andrew Pinski  <pinskia@physics.uc.edu>

	PR fortran/17901
	* options.c (gfc_handle_option): Add break after handing the
	J/M option.

2004-10-08  Tobias Schlueter  <tobias.shclueter@physik.uni-muenchen.de>

	* arith.c: Fix formatting issues.

2004-10-07  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/17676
	* resolve.c (resolve_operator): Use correct operator name in message.

2004-10-07  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* primary.c (match_boz_constant): Allow kind parameter suffixes.
	Move standard warning further to the front.

2004-10-07  Kazu Hirata  <kazu@cs.umass.edu>

	* trans-stmt.c: Fix a comment typo.

2004-10-07  Paul Brook  <paul@codesourcery.com>

	PR fortran/17678
	* trans-array.c (gfc_trans_deferred_array): Leave use associated
	variables alone.

2004-10-06  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/17568
	* simplify.c (twos_complement): New function.
	(gfc_simplify_ishft, gfc_simplify_ishftc): Revise.

	* simplify.c (gfc_simplify_abs): Use mpfr_hypot for CABS.

2004-10-06  Paul Brook  <paul@codesourcery.com>

	* trans-stmt.c (gfc_trans_simple_do): New function.
	(gfc_trans_do): Use it.  Evaluate iteration bounds before entering
	loop.  Update comments.

2004-10-04  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/17283
	* iresolve.c (gfc_resolve_pack): Choose function depending if mask
	is scalar.

	PR fortran/17631
	* intrinsic.c (add_sym_5): Remove.
	(add_subroutines): Add resolution function for MVBITS.
	* intrinsic.h (gfc_resolve_mvbits): Declare resolution function for
	MVBITS
	* iresolve.c (gfc_resolve_mvbits): New function.
	(gfc_resolve_random_number): Remove empty line at end of function.

	* trans-const.c (gfc_build_cstring_const): New function.
	(gfc_init_cst): Use new function.
	* trans-const.h (gfc_build_cstring_const): Add prototype.
	* trans-io.c (set_string, set_error_locus): Use new function.
	* trans-stmt.c (gfc_trans_goto): Use new function.

	PR fortran/17708
	* parse.c (accept_statement): Don't treat END DO like END IF and
	END SELECT.
	(parse_do_block): Generate possible END DO label inside END DO
	block.

	PR fortran/17776
	* check.c (gfc_check_system_sub): New function.
	* gfortran.h (gfc_generic_isym_id): Add GFC_ISYM_SYSTEM.
	* intrinsic.c (add_functions): Add 'system'.
	(add_subroutines): Add 'system'.
	* intrinsic.h (gfc_check_etime_sub, gfc_check_getcwd_sub):
	Move prototypes to other suborutines.
	(gfc_check_system_sub, gfc_resolve_system, gfc_resolve_system_sub):
	Add prototype.
	(gfc_resolve_system_clock): Fix formatting of prototype.
	* iresolve.c (gfc_resolve_system, gfc_resolve_system_sub): New
	functions.
	* trans-intrinsic.c (gfc_conv_intrinsic_function): Deal with
	GFC_ISYM_SYSTEM.

2004-10-04  Erik Schnetter  <schnetter@aei.mpg.de>

	* scanner.c (preprocessor_line): Accept preprocessor lines without
	file names.  Check file names for closing quotes.  Handle escaped
	quotes in file names.

2004-10-04  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>
	Paul Brook  <paul@codesourcery.com>

	* trans-array.c (gfc_conv_expr_descriptor): Check for substriungs.
	Use gfc_get_expr_charlen.
	* trans-expr.c (gfc_get_expr_charlen): New function.
	* trans.h (gfc_get_expr_charlen): Add prototype.

2004-10-04  Kazu Hirata  <kazu@cs.umass.edu>

	* trans-intrinsic.c: Fix a comment typo.

2004-10-03  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* simplify.c (range_check): Remove blank line at beginning of function.
	(gfc_simplify_dint): Same at end of function.
	(gfc_simplify_exponent, gfc_simplify_fraction): Simplify calculations.
	(gfc_simplify_bound): Fix indentation.
	(gfc_simplify_log10): Simplify calculation.
	(gfc_simplify_min, gfc_simplify_max): Remove blank line at beginning
	of function.
	(gfc_simplify_nearest): Same at end of function.
	(gfc_simplify_nint, gfc_simplify_idnint): Same at beginning of
	function.
	(gfc_simplify_rrspacing, gfc_simplify_set_exponent,
	gfc_simplify_spacing): Simplify calulations.

2004-10-03  Feng Wang  <fengwang@nudt.edu.cn>

	* trans-intrinsic.c: Fix comments on spacing and rrspacing
	(gfc_conv_intrinsic_rrspacing): Add fold on constant trees.

2004-10-01  Jan Hubicka  <jh@suse.cz>

	* f95-lang.c (gfc_expand_function): Update call of
	tree_rest_of_compilation.
	* trans-decl.c (gfc_generate_constructors): Likewise.

2004-09-26  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-intrinsic.c: Comment fixes.

2004-09-25  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* decl.c (add_init_expr_to_sym, variable_decl): Comment fixes.

2004-09-24  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-types.c (gfc_return_by_reference): Remove superfluous
	assertion.

	* intrinsic.h (gfc_resolve_getcwd): Update prototype.
	* iresolve.c (gfc_resolve_getcwd): Add second argument to function.

	PR fortran/17615
	* trans-expr.c (gfc_trans_arrayfunc_assign): Look at resolved
	function to determine return type.

2004-09-20  Jan Hubicka  <jh@suse.cz>

	* trans-decl.c (build_entry_thunks): Finalize the function; do not lower
	tree.
	(gfc_generate_function_code): Likewise.

2004-09-20  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/15957
	* simplify.c (gfc_simplify_reshape): Set shape of return value
	correctly.

2004-09-17  Jeffrey D. Oldham  <oldham@codesourcery.com>
	    Zack Weinberg  <zack@codesourcery.com>

	* f95-lang.c, trans-expr.c, trans.c: Update for new tree-class
	enumeration constants.

2004-09-17  Paul Brook  <paul@codesourcery.com>

	* gfortran.h (struct gfc_linebuf): Don't use C99 empty arrays.
	(gfc_linebuf_header_size): Define.
	* scanner.c (load_file): Use it.

2004-09-16  Kazu Hirata  <kazu@cs.umass.edu>

	* array.c, data.c, decl.c, dependency.c, error.c, f95-lang.c,
	interface.c, intrinsic.c, io.c, misc.c, module.c, parse.h,
	resolve.c, scanner.c, trans-array.c, trans-array.h,
	trans-common.c, trans-const.h, trans-decl.c, trans-expr.c,
	trans-intrinsic.c, trans-stmt.c, trans-types.c, trans.c,
	trans.h: Fix comment typos.  Follow spelling conventions.

2004-09-16  Victor Leikehman  <lei@il.ibm.com>

	PR/15364
	* trans-io.c (transfer_array_component): New function.
	(transfer_expr): For array fields, call transfer_array_component.

2004-09-16  Kazu Hirata  <kazu@cs.umass.edu>

	* gfortran.texi: Fix a typo.

2004-09-15  Aaron W. LaFramboise  <aaronavay62@aaronwl.com>

	* parse.c (eof_buf): Rename eof to eof_buf.
	(unexpected_eof): Same.
	(gfc_parse_file): Same.

2004-09-15  Steven G. Kargl  <kargls@comcast.net>

	* check.c (gfc_check_getcwd_sub): New function.
	* gfortran.h (GFC_ISYM_GETCWD): New symbol.
	* intrinsic.c (add_functions): Add function definition;
	Use symbol.
	* intrinsic.c (add_subroutines): Add subroutine definitions.
	* intrinsic.h: Add prototypes.
	* iresolve.c (gfc_resolve_getcwd, gfc_resolve_getcwd_sub):
	New functions.
	* trans-intrinsic.c (gfc_conv_intrinsic_function): Use symbol.

2004-09-15  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/16485
	* module.c (write_symbol): Don't fill in module name here.
	(write_symbol0): Fill in here instead.

2004-09-14  Kazu Hirata  <kazu@cs.umass.edu>

	* data.c, decl.c, f95-lang.c, gfortran.h, match.c,
	trans-array.c, trans-common.c, trans-expr.c,
	trans-intrinsic.c, trans-stmt.c, trans-types.c, trans.h: Fix
	comment typos.  Follow spelling conventions.

2004-09-09  Paul Brook  <paul@codesourcery.com>

	* scanner.c (get_file): Add ATTRIBUTE_UNUSED.

2004-09-08  Paul Brook  <paul@codesourcery.com>

	* array.c: Don't include assert.h.
	* data.c: Don't include assert.h.  Replace assert and abort with
	gcc_assert and gcc_unreachable.
	* dependency.c: Ditto.
	* f95-lang.c: Ditto.
	* iresolve.c: Ditto.
	* resolve.c: Ditto.
	* simplify.c: Ditto.
	* symbol.c: Ditto.
	* trans-array.c: Ditto.
	* trans-common.c: Ditto.
	* trans-const.c: Ditto.
	* trans-decl.c: Ditto.
	* trans-expr.c: Ditto.
	* trans-intrinsic.c: Ditto.
	* trans-io.c: Ditto.
	* trans-stmt.c: Ditto.
	* trans-types.c: Ditto.
	* trans.c: Ditto.

2004-09-07  Per Bothner  <per@bothner.com>
	Paul Brook  <paul@codesourcery.com>

	* error.c (show_locus): Handle mapped locations.
	* f95-lang.c (gfc_be_parse_file): Initialize mapped locations.
	* gfortran.h: Include input.h.
	(struct gfc_linebuf): Use source_location.
	* scanner.c (get_file): Initialize linemap.
	(preprocessor_line): Pass extra argument to get_file.
	(load_file): Ditto.  Setup linemap.
	(gfc_new_file): Handle mapped locations.
	* trans-common.c (build_field, build_equiv_decl, build_common_decl):
	Set decl source locations.
	(gfc_trans_common): Set blank common block location.
	* trans-decl.c (gfc_set_decl_location): New function.
	(gfc_get_label_decl, gfc_get_symbol_decl): Use it.
	(trans_function_start): Move call to gfc_set_backend_locus..
	(build_function_decl): ... to here.
	(build_entry_thunks): Set and restore the backend locus.
	(gfc_generate_constructors): Remove excess arguments to
	init_function_start.
	(gfc_generate_block_data): Add comments.  Set the decl locus.
	* trans-io.c (set_error_locus): Handle mapped locations.
	* trans.c (gfc_get_backend_locus, gfc_get_backend_locus): Ditto.
	(gfc_trans_code): Use SET_EXPR_LOCATION.
	(gfc_generate_code): Override the location of the new symbol.
	* trans.h (gfc_set_decl_location): Add prototype.

2004-08-31  Paul Brook  <paul@codesourcery.com>

	* trans-types.c (gfc_type_for_mode): Return NULL for unknown modes.

2004-09-01  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/15327
	* trans-intrinsic.c (gfc_conv_intrinsic_merge): Do the right thing for
	strings.

2004-09-01  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/16400
	PR fortran/16404
	(port from g95)
	* resolve.c (resolve_transfer): New function.
	(resolve_code): Call resolve_transfer in case of EXEC_TRANSFER.

2004-08-31  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/16579
	* trans-types.c (gfc_init_types): Make gfc_character1_type_node an
	unsigned char.

2004-08-31  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* CONTRIB, NEWS, README, TODO: Remove obsolete files.

2004-08-31  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/17244
	* trans-types.c (gfc_return_by_reference): Remove TODO error,
	add comment pointing out possible issue WRT compatibility with g77.

2004-08-31  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-decl.c, trans-expr.c, trans-io.c, trans-types.c: Replace
	all occurences of 'gfc_strlen_type_node' by
	'gfc_charlen_type_node'.
	* trans-types.h: Same. Also update comment accordingly.

2004-08-31  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* primary.c: Update copyright boilerplate to say GCC.
	* f95-lang.c: Change initial comment to say gfortran.

2004-08-31  Paul Brook  <paul@codesourcery.com>

	* trans-types.h: Add comments.
	(intmax_type_node, string_type_node, const_string_type_node): Remove.

2004-08-30  Richard Henderson  <rth@redhat.com>

	* Make-lang.in (fortran/f95-lang.o): Update dependencies.
	(fortran/trans-decl.o, fortran/trans-types.o): Likewise.
	* gfortran.h (gfc_integer_info): Add c_char, c_short, c_int,
	c_long, c_long_long.
	(gfc_logical_info): Add c_bool.
	(gfc_real_info): Add mode_precision, c_float, c_double, c_long_double.
	* trans-array.c (gfc_array_allocate): Use TYPE_PRECISION
	rather than gfc_int[48]_type_node for allocate choice.
	* trans-decl.c (gfc_build_intrinsic_function_decls): Cache
	local copies of some kind type nodes.
	(gfc_build_builtin_function_decls): Likewise.
	* trans-expr.c (gfc_conv_power_op): Likewise.
	* trans-intrinsic.c (gfc_conv_intrinsic_index,
	gfc_conv_intrinsic_scan, gfc_conv_intrinsic_verify,
	gfc_conv_intrinsic_trim, gfc_conv_intrinsic_repeat): Likewise.
	* trans-stmt.c (gfc_trans_pause, gfc_trans_stop,
	gfc_trans_character_select, gfc_trans_allocate): Likewise.
	* trans-io.c (gfc_pint4_type_node): Move into ...
	(gfc_build_io_library_fndecls): ... here.  Cache local copies of
	some kind type nodes.
	* trans-types.c (gfc_type_nodes): Remove.
	(gfc_character1_type_node, gfc_strlen_type_node): New.
	(gfc_integer_types, gfc_logical_types): New.
	(gfc_real_types, gfc_complex_types): New.
	(gfc_init_kinds): Fill in real mode_precision.
	(gfc_build_int_type, gfc_build_real_type): New.
	(gfc_build_complex_type, gfc_build_logical_type): New.
	(c_size_t_size): New.
	(gfc_init_types): Loop over kinds.
	(gfc_get_int_type, gfc_get_real_type): Use gfc_validate_kind.
	(gfc_get_complex_type, gfc_get_logical_type): Likewise.
	(gfc_get_character_type_len): Likewise.
	(gfc_type_for_size): Loop over kinds; use a reduced set of
	unsigned type nodes.
	(gfc_type_for_mode): Loop over kinds.
	(gfc_signed_or_unsigned_type): Use gfc_type_for_size.
	(gfc_unsigned_type, gfc_signed_type): Use gfc_signed_or_unsigned_type.
	* trans-types.h (F95_INT1_TYPE, F95_INT2_TYPE, F95_INT4_TYPE,
	F95_INT8_TYPE, F95_INT16_TYPE, F95_REAL4_TYPE, F95_REAL8_TYPE,
	F95_REAl16_TYPE, F95_COMPLEX4_TYPE, F95_COMPLEX8_TYPE,
	F95_COMPLEX16_TYPE, F95_LOGICAL1_TYPE, F95_LOGICAL2_TYPE,
	F95_LOGICAL4_TYPE, F95_LOGICAL8_TYPE, F95_LOGICAL16_TYPE,
	F95_CHARACTER1_TYPE, NUM_F95_TYPES, gfc_type_nodes,
	gfc_int1_type_node, gfc_int2_type_node, gfc_int4_type_node,
	gfc_int8_type_node, gfc_int16_type_node, gfc_real4_type_node,
	gfc_real8_type_node, gfc_real16_type_node, gfc_complex4_type_node,
	gfc_complex8_type_node, gfc_complex16_type_node,
	gfc_logical1_type_node, gfc_logical2_type_node,
	gfc_logical4_type_node, gfc_logical8_type_node,
	gfc_logical16_type_node, gfc_strlen_kind): Remove.
	(gfc_character1_type_node): Turn in to a variable.
	(gfc_strlen_type_node): Likewise.

2004-08-30  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.h (gfc_namespace): Add new field is_block_data.
	* parse.c (accept_statement): Remove special handling for BLOCK DATA.
	(parse_block_data): Record BLOCK DATA name, set is_block_data field.
	* trans.c (gfc_generate_code): Handle BLOCK DATA units.
	* trans.h (gfc_generate_block_data): Add prototype.
	* trans-decl.c (gfc_generate_block_data): New function.

2004-08-29  Richard Henderson  <rth@redhat.com>

	* trans-const.c (gfc_conv_mpz_to_tree): Use mpz_export.
	* trans-types.c (gfc_init_kinds): Reject integer kinds larger
	than two HOST_WIDE_INT.

2004-08-29  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/13910
	* decl.c (free_variable, free_value, gfc_free_data, var_list,
	var_element, top_var_list, match_data_constant, top_val_list,
	gfc_match_data): Move here from match.c.
	(match_old_style_init): New function.
	(variable_decl): Match old-style initialization.
	* expr.c (gfc_get_variable_expr): New function.
	* gfortran.h (gfc_get_variable_expr): Add prototype.
	* gfortran.texi: Start documentation for supported extensions.
	* match.c: Remove the functions moved to decl.c.
	* match.h (gfc_match_data): Move prototype to under decl.c.
	* symbol.c (gfc_find_sym_tree, gfc_find_symbol): Add/correct
	comments.

2004-08-29  Steven G. Kargl  <kargls@comcast.net>
	Paul Brook  <paul@codesourcery.com>

	* check.c (gfc_check_besn, gfc_check_g77_math1): New functions.
	* f95-lang.c (DO_DEFINE_MATH_BUILTIN): Define.
	(DEFINE_MATH_BUILTIN, DEFINE_MATH_BUILTIN_C): Use it.
	(build_builtin_fntypes): New function.
	(gfc_init_builtin_functions): Use it.
	* gfortran.h (enum gfc_generic_isym_id): Add GFC_ISYM_{J,Y}{0,1,N}
	and GFC_ISYM_ERF{,C}.
	(gfc_c_int_kind): Declare.
	* intrinsic.c (add_functions): Add [d]bes* and [d]erf*.
	* intrinsic.h (gfc_check_besn, gfc_check_g77_math1, gfc_resolve_besn,
	gfc_resolve_g77_math1): Add prototypes.
	* resolve.c (gfc_resolve_besn, gfc_resolve_g77_math1): New functions.
	* mathbuiltins.def: Add comment.  Change third argument.  Use
	DEFINE_MATH_BUILTIN_C.  Add bessel and error functions.
	* trans-intrinsic.c (BUILT_IN_FUNCTION): Define.
	(DEFINE_MATH_BUILTIN, DEFINE_MATH_BUILTIN_C): Use it.
	* trans-types.c (gfc_c_int_kind): Declare.
	(gfc_init_kinds): Set it.

2004-08-29  Steven G. Kargl  <kargls@comcast.net>
	Paul Brook  <paul@codesourcery.com>

	* gfortran.h (enum gfc_generic_isym_id): Add GFC_ISYM_GET?ID.
	(gfc_check_f, gfc_simplify_f): Add f0.
	* intrinsic.c (do_check): Call f0.  Flatten.
	(add_sym_0): Fix prototype.  Set f0.
	(add_functions): Add getgid, getgid and getuid.
	(resolve_intrinsic): Remove obsolete comment.
	(do_simplify): Call f0.
	* intrinsic.h (gfc_resolve_getgid, gfc_resolve_getpid,
	gfc_resolve_getuid): Add prototypes.
	* iresolve.c (gfc_resolve_getgid, gfc_resolve_getpid,
	gfc_resolve_getuid): New functions.
	* trans-intrinsic.c (gfc_conv_intrinsic_function): Handle
	GFC_ISYM_GET?ID.

2004-08-28  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* error.c (gfc_error_init_1): Remove blank line in front of
	function body. Add missing blank.
	(gfc_buffer_error, error_char, error_string): Remove blank line in
	front of function body.
	(show_locus): Add comma in comment.
	(gfc_clear_warning, gfc_warning_check, gfc_clear_error,
	gfc_push_error, gfc_pop_error): Remove blank line in front of
	function body.
	(gfc_get_errors): Typo fix in comment in front of function. Remove
	blank line in front of function body.

2004-08-27  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.h (gfc_default_*_kind): Remove prototypes, add extern
	variable declaration of same name.
	* arith.c, check.c, decl.c, dump_parse_tree.c, expr.c,
	intrinsic.c, io.c, iresolve.c, match.c, options.c, primary.c,
	resolve.c, simplify.c, symbol.c, trans-const.c, trans-io.c:
	Replace all calls to gfc_default_*_kind with variable accesses.
	* trans-types.c: Same as above.
	(gfc_default_*_kind_1): Rename to gfc_default_*_kind, remove
	static qualifier. Replace all occurences.
	(gfc_default_*_kind): Remove functions.

2004-08-26  Richard Henderson  <rth@redhat.com>

	* arith.c: Include system.h, not real system headers.
	(MPZ_NULL, MPF_NULL, DEF_GFC_INTEGER_KIND, DEF_GFC_LOGICAL_KIND,
	DEF_GFC_REAL_KIND, GFC_SP_KIND, GFC_SP_PREC, GFC_SP_EMIN, GFC_SP_EMAX,
	GFC_DP_KIND, GFC_DP_PREC, GFC_DP_EMIN, GFC_DP_EMAX, GFC_QP_KIND,
	GFC_QP_PREC, GFC_QP_EMIN, GFC_QP_EMAX): Remove.
	(gfc_integer_kinds, gfc_logical_kinds, gfc_real_kinds,
	gfc_index_integer_kind, gfc_default_integer_kind,
	gfc_default_real_kind,gfc_default_double_kind,
	gfc_default_character_kind, gfc_default_logical_kind,
	gfc_default_complex_kind, validate_integer, validate_real,
	validate_logical, validate_character,
	gfc_validate_kind): Move to trans-types.c.
	(gfc_set_model_kind): Use gfc_validate_kind.
	(gfc_set_model): Just copy the current precision to default.
	(gfc_arith_init_1): Use mpfr precision 128 for integer setup.
	* f95-lang.c (gfc_init_decl_processing): Invoke gfc_init_kinds.
	* gfortran.h: Update file commentary.
	* trans-types.c (MAX_INT_KINDS, MAX_REAL_KINDS): New.
	(gfc_default_integer_kind_1, gfc_default_real_kind_1,
	gfc_default_double_kind_1, gfc_default_character_kind_1,
	gfc_default_logical_kind_1, gfc_default_complex_kind_1): New.
	(gfc_init_kinds): New.
	(gfc_init_types): Don't set gfc_index_integer_kind here.
	* trans-types.h (gfc_init_kinds): Declare.
	* doc/invoke.texi: Clarify DOUBLE PRECISION behaviour wrt -r8.

2004-08-26  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* check.c (gfc_check_atan2): New function.
	* intrinsic.c (add_functions): Use gfc_check_atan2 for ATAN2
	* intrinsic.h (gfc_check_atan2): Add prototype.

2004-08-25  Richard Henderson  <rth@redhat.com>

	* arith.c (gfc_validate_kind): Add may_fail argument; abort if
	false and we don't validate the kind.
	(gfc_check_integer_range, gfc_check_real_range): Update to match.
	* check.c (kind_check): Likewise.
	* decl.c (gfc_match_old_kind_spec, gfc_match_kind_spec): Likewise.
	(match_char_spec, match_logical_spec): Likewise.
	* gfortran.h (gfc_validate_kind): Likewise.
	* options.c (gfc_handle_option): Likewise.
	* primary.c (match_integer_constant, match_real_constant,
	match_string_constant, match_logical_constant,
	match_const_complex_part): Likewise.
	* simplify.c (get_kind, gfc_simplify_bit_size, gfc_simplify_digits,
	gfc_simplify_epsilon, gfc_simplify_huge, gfc_simplify_ibclr,
	gfc_simplify_ibset, gfc_simplify_ishft, gfc_simplify_ishftc,
	gfc_simplify_maxexponent, gfc_simplify_minexponent,
	gfc_simplify_nearest, gfc_simplify_not, gfc_simplify_precision,
	gfc_simplify_radix, gfc_simplify_range, gfc_simplify_rrspacing,
	gfc_simplify_scale, gfc_simplify_spacing, gfc_simplify_tan,
	gfc_simplify_tiny): Likewise.
	* trans-intrinsic.c (gfc_conv_intrinsic_aint, gfc_conv_intrinsic_mod,
	gfc_conv_intrinsic_minmaxloc, gfc_conv_intrinsic_minmaxval,
	prepare_arg_info): Likewise.

2004-08-25  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* expr.c (gfc_check_assign): Add comment. Add new warning.
	* trans-expr.c (gfc_conv_function_call): Correctly dereference
 	result of pointer valued function when not in pointer assignment.

2004-08-25  Paul Brook  <paul@codesourcery.com>

	* config-lang.in: Remove dead commented line.
	* module.c: Replace g95 with gfortran in comment.

2004-08-25  Paul Brook  <paul@codesourcery.com>

	PR fortran/17190
	* arith.c (gfc_mpfr_to_mpz): Workaround mpfr bug.

2004-08-25  Paul Brook  <paul@codesourcery.com>

	PR fortran/17144
	* trans-array.c (gfc_trans_allocate_temp_array): Remove
	string_length argument.
	(gfc_trans_array_ctor_element): New function.
	(gfc_trans_array_constructor_subarray): Use it.
	(gfc_trans_array_constructor_value): Ditto.  Handle constant
	character arrays.
	(get_array_ctor_var_strlen, get_array_ctor_strlen): New functions.
	(gfc_trans_array_constructor): Use them.
	(gfc_add_loop_ss_code): Update to new gfc_ss layout.
	(gfc_conv_ss_descriptor): Remember section string length.
	(gfc_conv_scalarized_array_ref): Ditto.  Remove dead code.
	(gfc_conv_resolve_dependencies): Update to new gfc_ss layout.
	(gfc_conv_expr_descriptor): Ditto.
	(gfc_conv_loop_setup): Ditto.  Spelling fixes.
	* trans-array.h (gfc_trans_allocate_temp_array): Update prototype.
	* trans-const.c (gfc_conv_constant):  Update to new gfc_ss layout.
	* trans-expr.c (gfc_conv_component_ref): Turn error into ICE.
	(gfc_conv_variable): Set string_length from section.
	(gfc_conv_function_call): Remove extra argument.
	(gfc_conv_expr, gfc_conv_expr_reference): Update to new gfc_ss layout.
	* trans-types.c (gfc_get_character_type_len): New function.
	(gfc_get_character_type): Use it.
	(gfc_get_dtype): Return zero for internal types.
	* trans-types.h (gfc_get_character_type_len): Add prototype.
	* trans.h (struct gfc_ss): Move string_length out of union.

2004-08-25  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans.h (build2_v, build3_v): New macros.
	(build_v): Remove.
	* f95-lang.c (gfc_truthvalue_conversion): Use build2 instead of
	build.
	* trans-array.c (gfc_conv_descriptor_data,
	gfc_conv_descriptor_offset, gfc_conv_descriptor_dimension,
	gfc_conv_descriptor_stride, gfc_conv_descriptor_lbound,
	gfc_conv_descriptor_ubound, gfc_trans_allocate_array_storage,
	gfc_trans_allocate_temp_array,
	gfc_trans_array_constructor_subarray,
	gfc_trans_array_constructor_value, gfc_conv_array_index_ref,
	gfc_trans_array_bound_check, gfc_conv_array_index_offset,
	gfc_conv_scalarized_array_ref, gfc_conv_array_ref,
	gfc_conv_array_ref, gfc_trans_preloop_setup,
	gfc_trans_scalarized_loop_end, gfc_conv_ss_startstride,
	gfc_conv_loop_setup, gfc_array_init_size,
	gfc_conv_array_initializer, gfc_trans_array_bounds,
	gfc_trans_auto_array_allocation, gfc_trans_dummy_array_bias,
	gfc_conv_expr_descriptor, gfc_conv_array_parameter,
	gfc_trans_deferred_array): Use buildN and buildN_v macros instead
	of build and build_v as appropriate.
	* trans-common.c (create_common): Same.
	* trans-decl.c (gfc_trans_auto_character_variable,
	gfc_trans_entry_master_switch, gfc_generate_function_code): Same.
	* trans-expr.c (gfc_conv_expr_present, gfc_conv_substring,
	gfc_conv_component_ref, gfc_conv_unary_op, gfc_conv_powi,
	gfc_conv_cst_int_power, gfc_conv_string_tmp, gfc_conv_concat_op,
	gfc_conv_expr_op, gfc_conv_function_call,
	gfc_trans_structure_assign): Same.
	* trans-intrinsic.c (build_fixbound_expr, build_round_expr,
	gfc_conv_intrinsic_aint, gfc_conv_intrinsic_bound,
	gfc_conv_intrinsic_cmplx, gfc_conv_intrinsic_mod,
	gfc_conv_intrinsic_dim, gfc_conv_intrinsic_sign,
	gfc_conv_intrinsic_dprod, gfc_conv_intrinsic_minmax,
	gfc_conv_intrinsic_anyall, gfc_conv_intrinsic_count,
	gfc_conv_intrinsic_arith, gfc_conv_intrinsic_minmaxloc,
	gfc_conv_intrinsic_minmaxval, gfc_conv_intrinsic_btest,
	gfc_conv_intrinsic_bitop, gfc_conv_intrinsic_singlebitop,
	gfc_conv_intrinsic_ibits, gfc_conv_intrinsic_ishft,
	gfc_conv_intrinsic_merge, gfc_conv_intrinsic_strcmp,
	gfc_conv_allocated, gfc_conv_associated, prepare_arg_info,
	gfc_conv_intrinsic_spacing, gfc_conv_intrinsic_rrspacing,
	gfc_conv_intrinsic_trim, gfc_conv_intrinsic_repeat,
	gfc_conv_intrinsic_iargc): Same.
	* trans-io.c (set_parameter_value, set_parameter_ref, set_string,
	set_flag, add_case, io_result, transfer_namelist_element,
	transfer_expr): Same.
	* trans-stmt.c (gfc_trans_goto, gfc_trans_return, gfc_trans_if_1,
	gfc_trans_arithmetic_if, gfc_trans_do, gfc_trans_do_while,
	gfc_trans_integer_select, gfc_trans_logical_select,
	gfc_trans_character_select, gfc_trans_forall_loop,
	gfc_trans_nested_forall_loop, gfc_do_allocate,
	generate_loop_for_temp_to_lhs, generate_loop_for_rhs_to_temp,
	compute_inner_temp_size, compute_overall_iter_number,
	allocate_temp_for_forall_nest, gfc_trans_pointer_assign_need_temp,
	gfc_trans_forall_1, gfc_evaluate_where_mask,
	gfc_trans_where_assign, gfc_trans_allocate): Same.
	* trans-types.c (gfc_get_dtype, gfc_get_array_type_bounds): Same.
	* trans.c (gfc_add_modify_expr, gfc_finish_block,
	gfc_build_array_ref, gfc_build_function_call,
	gfc_trans_runtime_check): Same.

2004-08-25  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-const.c (gfc_conv_mpz_to_tree): Change call to
	build_int_cst to build_int_cst_wide in accordance to Nathan's
	previous patch.

2004-08-25  Nathan Sidwell  <nathan@codesourcery.com>

	* trans-array.c (gfc_trans_array_constructor_value): Adjust
	build_int_cst calls.
	* trans-const.c (gfc_build_string_const, gfc_init_constants,
	gfc_conv_mpz_to_tree, gfc_conv_constant_to_tree): Likewise.
	* trans-decl.c (gfc_get_symbol_decl, build_entry_thunks,
	gfc_trans_entry_master_switch): Likewise.
	* trans-intrinsic.c (gfc_conv_intrinsic_ibits,
	gfc_conv_intrinsic_len, prepare_arg_info): Likewise.
	* trans-io.c (add_case, set_error_locus,
	transfer_namelist_element, transfer_expr): Likewise.
	* trans-stmt.c (gfc_trans_label_assign, gfc_trans_pause,
	gfc_trans_stop, gfc_trans_character_select): Likewise.
	* trans-types.c (gfc_init_types, gfc_get_dtype): Likewise.
	* trans.c (gfc_trans_runtime_check): Likewise.

2004-08-24  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-decl.c, trans-types.c: Add and remove blank lines as
	required.

2004-08-24  Richard Henderson  <rth@redhat.com>

	* trans-const.c (gfc_conv_mpz_to_tree): Fix 64-bit shift warning.

2004-08-24  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* resolve.c (merge_argument_lists): Revert unintentionally
	committed change.

2004-08-24  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-decl.c (build_function_decl): Fix spelling in comment.
	(build_entry_thunks): Remove code with no function.
	(gfc_build_intrinsic_function_decls): Remove empty line.

	* resolve.c (resolve_entries): Fix a bunch of comment typos.

2004-08-24  Nathan Sidwell  <nathan@codesourcery.com>

	* f95-lang.c (gfc_init_decl_processing): Adjust
	build_common_tree_nodes call.

2004-08-24  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-types.c: Spelling and formatting fixes.

2004-08-23  Richard Henderson  <rth@redhat.com>

	* trans-const.c (gfc_conv_mpz_to_tree): Use mpz_getlimbn instead
	of going through an intermediate string.  Fix 32/64 int/long bug.

2004-08-23  Eric Christopher  <echristo@redhat.com>

	* trans-types.c (gfc_type_for_mode): Remove VECTOR_TYPE_SUPPORTED_P
	usage. Use build_vector_type_for_mode for vector types.

2004-08-22  Richard Henderson  <rth@redhat.com>

	PR 13465
	* data.c (find_con_by_offset): Search ordered list; handle
	elements with repeat counts.
	(gfc_assign_data_value_range): New.
	* gfortran.h (struct gfc_data_value): Make repeat unsigned.
	(gfc_assign_data_value_range): Declare.
	* match.c (top_val_list): Extract repeat count into a temporary.
	* resolve.c (values): Make left unsigned.
	(next_data_value): Don't decrement left.
	(check_data_variable): Use gfc_assign_data_value_range.

2004-08-22  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-const.c, trans-decl.c, trans-expr.c: Spelling fixes.

2004-08-22  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* check.c (gfc_check_reduction): Rename to ...
	(check_reduction): ... this. Make static. Don't check type of
	first argument.
	(gfc_check_minval_maxval, gfc_check_prodcut_sum): New functions.
	* intrinsic.c (add_functions): Change MAXVAL, MINVAL, PRODUCT and
	SUM to use new check functions.
	(check_specific): Change logic to call new functions.
	* intrinsic.h (gfc_check_minval_maxval, gfc_check_product_sum):
	Add prototypes.
	(gfc_check_reduction): Remove prototype.

2004-08-20  Paul Brook  <paul@codesourcery.com>
	Canqun Yang  <canqun@nudt.edu.cn>

	PR fortran/17077
	* trans-array.c (gfc_conv_array_parameter): Pass correct pointer
	for automatic arrays.
	* trans-types.c (gfc_get_nodesc_array_type): Add comment.

2004-08-19  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>
	(Port from g95)

	PR fortran/17074
	* match.c (match_simple_forall, match_simple_where): Forward-declare.
	(gfc_match_if): Order statement list alphabetically, add WHERE and
	FORALL, remove double PAUSE.
	(gfc_match_simple_where, match_forall_header,
	gfc_match_simple_forall): New functions.
	(gfc_match_forall): Use match_forall_header.

2004-08-19  Paul Brook  <paul@codesourcery.com>

	PR fortran/17091
	* gfortran.h (gfc_access): Give ACCESS_UNKNOWN value 0.
	* symbol.c (gfc_clear_attr): Use memset.

2004-08-19  Paul Brook  <paul@codesourcery.com>

	PR fortran/14976
	PR fortran/16228
	* data.c (assign_substring_data_value): Remove.
	(create_character_intializer): New function.
	(gfc_assign_data_value): Track the typespec for the current
	subobject.  Use create_character_intializer.

2004-08-19  Erik Schnetter  <schnetter@aei.mpg.de>

	PR fortran/16946
	* check.c (gfc_check_reduction): New function.
	(gfc_check_minval_maxval): Removed.
	(gfc_check_product): Removed.
	(gfc_check_sum): Removed.
	* intrinsic.h: Add/remove declarations for these.
	* gfortran.h: Add field f3red to union gfc_check_f.
	* intrinsic.c (add_sym_3red): New function.
	(add_functions): Register maxval, minval, product, and sum intrinsics
	through add_sym_3red.
	(check_specific): Handle f3red union field.
	* iresolve.c: Whitespace change.

2004-08-18  Paul Brook  <paul@codesourcery.com>

	* trans-types.c (gfc_sym_type): Use pointer types for optional args.

2004-08-18  Victor Leikehman  <lei@il.ibm.com>

	PR fortran/13278
	* trans-io.c (transfer_namelist_element): New. Recursively handle
	derived-type variables.  Pass string lengths.
	(build_dt): Code moved to build_namelist, with some
	changes and additions.
	(gfc_build_io_library_fndecls): Declare the fifth
	argument in st_set_nml_var_char -- string_length.

2004-08-17  Paul Brook  <paul@codesourcery.com>
	Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/13082
	* decl.c (get_proc_name): Update mystery comment.
	(gfc_match_entry): Check for errors earlier.  Add entry point to list.
	* dump-parse-tree.c (gfc_show_code_node): Print EXEC_ENTRY nodes.
	* gfortran.h (symbol_attribute): Add entry_master.  Document entry.
	(struct gfc_entry_list): Define.
	(gfc_get_entry_list): Define.
	(struct gfc_namespace): Add refs and entries.
	(enum gfc_exec_op): Add EXEC_ENTRY.
	(struct gfc_code): Add ext.entry.
	* module.c (ab_attribute, attr_bits): Remove AB_ENTRY.
	(mio_symbol_attribute): Don't save/reture addr->entry.
	(mio_namespace_ref): Refcount namespaces.
	* parse.c (accept_statement): Handle ST_ENTRY.
	(gfc_fixup_sibling_symbols): Mark symbol as referenced.
	(parse_contained): Fixup sibling references to entry points
	after parsing the procedure body.
	* resolve.c (resolve_contained_fntype): New function.
	(merge_argument_lists, resolve_entries): New functions.
	(resolve_contained_functions): Use them.
	(resolve_code): Handle EXEC_ENTRY.
	(gfc_resolve): Call resolve_entries.
	* st.c (gfc_free_statement): Handle EXEC_ENTRY.
	* symbol.c (gfc_get_namespace): Refcount namespaces.
	(gfc_free_namespace): Ditto.
	* trans-array.c (gfc_trans_dummy_array_bias): Treat all args as
	optional when multiple entry points are present.
	* trans-decl.c (gfc_get_symbol_decl): Remove incorrect check.
	(gfc_get_extern_function_decl): Add assertion.  Fix coment.
	(create_function_arglist, trans_function_start, build_entry_thunks):
	New functions.
	(gfc_build_function_decl): Rename ...
	(build_function_decl): ... to this.
	(gfc_create_function_decl): New function.
	(gfc_generate_contained_functions): Use it.
	(gfc_trans_entry_master_switch): New function.
	(gfc_generate_function_code): Use new functions.
	* trans-stmt.c (gfc_trans_entry): New function.
	* trans-stmt.h (gfc_trans_entry): Add prototype.
	* trans-types.c (gfc_get_function_type): Add entry point argument.
	* trans.c (gfc_trans_code): Handle EXEC_ENTRY.
	(gfc_generate_module_code): Call gfc_create_function_decl.
	* trans.h (gfc_build_function_decl): Remove.
	(gfc_create_function_decl): Add prototype.

2004-08-15  Andrew Pinski  <apinski@apple.com>

	PR fortran/17030
	* f95-lang.c (gfc_init_builtin_functions): Initialize the builtins
	for cabs{,f} and copysign{,f}.
	* trans-decl.c (gfor_fndecl_math_cabsf): Delete.
	(gfor_fndecl_math_cabs): Delete.
	(gfor_fndecl_math_sign4): Delete.
	(gfor_fndecl_math_sign8): Delete.
	(gfc_build_intrinsic_function_decls): Remove the
	initializing of cabs{,f} and copysign{,f} functions.
	* trans-intrinsic.c (gfc_conv_intrinsic_abs): Use the builtins
	instead of the functions definitions.
	(gfc_conv_intrinsic_sign): Likewise.
	* trans.h (gfor_fndecl_math_cabsf): Delete.
	(gfor_fndecl_math_cabs): Delete.
	(gfor_fndecl_math_sign4): Delete.
	(gfor_fndecl_math_sign8): Delete.

2004-08-15  Nathan Sidwell  <nathan@codesourcery.com>

	* trans-array.c (gfc_trans_array_constructor_value): Use
	build_int_cst.
	* trans-const.c (gfc_build_string_const,
	gfc_init_constants, gfc_conv_mpz_to_tree,
	gfc_conv_constant_to_tree): Likewise.
	* trans-decl.c (gfc_get_symbol_decl): Likewise.
	* trans-intrinsic.c (gfc_conv_intrinsic_ibits,
	gfc_conv_intrinsic_len, prepare_arg_info): Likewise.
	* trans-io.c (add_case, set_error_locus, build_dt,
	transfer_expr): Likewise.
	* trans-stmt.c (gfc_trans_label_assign, gfc_trans_pause,
	gfc_trans_stop, gfc_trans_character_select): Likewise.
	* trans-types.c (gfc_init_types, gfc_get_dtype): Likewise.
	* trans.c (gfc_trans_runtime_check): Likewise.

2004-08-14  Paul Brook  <paul@codesourcery.com>

	* trans-decl.c (gfc_build_function_decl): Remove dead code.

2004-08-14  Paul Brook  <paul@codesourcery.com>

	* trans-arry.c (gfc_trans_auto_array_allocation): Remove unused var.

2004-08-13  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* gfortran.h: Add comments.
	* parse.c (parse_contained): Fix comment typo.
	* resolve.c (was_declared): Ditto.
	* symbol.c: Ditto.

2004-08-11  Paul Brook  <paul@codeourcery.com>

	PR fortran/16917
	* intrinsic.c (add_functions): Add dfloat as an alias for dble.

2004-08-10  Richard Henderson  <rth@redhat.com>

	* f95-lang.c (gfc_init_builtin_functions): Remove
	 __builtin_stack_alloc, add __builtin_alloca.
	* trans-array.c (gfc_trans_auto_array_allocation): Use DECL_EXPR.
	* trans-decl.c (gfc_trans_auto_character_variable): Likewise.

2004-08-10  Paul Brook  <paul@codesourcery.com>

	* trans-io.c (transfer_expr): Handle pointters.

2004-08-10  Paul Brook  <paul@codesourcery.com>

	PR fortran/16919
	* trans-array.c (gfc_add_loop_ss_code): Handle GFC_SS_COMPONENT.
	(gfc_conv_array_index_offset): Allow "temporary" with nonzero delta.
	(gfc_trans_preloop_setup, gfc_trans_scalarized_loop_boundary):
	Handle GFC_SS_COMPONENT.
	(gfc_conv_ss_startstride): Ditto.  Set ss->shape.
	(gfc_conv_loop_setup): Tweak commends. Remove dead code.
	Use ss->shape.
	(gfc_conv_array_initializer): Call specific initializer routines.
	* trans-expr.c (gfc_trans_structure_assign): New function.
	(gfc_trans_subarray_assign): New function.
	(gfc_trans_subcomponent_assign): New fucntion
	(gfc_conv_structure): Use them.
	* trans.h (gfc_ss_type): Add GFC_SS_COMPONENT.
	(gfc_ss): Add shape.

2004-08-08  Victor Leikehman  <lei@il.ibm.com>

	* simplify.c (gfc_simplify_shape): Bugfix.
	* expr.c (gfc_copy_shape_excluding): New function.
	* gfortran.h (gfc_get_shape): Bugfix.
	(gfc_copy_shape_excluding): Added declaration.
	* iresolve.c (gfc_resolve_all, gfc_resolve_any, gfc_resolve_count,
	gfc_resolve_cshift, gfc_resolve_eoshift, gfc_resolve_lbound,
	gfc_resolve_ubound, gfc_resolve_transpose): Added compile
	time resolution of shape.

2004-08-06  Janne Blomqvist  <jblomqvi@cc.hut.fi>

	* intrinsic.c (add_subroutines): Add getenv and
	get_environment_variable. (add_sym_5s): New function.
	* intrinsic.h (gfc_resolve_get_environment_variable): Add
	prototype.
	* iresolve.c (gfc_resolve_get_environment_variable): New
	function.

2004-08-06  Feng Wang  <fengwang@nudt.edu.cn>

	* f95-lang.c (gfc_init_builtin_functions): Fix the number of
	__builtin_pow[f] arguments.

2004-08-06  Steven G. Kargl  <kargls@comcast.net>

	* arith.c: Add #define for model numbers.  Remove global GMP variables.
	(natural_logarithm,common_logarithm,exponential,sine,
	cosine,arctangent,hypercos,hypersine ): Remove.
	(gfc_mpfr_to_mpz,gfc_set_model_kind,gfc_set_model): New functions.
	(arctangent2,gfc_arith_init_1,gfc_arith_done_1
	gfc_check_real_range, gfc_constant_result, gfc_range_check,
	gfc_arith_uminus,gfc_arith_plus, gfc_arith_minus, gfc_arith_times,
	gfc_arith_divide,complex_reciprocal,complex_pow_ui,
	gfc_arith_power,gfc_compare_expr,compare_complex,gfc_convert_real,
	gfc_convert_complex,gfc_int2real,gfc_int2complex,
	gfc_real2int,gfc_real2real,gfc_real2complex,
	gfc_complex2int,gfc_complex2real,gfc_complex2complex): Convert GMP
	to MPFR, use new functions.
	* arith.h: Remove extern global variables.
	(natural_logarithm,common_logarithm,exponential, sine, cosine,
	arctangent,hypercos,hypersine): Remove prototypes.
	(arctangent2): Update prototype from GMP to MPFR.
	(gfc_mpfr_to_mpz, gfc_set_model_kind,gfc_set_model): Add prototypes.
	* dump-parse-tree.c (gfc_show_expr): Convert GMP to MPFR.
	* expr.c (free_expr0,gfc_copy_expr): Convert GMP to MPFR.
	* gfortran.h (GFC_REAL_BITS): Remove.
	(arith): Add ARITH_NAN.
	Include mpfr.h.  Define GFC_RND_MODE.
	Rename GCC_GFORTRAN_H GFC_GFC_H.
	(gfc_expr): Convert GMP to MPFR.
	* module.c: Add arith.h, correct type in comment.
	(mio_gmp_real): Convert GMP to MPFR.
	(mio_expr):  Use gfc_set_model_kind().
	* primary.c:  Update copyright date with 2004.
	(match_real_constant,match_const_complex_part): Convert GMP to MPFR.
	* simplify.c: Remove global GMP variables
	(gfc_simplify_abs,gfc_simplify_acos,gfc_simplify_aimag,
	gfc_simplify_aint,gfc_simplify_dint,gfc_simplify_anint,
	gfc_simplify_dnint,gfc_simplify_asin,gfc_simplify_atan,
	gfc_simplify_atan2,gfc_simplify_ceiling,simplify_cmplx,
	gfc_simplify_conjg,gfc_simplify_cos,gfc_simplify_cosh,
	gfc_simplify_dim,gfc_simplify_dprod,gfc_simplify_epsilon,
	gfc_simplify_exp,gfc_simplify_exponent,gfc_simplify_floor,
	gfc_simplify_fraction,gfc_simplify_huge,gfc_simplify_int,
	gfc_simplify_ifix,gfc_simplify_idint,gfc_simplify_log,
	gfc_simplify_log10,simplify_min_max,gfc_simplify_mod,
	gfc_simplify_modulo,gfc_simplify_nearest,simplify_nint,
	gfc_simplify_rrspacing,gfc_simplify_scale,
	gfc_simplify_set_exponent,gfc_simplify_sign,gfc_simplify_sin,
	gfc_simplify_sinh,gfc_simplify_spacing,gfc_simplify_sqrt,
	gfc_simplify_tan,gfc_simplify_tanh,gfc_simplify_tiny,
	gfc_simplify_init_1,gfc_simplify_done_1):  Convert GMP to MPFR.
	Use new functions.
	* trans-const.c (gfc_conv_mpfr_to_tree): Rename from
	gfc_conv_mpf_to_tree.  Convert it to use MPFR
	(gfc_conv_constant_to_tree): Use it.
	* trans-const.h: Update prototype for gfc_conv_mpfr_to_tree().
	* trans-intrinsic.c: Add arith.h, remove gmp.h
	(gfc_conv_intrinsic_aint,gfc_conv_intrinsic_mod): Convert GMP to MPFR.

2004-08-06  Victor Leikehman  <lei@il.ibm.com>
	Paul Brook  <paul@codesourcery.com>

	* trans-array.c (gfc_trans_allocate_array_storage,
	gfc_trans_allocate_temp_array, gfc_add_loop_ss_code,
	gfc_conv_loop_setup): For functions, if the shape of the result
	is not known in compile-time, generate an empty array descriptor for
	the result and let the callee to allocate the memory.
	(gfc_trans_dummy_array_bias): Do nothing for pointers.
	(gfc_conv_expr_descriptor): Use function return values directly.
	* trans-expr.c (gfc_conv_function_call): Always add byref call
	insn to pre chain.
	(gfc_trans_pointer_assignment): Add comments.
	(gfc_trans_arrayfunc_assign): Don't chain on expression.

2004-08-01  Roger Sayle  <roger@eyesopen.com>

	* options.c (gfc_init_options): Don't warn about the use GNU
	extensions by default.
	(gfc_post_options): Warn about GNU extensions with -pedantic.
	(gfc_handle_option): Don't warn about GNU extensions with -std=gnu.

2004-07-30  Richard Henderson  <rth@redhat.com>

	* trans-expr.c (gfc_conv_expr_reference): Create a CONST_DECL
	for TREE_CONSTANTs.

2004-07-25  Richard Henderson  <rth@redhat.com>

	* trans-decl.c (gfc_build_function_decl): Set DECL_ARTIFICIAL
	and DECL_IGNORED_P on RESULT_DECL.
	(gfc_generate_constructors): Likewise.

2004-07-18  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/16465
	* lang.opt (ffixed-line-length-none, ffixed-line-length-): New
	options.
	(ffixed-line-length-80, ffixed-line-length-132): Remove.
	* options.c (gfc_handle_options): Deal with changed options.
	* scanner.c (load_line): Change second arg to 'char **',
	allocate if pointing to NULL. Keep track of buffer's length.
	Adapt buffer size to overlong lines. Pad lines to full length
	in fixed form.
	(load_file): Adapt to new interface of load_line.

2004-07-17  Joseph S. Myers  <jsm@polyomino.org.uk>

	* trans.h (builtin_function): Declare.

2004-07-16  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/16404
	(parts ported from g95)
	* parse.h (gfc_state_data): New field do_variable.
	(gfc_check_do_variable): Add prototype.
	* parse.c (push_state): Initialize field 'do_variable'.
	(gfc_check_do_variable): New function.
	(parse_do_block): Remember do iterator variable.
	(parse_file): Initialize field 'do_variable'.
	* match.c (gfc_match_assignment, gfc_match_do,
	gfc_match_allocate, gfc_match_nullify, gfc_match_deallocate):
	Add previously missing checks.
	(gfc_match_return): Reformat error message.
	* io.c (match_out_tag): New function.
	(match_open_element, match_close_element,
	match_file_element, match_dt_element): Call match_out_tag
	instead of match_vtag where appropriate.
	(match_io_iterator, match_io_element): Add missing check.
	(match_io): Reformat error message.
	(match_inquire_element): Call match_out_tag where appropriate.

	* parse.c (gfc_check_do_variable): Fix error locus.

2004-07-15  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/15129
	* trans-decl.c (gfc_build_function_decl): Create a new chardecl
	for every assumed length character dummy argument.

	PR fortran/15140
	* trans-decl.c (gfc_trans_deferred_vars): Remove bogus assertion.

	PR fortran/13792
	* simplify.c (gfc_simplify_bound): Copy the bound expression.

2004-07-15  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

 	PR fortran/15324
	* trans-array.c gfc_trans_g77_array,
	gfc_trans_dummy_array_bias): Don't call gfc_trans_string_init
	for assumed length characters.
	(gfc_conv_expr_descriptor): Set se->string_length if dealing
	with a character expression.
	(gfc_cvonv_array_parameter): Pass string length when passing
	character array according to g77 conventions.

2004-07-12  Paul Brook  <paul@codesourcery.com>

	* expr.c (gfc_check_assign_symbol): Handle pointer assignments.
	* trans-array.c (gfc_trans_auto_array_allocation): Remove
	initialization code.
	* trans-common.c (create_common): Use gfc_conv_initializer.
	* trans-decl.c (gfc_get_symbol_decl): Use gfc_conv_initializer.
	* trans-expr.c (gfc_conv_initializer): New function.
	(gfc_conv_structure): Use it.
	* trans.h (gfc_conv_initializer): Add prototype.

2004-07-11  Paul Brook  <paul@codesourcery.com>

	PR fortran/15986
	* parse.c (gfc_fixup_sibling_symbols): Also look for untyped
	variables.
	(parse_contained): Mark contained symbols as referenced.

2004-07-11  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/16455
	* module.c (gfc_dump_module, gfc_use_module): Print locus
	when opening of module file fails.

	PR fortran/16404
	* io.c (match_io): Flag 'WRITE(...), ...' as extension.

	PR fortran/16404
	* match.c (gfc_match_program): A program name is obligatory.
	(gfc_match_return): RETURN in main program is an extension.
	(gfc_match_block_data): A space is required before a block data
	name.

	PR fortran/16433
	* primary.c (match_boz_constant): Call gfc_notify_std only if
	we actually have a non-standard boz-literal-constant.

	PR fortran/15754
	* expr.c (gfc_check_assign): Print ranks if incompatible. Issue
	warning if assigning NULL().

2004-07-11  Joseph S. Myers  <jsm@polyomino.org.uk>

	* f95-lang.c (set_block): Remove.
	(gfc_clear_binding_stack): New.
	(LANG_HOOKS_CLEAR_BINDING_STACK): Define.
	(struct binding_level): Remove block_created_by_back_end.
	(clear_binding_level): Likewise.
	(poplevel): Don't handle block_created_by_back_end.

2004-07-10  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-decl.c (gfc_create_module_variable): Nothing to do if
	symbol is in common, because we ...
	(gfc_generate_module_vars): Call gfc_trans_common.

2004-07-10  Paul Brook  <paul@codesourcery.com>

	* trans-array.c (gfc_build_null_descriptor): New function.
	(gfc_trans_static_array_pointer): Use it.
	* trans-array.h (gfc_build_null_descriptor): Add prototype.
	* trans-expr.c (gfc_conv_structure): Handle array pointers.

2004-07-10  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/16336
	* decl.c (gfc_match_save): Use-associated common block
	doesn't collide.
	* gfortran.h (gfc_common_head): Add new field 'name'.
	Fix typo in comment after #endif.
	* match.c (gfc_get_common): Add new argument from_common,
	mangle name if flag is set, fill in new field in structure
	gfc_common_head.
	(match_common): Set new arg in call to gfc_get_common,
	use-associated common block doesn't collide.
	* match.h (gfc_get_common): Adapt prototype.
	* module.c (load_commons): Set new arg in call to
	gfc_get_common.
	* symbol.c (free_common_tree): New function.
	(gfc_free_namespace): Call new function.
	* trans-common.c (several functions): Remove argument
	'name', use name from gfc_common_head instead.

2004-07-10  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* expr.c (gfc_check_pointer_assign): Verify that rank of the LHS
	and RHS match. Return early if the RHS is NULL().

	PR fortran/16336
	* match.c (match_common): Fix error reporting for used common.

	PR fortran/15969
	* trans-expr.c (gfc_conv_structure): Handle initialization
	of scalar pointer components.

	* parse.c (decode_statement): Fix matching of BLOCK DATA.

	* trans-decl.c (generate_local_decl): Remove workaround obsoleted
	by fix for PR 15481.

2004-07-10  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	* trans-common.c: Fix whitespace issues, make variable names
	more readable.
	(create_common): Additionally, make loop logic more obvious.

2004-07-10  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>
	Paul Brook  <paul@codesourcery.com>

	PR fortran/13415
	* trans-common.c (calculate_length): Remove ...
	(get_segment_info): Merge into here.  Save field type.
	(build_field): Use saved type.
	(create_common, new_condition, new_segment, finish_equivalences):
	Use new get_segment_info.
	* trans-types.c: Update comment.

2004-07-09  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/14077
	* moduele.c (mio_symbol): Don't I/O initial values unless
	symbol is a parameter.

2004-07-09  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/13201
	* resolve.c (resolve_symbol): Verify that the shape of a
	parameter array is not only explicit, but also constant.
	* array.c (gfc_is_compile_time_shape): New function.
	* gfortran.h (gfc_is_compile_time_shape): Add prototype.

2004-07-09  Tobias Schlueter  <tobias.schlueter@physik.uni-muenchen.de>

	PR fortran/15481
	PR fortran/13372
	PR fortran/13575
	PR fortran/15978
	* module.c (write_symbol, write_symtree): Remove workaround.
	* primary.c (match_actual_arglist): Enhance comment.
	(gfc_match_rvalue): Handle function call with first argument
	a keyword argument correctly.
	* resolve.c (resolve_symbol): Change call to
	gfc_set_default_type to issue error if no implicit type
	can be found.
	* trans-decl.c (gfc_create_module_variable): Remove workaround.

2004-07-08  Paul Brook  <paul@codesourcery.com>

	* intrinsic.c (add_sym_4s): New function.
